(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    602380,      14986]
NotebookOptionsPosition[    599210,      14895]
NotebookOutlinePosition[    602369,      14985]
CellTagsIndexPosition[    602326,      14982]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Copyright", " ", "\[Copyright]", " ", "Taylor"}], " ", "&"}], 
      " ", "Francis", " ", "Group"}], ",", " ", 
     RowBox[{
     "2014.", "\[IndentingNewLine]", "\[IndentingNewLine]", "Permission", " ",
       "is", " ", "hereby", " ", "granted"}], ",", " ", 
     RowBox[{"free", " ", "of", " ", "charge"}], ",", " ", 
     RowBox[{
     "to", " ", "any", " ", "person", " ", "obtaining", " ", "a", " ", "copy",
       " ", "of", " ", "this", " ", "software", " ", "and", " ", "associated",
       " ", "documentation", " ", "files", " ", 
      RowBox[{"(", 
       RowBox[{"the", " ", "\"\<Software\>\""}], ")"}]}], ",", " ", 
     RowBox[{
     "to", " ", "deal", " ", "in", " ", "the", " ", "Software", " ", 
      "without", " ", "restriction"}], ",", " ", 
     RowBox[{
     "including", " ", "without", " ", "limitation", " ", "the", " ", 
      "rights", " ", "to", " ", "use"}], ",", " ", "copy", ",", " ", "modify",
      ",", " ", "merge", ",", " ", "publish", ",", " ", "distribute", ",", 
     " ", "sublicense", ",", " ", 
     RowBox[{
      RowBox[{"and", "/", "or"}], " ", "sell", " ", "copies", " ", "of", " ", 
      "the", " ", "Software"}], ",", " ", 
     RowBox[{
     "and", " ", "to", " ", "permit", " ", "persons", " ", "to", " ", "whom", 
      " ", "the", " ", "Software", " ", "is", " ", "furnished", " ", "to", 
      " ", "do", " ", "so"}], ",", " ", 
     RowBox[{"subject", " ", "to", " ", "the", " ", "following", " ", 
      RowBox[{"conditions", ":", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
       "The", " ", "above", " ", "copyright", " ", "notice", " ", "and", " ", 
        "this", " ", "permission", " ", "notice", " ", "shall", " ", "be", 
        " ", "included", " ", "in", " ", "all", " ", "copies", " ", "or", " ",
         "substantial", " ", "portions", " ", "of", " ", "the", " ", 
        RowBox[{
        "software", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "THE"}], " ", "SOFTWARE", " ", "IS", " ", "PROVIDED", " ", 
        "\"\<AS IS\>\"", " ", "WITHOUT", " ", "WARRANTY", " ", "OF", " ", 
        "ANY", " ", "KIND"}]}]}], ",", " ", 
     RowBox[{"EXPRESS", " ", "OR", " ", "IMPLIED"}], ",", " ", 
     RowBox[{
     "INCLUDING", " ", "BUT", " ", "NOT", " ", "LIMITED", " ", "TO", " ", 
      "THE", " ", "WARRANTIES", " ", "OF", " ", "MERCHANTABILITY"}], ",", " ", 
     RowBox[{
     "FITNESS", " ", "FOR", " ", "A", " ", "PARTICULAR", " ", "PURPOSE", " ", 
      "AND", " ", 
      RowBox[{"NONINFRINGEMENT", ".", " ", "IN"}], " ", "NO", " ", "EVENT", 
      " ", "SHALL", " ", "THE", " ", "AUTHORS", " ", "OR", " ", "COPYRIGHT", 
      " ", "HOLDERS", " ", "BE", " ", "LIABLE", " ", "FOR", " ", "ANY", " ", 
      "CLAIM"}], ",", " ", "DAMAGES", ",", " ", 
     RowBox[{"OR", " ", "OTHER", " ", "LIABILITY"}], ",", " ", 
     RowBox[{
     "WHETHER", " ", "IN", " ", "AN", " ", "ACTION", " ", "OR", " ", 
      "CONTRACT"}], ",", " ", 
     RowBox[{"TORT", " ", "OR", " ", "OTHERWISE"}], ",", " ", 
     RowBox[{"ARISING", " ", "FROM"}], ",", " ", 
     RowBox[{
     "OUT", " ", "OF", " ", "OR", " ", "IN", " ", "CONNECTION", " ", "WITH", 
      " ", "THE", " ", "SOFTWARE", " ", "OR", " ", "THE", " ", "USE", " ", 
      "OR", " ", "OTHER", " ", "DEALINGS", " ", "IN", " ", "THE", " ", 
      RowBox[{"SOFTWARE", "."}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "*)"}],
   FontColor->GrayLevel[0.5]], 
  StyleBox["\[IndentingNewLine]",
   FontColor->GrayLevel[0.5]], 
  StyleBox["\[IndentingNewLine]",
   FontColor->GrayLevel[0.5]], 
  StyleBox["\[IndentingNewLine]",
   FontColor->GrayLevel[0.5]], 
  StyleBox[
   RowBox[{"(*", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "This", " ", "version", " ", "of", " ", "the", " ", "unum", " ", 
      "prototype", " ", "environment", " ", "updated", " ", "September", " ", 
      "26"}], ",", " ", 
     RowBox[{
      RowBox[{
      "2014.", "\[IndentingNewLine]", "It", " ", "has", " ", "been", " ", 
       "tested", " ", "extensively", " ", "with", " ", "Mathematica", " ", 
       "9"}], ";", " ", 
      RowBox[{
      "no", " ", "problems", " ", "have", " ", "been", " ", "found", " ", 
       "so", " ", "far", " ", "when", " ", "run", " ", "with", " ", 
       "Mathematica", " ", "10.", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "Updated", " ", "again", " ", "June", " ", 
       "15"}]}], ",", " ", 
     RowBox[{
     "2015", " ", "to", " ", "correct", " ", "a", " ", "subscript", " ", 
      "error", " ", "in", " ", "the", " ", "bisect", " ", 
      RowBox[{"function", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Author", ":", " ", 
        RowBox[{"John", " ", 
         RowBox[{"L", ".", " ", "Gustafson"}]}]}]}]}]}], 
    "\[IndentingNewLine]", "*)"}],
   FontColor->GrayLevel[0.5]], 
  StyleBox["\[IndentingNewLine]",
   FontColor->GrayLevel[0.5]], 
  StyleBox["\[IndentingNewLine]",
   FontColor->GrayLevel[0.5]], 
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Set", " ", "the", " ", "environment", " ", "variables", " ", "based", 
      " ", "on", " ", "the", " ", "esizesize", " ", "and", " ", 
      RowBox[{"fsizesize", ".", " ", "In"}], " ", "this", " ", "prototype"}], 
     ",", " ", 
     RowBox[{
     "the", " ", "maximum", " ", "esizesize", " ", "is", " ", "4", " ", "and",
       " ", "the", " ", "maximum", " ", "fsizesize", " ", "is", " ", 
      "11."}]}], " ", "*)"}],
   FontColor->GrayLevel[0.5]], 
  StyleBox["\[IndentingNewLine]",
   FontColor->GrayLevel[0.5]], 
  RowBox[{
   RowBox[{
    RowBox[{"setenv", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"e_Integer", "/;", 
        RowBox[{"0", "\[LessEqual]", "e", "\[LessEqual]", "4"}]}], ",", 
       RowBox[{"f_Integer", "/;", 
        RowBox[{"0", "\[LessEqual]", "f", "\[LessEqual]", "11"}]}]}], "}"}], 
     "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"esizesize", ",", "fsizesize"}], "}"}], "=", 
       RowBox[{"{", 
        RowBox[{"e", ",", "f"}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"esizemax", ",", "fsizemax"}], "}"}], "=", 
       SuperscriptBox["2", 
        RowBox[{"{", 
         RowBox[{"e", ",", "f"}], "}"}]]}], ";", "\[IndentingNewLine]", 
      RowBox[{"utagsize", "=", 
       RowBox[{"1", "+", "f", "+", "e"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"maxubits", "=", 
       RowBox[{"1", "+", "esizemax", "+", "fsizemax", "+", "utagsize"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"ubitmask", "=", 
       RowBox[{"BitShiftLeft", "[", 
        RowBox[{"1", ",", 
         RowBox[{"utagsize", "-", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fsizemask", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"BitShiftLeft", "[", 
          RowBox[{"1", ",", "f"}], "]"}], "-", "1"}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"esizemask", 
       StyleBox["=", "Input"], 
       RowBox[{
        RowBox[{
         StyleBox["(", "Input"], " ", 
         RowBox[{"ubitmask", "-", "1"}], ")"}], "-", "fsizemask"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"efsizemask", "=", 
       RowBox[{"BitOr", "[", 
        RowBox[{"esizemask", ",", "fsizemask"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"utagmask", "=", 
       RowBox[{"BitOr", "[", " ", 
        RowBox[{"ubitmask", ",", "efsizemask"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ulpu", "=", 
       RowBox[{"BitShiftLeft", "[", 
        RowBox[{"1", ",", "utagsize"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"smallsubnormalu", "=", 
       RowBox[{"efsizemask", "+", "ulpu"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"smallnormalu", "=", 
       RowBox[{"efsizemask", "+", 
        RowBox[{"BitShiftLeft", "[", 
         RowBox[{"1", ",", 
          RowBox[{"maxubits", "-", "1", "-", "esizemax"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"signbigu", "=", 
       RowBox[{"BitShiftLeft", "[", 
        RowBox[{"1", ",", 
         RowBox[{"maxubits", "-", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"posinfu", "=", 
       RowBox[{"signbigu", "-", "1", "-", " ", "ubitmask"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"maxrealu", "=", 
       RowBox[{"posinfu", "-", "ulpu"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"minrealu", "=", 
       RowBox[{"maxrealu", "+", "signbigu"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"neginfu", "=", 
       RowBox[{"posinfu", "+", "signbigu"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"negbigu", "=", 
       RowBox[{"neginfu", "-", "ulpu"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"qNaNu", "=", 
       RowBox[{"posinfu", "+", " ", "ubitmask"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sNaNu", "=", 
       RowBox[{"neginfu", "+", " ", "ubitmask"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"negopeninfu", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"utagsize", "\[Equal]", "1"}], ",", "2^^1101", ",", 
         RowBox[{"BitShiftLeft", "[", 
          RowBox[{"2^^1111", ",", 
           RowBox[{"utagsize", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"posopeninfu", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"utagsize", "\[Equal]", "1"}], ",", "2^^0101", ",", 
         RowBox[{"BitShiftLeft", "[", 
          RowBox[{"2^^0111", ",", 
           RowBox[{"utagsize", "-", "1"}]}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"negopenzerou", "=", 
       RowBox[{"BitShiftLeft", "[", 
        RowBox[{"2^^1001", ",", 
         RowBox[{"utagsize", "-", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"maxreal", "=", 
       RowBox[{
        SuperscriptBox["2", 
         SuperscriptBox["2", 
          RowBox[{"esizemax", "-", "1"}]]], 
        FractionBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["2", "fsizemax"], "-", "1"}], ")"}], 
         SuperscriptBox["2", 
          RowBox[{"fsizemax", "-", "1"}]]]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"smallsubnormal", "=", 
       SuperscriptBox["2", 
        RowBox[{"2", "-", 
         SuperscriptBox["2", 
          RowBox[{"esizemax", "-", "1"}]], "-", "fsizemax"}]]}], ";"}], 
     ")"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Make", " ", "sure", " ", "values", " ", "are", " ", "initialized", " ",
        "to", " ", 
       StyleBox["something",
        FontSlant->"Italic"]}], ",", " ", 
      RowBox[{"to", " ", 
       RowBox[{"start", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"setenv", "[", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], "]"}], ";"}], " ", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Local", " ", "palette", " ", 
      RowBox[{"definitions", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gogreen", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", ".75", ",", ".625"}], "}"}], "]"}],
      FontColor->RGBColor[0., 0.7529411764705882, 0.6274509803921569]]}], 
    StyleBox[";",
     FontColor->GrayLevel[0]]}], 
   StyleBox[" ",
    FontColor->GrayLevel[0]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Traffic", " ", "light", " ", "color"}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cautionamber", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{".96", ",", ".72", ",", "0"}], "}"}], "]"}],
      FontColor->RGBColor[0.9607843137254902, 0.7254901960784313, 0.]]}], 
    ";"}], 
   StyleBox[
    RowBox[{" ", 
     StyleBox[" ",
      FontColor->GrayLevel[0.5]]}]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Traffic", " ", "light", " ", "color"}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"stopred", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", ".125", ",", "0"}], "}"}], "]"}],
      FontColor->RGBColor[1., 0.12549019607843137`, 0.]]}], ";"}], 
   StyleBox[" ",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Traffic", " ", "light", " ", "color"}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"brightblue", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{".25", ",", ".5", ",", "1"}], "}"}], "]"}],
      FontColor->RGBColor[0.25098039215686274`, 0.5019607843137255, 1.]]}], 
    ";"}], 
   StyleBox[" ",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Better", " ", "contrast", " ", "with", " ", "black"}], " ", 
     "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sanegreen", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{"0", ",", ".75", ",", "0"}], "}"}], "]"}],
      FontColor->RGBColor[0., 0.7529411764705882, 0.]]}], ";"}], " ", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Better", " ", "contrast", " ", "with", " ", "white"}], " ", 
     "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"paleblue", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{".9", ",", ".9", ",", "1"}], "}"}], "]"}],
      FontColor->RGBColor[0.7843137254901961, 1., 1.]]}], ";"}], 
   StyleBox[" ",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Background", " ", "color", " ", "for", " ", "g"}], "-", 
      RowBox[{"bound", " ", "tables"}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"brightpurple", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{".75", ",", ".5", ",", "1"}], "}"}], "]"}],
      FontColor->RGBColor[0.7529411764705882, 0.5019607843137255, 1.]]}], 
    StyleBox[";",
     FontColor->RGBColor[0.7529411764705882, 0.5019607843137255, 1.]]}], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Used", " ", "in", " ", "\"\<wrapping problem\>\""}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"brightmagenta", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        StyleBox[
         RowBox[{"1", ",", ".25", ",", "1"}],
         FontColor->RGBColor[1., 0.25098039215686274`, 1.]], "}"}], "]"}],
      FontColor->RGBColor[1., 0.25098039215686274`, 1.]]}], ";"}], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Prints", " ", "better", " ", "than", " ", "magenta"}], " ", 
     "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{
     StyleBox["textamber",
      FontColor->GrayLevel[0]], 
     StyleBox["=",
      FontColor->GrayLevel[0]], 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{".75", ",", ".5", ",", "0"}], "}"}], "]"}],
      FontColor->RGBColor[0.7529411764705882, 0.5019607843137255, 0.]]}], 
    ";"}], " ", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Better", " ", "contrast", " ", "with", " ", "white"}], " ", 
     "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"chartreuse", "=", 
     StyleBox[
      RowBox[{"RGBColor", "[", 
       RowBox[{"{", 
        RowBox[{".875", ",", "1", ",", ".5"}], "}"}], "]"}],
      FontColor->RGBColor[0.8784313725490196, 1., 0.5019607843137255]]}], 
    ";"}], " ", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Background", " ", "for", " ", "general", " ", "interval", " ", 
      "table"}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "View", " ", "the", " ", "three", " ", "fields", " ", "of", " ", "a", 
       " ", "utag", " ", "as", " ", "a", " ", "color"}], "-", 
      RowBox[{"coded", " ", "binary", " ", 
       RowBox[{"string", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"utagview", "[", "u_Integer", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"e", "=", 
         RowBox[{"BitShiftRight", "[", 
          RowBox[{
           RowBox[{"BitAnd", "[", 
            RowBox[{"u", ",", "esizemask"}], "]"}], ",", "fsizesize"}], 
          "]"}]}], ",", 
        RowBox[{"f", "=", 
         RowBox[{"BitAnd", "[", 
          RowBox[{"u", ",", "fsizemask"}], "]"}]}], ",", 
        RowBox[{"i", "=", 
         RowBox[{"BitShiftRight", "[", 
          RowBox[{"u", ",", 
           RowBox[{"utagsize", "-", "1"}]}], "]"}]}]}], "}"}], ",", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"i", ",", "Magenta", ",", "\"\<Input\>\""}], "]"}], ",", 
            
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"IntegerString", "[", 
               RowBox[{"e", ",", "2", ",", "esizesize"}], "]"}], ",", 
              "sanegreen", ",", "\"\<Input\>\""}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"IntegerString", "[", 
               RowBox[{"f", ",", "2", ",", "fsizesize"}], "]"}], ",", 
              RowBox[{"FontColor", "\[Rule]", "Gray"}], ",", 
              "\"\<Input\>\""}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", "1"}], ",", 
              "\"\<\[NegativeThinSpace]\[CenterEllipsis]\>\"", ",", 
              "\"\<\[DownArrow]\>\""}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"e", "+", "1"}], ",", "\"\<Text\>\""}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"f", "+", "1"}], ",", "\"\<Text\>\""}], "]"}]}], 
           "}"}]}], "}"}], ",", 
        RowBox[{"Frame", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"None", ",", "None", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "True"}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "True"}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "True"}]}], "}"}]}],
           "}"}]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "a", " ", "value", " ", "is", " ", "a", " ", 
      "legitimate", " ", 
      RowBox[{"unum", ".", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Must", " ", "be", " ", "integer"}], ",", " ", 
         RowBox[{
          RowBox[{"and", " ", "in"}], "-", 
          RowBox[{"range", "."}]}]}], ")"}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"unumQ", "[", "x_", "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"IntegerQ", "[", "x", "]"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "\[GreaterEqual]", "0"}], "\[And]", 
         RowBox[{"x", "\[LessEqual]", "sNaNu"}]}], ",", "True", ",", 
        "False"}], "]"}], ",", "False"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Values", " ", "and", " ", "bit", " ", "masks", " ", "for", " ", 
      "taking", " ", "apart", " ", "a", " ", "unum", " ", "bit", " ", 
      RowBox[{"string", ".", " ", "Independent"}], " ", "of", " ", "the", " ",
       "contents", " ", "of", " ", "the", " ", 
      RowBox[{"utag", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"fsizeminus1", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitAnd", "[", 
     RowBox[{"u", ",", "fsizemask"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fsize", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"1", "+", 
     RowBox[{"fsizeminus1", "[", "u", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"esizeminus1", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitShiftRight", "[", 
     RowBox[{
      RowBox[{"BitAnd", "[", 
       RowBox[{"u", ",", "esizemask"}], "]"}], ",", "fsizesize"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"esize", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"1", "+", 
     RowBox[{"esizeminus1", "[", "u", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"utag", "[", 
     RowBox[{
      RowBox[{"esize_Integer", "/;", 
       RowBox[{"1", "\[LessEqual]", "esize", "\[LessEqual]", "esizemax"}]}], 
      ",", 
      RowBox[{"fsize_Integer", "/;", 
       RowBox[{"1", "\[LessEqual]", "fsize", "\[LessEqual]", "fsizemax"}]}]}],
      "]"}], ":=", 
    RowBox[{"BitOr", "[", 
     RowBox[{
      RowBox[{"fsize", "-", "1"}], ",", 
      RowBox[{"BitShiftLeft", "[", 
       RowBox[{
        RowBox[{"esize", "-", "1"}], ",", "fsizesize"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"numbits", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"1", "+", 
     RowBox[{"esize", "[", "u", "]"}], "+", 
     RowBox[{"fsize", "[", "u", "]"}], "+", "utagsize"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"signmask", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitShiftLeft", "[", 
     RowBox[{"1", ",", 
      RowBox[{
       RowBox[{"numbits", "[", "u", "]"}], "-", "1"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hiddenmask", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitShiftLeft", "[", 
     RowBox[{"1", ",", 
      RowBox[{
       RowBox[{"fsize", "[", "u", "]"}], "+", "utagsize"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fracmask", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", "\[IndentingNewLine]", 
    
    RowBox[{"BitShiftLeft", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"BitShiftLeft", "[", 
        RowBox[{"1", ",", 
         RowBox[{"fsize", "[", "u", "]"}]}], "]"}], "-", "1"}], ",", 
      "utagsize"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expomask", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitShiftLeft", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"BitShiftLeft", "[", 
        RowBox[{"1", ",", 
         RowBox[{"esize", "[", "u", "]"}]}], "]"}], "-", "1"}], ",", 
      RowBox[{
       RowBox[{"fsize", "[", "u", "]"}], "+", "utagsize"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"floatmask", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"signmask", "[", "u", "]"}], "+", 
     RowBox[{"expomask", "[", "u", "]"}], "+", 
     RowBox[{"fracmask", "[", "u", "]"}]}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Values", " ", "and", " ", "bit", " ", "masks", " ", "that", " ", 
      "depend", " ", "on", " ", "what", " ", "is", " ", "stored", " ", "in", 
      " ", "the", " ", 
      RowBox[{"utag", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"bias", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     SuperscriptBox["2", 
      RowBox[{"esizeminus1", "[", "u", "]"}]], "-", "1"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sign", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Boole", "[", 
     RowBox[{
      RowBox[{"BitAnd", "[", 
       RowBox[{"u", ",", 
        RowBox[{"signmask", "[", "u", "]"}]}], "]"}], ">", "0"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expo", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitShiftRight", "[", 
     RowBox[{
      RowBox[{"BitAnd", "[", 
       RowBox[{"u", ",", 
        RowBox[{"expomask", "[", "u", "]"}]}], "]"}], ",", 
      RowBox[{"utagsize", "+", 
       RowBox[{"fsize", "[", "u", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hidden", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Boole", "[", 
     RowBox[{
      RowBox[{"expo", "[", "u", "]"}], ">", "0"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"frac", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"BitShiftRight", "[", 
     RowBox[{
      RowBox[{"BitAnd", "[", 
       RowBox[{"u", ",", 
        RowBox[{"fracmask", "[", "u", "]"}]}], "]"}], ",", "utagsize"}], 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"inexQ", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"BitAnd", "[", " ", 
      RowBox[{"ubitmask", ",", "u"}], "]"}], ">", "0"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"exQ", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"BitAnd", "[", 
      RowBox[{"ubitmask", ",", "u"}], "]"}], "\[Equal]", "0"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"exact", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"inexQ", "[", "u", "]"}], ",", 
      RowBox[{"BitXor", "[", 
       RowBox[{"u", ",", " ", "ubitmask"}], "]"}], ",", "u"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Display", " ", "the", " ", "six", " ", "fields", " ", "of", " ", "a", 
       " ", "unum", " ", "bit", " ", "string"}], ",", " ", 
      RowBox[{"color", "-", 
       RowBox[{"coded", " ", "and", " ", 
        RowBox[{"spaced", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"colorcode", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Row", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"sign", "[", "u", "]"}], ",", "Red", ",", "Bold"}], "]"}], 
       ",", "\"\<\[ThinSpace]\>\"", ",", 
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"IntegerString", "[", 
          RowBox[{
           RowBox[{"expo", "[", "u", "]"}], ",", "2", ",", 
           RowBox[{"esize", "[", "u", "]"}]}], "]"}], ",", "brightblue", ",", 
         "Bold"}], "]"}], ",", "\"\<\[ThinSpace]\>\"", ",", 
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"IntegerString", "[", 
          RowBox[{
           RowBox[{"frac", "[", "u", "]"}], ",", "2", ",", 
           RowBox[{"fsize", "[", "u", "]"}]}], "]"}], ",", "Bold"}], "]"}], 
       ",", "\"\<\[ThinSpace]\>\"", ",", 
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"Boole", "[", 
          RowBox[{"inexQ", "[", "u", "]"}], "]"}], ",", "Magenta"}], "]"}], 
       ",", "\"\<\[ThinSpace]\>\"", ",", 
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"IntegerString", "[", 
          RowBox[{
           RowBox[{"esizeminus1", "[", "u", "]"}], ",", "2", ",", 
           "esizesize"}], "]"}], ",", "sanegreen"}], "]"}], ",", 
       "\"\<\[ThinSpace]\>\"", ",", 
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"IntegerString", "[", 
          RowBox[{
           RowBox[{"fsizeminus1", "[", "u", "]"}], ",", "2", ",", 
           "fsizesize"}], "]"}], ",", "Gray"}], "]"}]}], "}"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Numerical", " ", "value", " ", "meant", " ", "by", " ", "exponent", 
       " ", "bits"}], ";", " ", 
      RowBox[{"helper", " ", "function", " ", "for", " ", 
       RowBox[{"u2f", ":"}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"expovalue", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"expo", "[", "u", "]"}], "-", 
     RowBox[{"bias", "[", "u", "]"}], "+", "1", "-", 
     RowBox[{"hidden", "[", "u", "]"}]}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Convert", " ", "an", " ", "exact", " ", "unum", " ", "to", " ", "its", 
      " ", "float", " ", 
      RowBox[{"value", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"u2f", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{
       RowBox[{"unumQ", "[", "u", "]"}], "\[And]", 
       RowBox[{"exQ", "[", "u", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"u", "\[Equal]", "posinfu"}], ",", 
      RowBox[{"+", "\[Infinity]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"u", "\[Equal]", "neginfu"}], ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[IndentingNewLine]", "True", ",", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], 
        RowBox[{"sign", "[", "u", "]"}]], 
       SuperscriptBox["2", 
        RowBox[{"expovalue", "[", "u", "]"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"hidden", "[", "u", "]"}], "+", 
         FractionBox[
          RowBox[{"frac", "[", "u", "]"}], 
          SuperscriptBox["2", 
           RowBox[{"fsize", "[", "u", "]"}]]]}], ")"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Biggest", " ", "unum", " ", "possible", " ", "with", " ", "identical", 
      " ", "utag", " ", 
      RowBox[{"contents", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"bigu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"expomask", "[", "u", "]"}], "+", 
     RowBox[{"fracmask", "[", "u", "]"}], "+", 
     RowBox[{"BitAnd", "[", 
      RowBox[{"efsizemask", ",", "u"}], "]"}], "-", 
     RowBox[{"ulpu", " ", 
      RowBox[{"Boole", "[", 
       RowBox[{
        RowBox[{"BitAnd", "[", 
         RowBox[{"u", ",", "efsizemask"}], "]"}], "\[Equal]", "efsizemask"}], 
       "]"}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Biggest", " ", "numerical", " ", "value", " ", "representable", " ", 
      "with", " ", "identical", " ", "utag", " ", 
      RowBox[{"contents", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"big", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"u2f", "[", 
     RowBox[{"bigu", "[", "u", "]"}], "]"}]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Some", " ", 
      RowBox[{"synonyms", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"open", ",", "closed"}], "}"}], "=", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NaN", "=", "Indeterminate"}], ";"}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "x", " ", "is", " ", "representable", " ", "as", 
      " ", "a", " ", 
      RowBox[{"float", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Including", " ", "exception", " ", 
         RowBox[{"values", "."}]}], ")"}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"floatQ", "[", "x_", "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"NumericQ", "[", "x", "]"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Head", "[", "x", "]"}], "=!=", "Complex"}], ",", "True", 
        ",", "False"}], "]"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "===", "\[Infinity]"}], "\[Or]", 
         RowBox[{"x", "===", 
          RowBox[{"-", "\[Infinity]"}]}], "\[Or]", 
         RowBox[{"x", "===", "NaN"}]}], ",", "True", ",", "False"}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "for", " ", "a", " ", "value", " ", "being", " ", "in", " ",
       "the", " ", "form", " ", "of", " ", "a", " ", "general", " ", 
      RowBox[{"bound", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gQ", "[", "x_", "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Head", "[", "x", "]"}], "===", "List"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Head", "[", 
            SubscriptBox["x", 
             RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
            "]"}], "===", "List"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", 
              SubscriptBox["x", 
               RowBox[{
               "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "]"}],
              "==", "2"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Head", "[", 
                SubscriptBox["x", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
                "]"}], "===", "List"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  SubscriptBox["x", 
                   RowBox[{
                   "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
                  "]"}], "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[Element]", "Booleans"}], "\[And]", 
                   RowBox[{
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "\[Element]", "Booleans"}], "\[And]", 
                   RowBox[{"floatQ", "[", 
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "]"}], "\[And]", 
                   RowBox[{"floatQ", "[", 
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===",
                     "NaN"}], "\[Or]", 
                    RowBox[{
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===",
                     "NaN"}]}], ",", "True", ",", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "==", 
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                    "\[And]", 
                    RowBox[{"\[Not]", 
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
                    "\[And]", 
                    RowBox[{"\[Not]", 
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
                    ")"}], "\[Or]", 
                    RowBox[{
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", 
                    
                    SubscriptBox["x", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
                    ",", "True", ",", "\[IndentingNewLine]", "False"}], "]"}],
                     ",", "False"}], "]"}], ",", "False"}], "]"}], ",", 
                "False"}], "]"}], ",", "False"}], "]"}], ",", "False"}], 
           "]"}], ",", "False"}], "]"}], ",", "False"}], "]"}], ",", 
      "False"}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Test", " ", "for", " ", "a", " ", "value", " ", "being", " ", "in", 
       " ", "the", " ", "form", " ", "of", " ", "a", " ", "ubound"}], ",", 
      " ", 
      RowBox[{"with", " ", "one", " ", "or", " ", "two", " ", 
       RowBox[{"unums", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"uboundQ", "[", "x_", "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Head", "[", "x", "]"}], "===", "List"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "1"}], "\[Or]", 
         RowBox[{
          RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "2"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"xL", "=", 
             SubscriptBox["x", 
              RowBox[{
              "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], ",", 
            
            RowBox[{"xR", "=", 
             SubscriptBox["x", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}], ",", "gL", 
            ",", "gR"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"unumQ", "[", "xL", "]"}], "\[And]", 
             RowBox[{"unumQ", "[", "xR", "]"}]}], ",", "\[IndentingNewLine]", 
            
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"gL", ",", "gR"}], "}"}], "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"unum2g", "[", "xL", "]"}], ",", 
                RowBox[{"unum2g", "[", "xR", "]"}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "1"}], 
                "\[Or]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"xL", "\[Equal]", "qNaNu"}], "\[Or]", 
                  RowBox[{"xL", "\[Equal]", "sNaNu"}], "\[Or]", 
                  RowBox[{"xR", "\[Equal]", "qNaNu"}], "\[Or]", 
                  RowBox[{"xR", "\[Equal]", "sNaNu"}]}], ")"}], "\[Or]", 
                "\[IndentingNewLine]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    SubscriptBox["gL", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", 
                    
                    SubscriptBox["gR", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                   ")"}], "\[Or]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    SubscriptBox["gL", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", 
                    SubscriptBox["gR", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                    "\[And]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"exQ", "[", "xL", "]"}], "\[And]", 
                    RowBox[{"exQ", "[", "xR", "]"}]}], ")"}]}], ")"}]}], 
                 ")"}]}], ",", "\[IndentingNewLine]", "True", ",", "False"}], 
              "]"}]}], ",", "False"}], "]"}]}], "]"}], ",", "False"}], "]"}], 
      ",", "False"}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "for", " ", "a", " ", "value", " ", "being", " ", "in", " ",
       "the", " ", "form", " ", "of", " ", "a", " ", "ubound", " ", "with", 
      " ", "two", " ", 
      RowBox[{"unums", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"uboundpairQ", "[", "x_", "]"}], ":=", 
    RowBox[{
     RowBox[{"uboundQ", "[", "x", "]"}], "\[And]", 
     RowBox[{
      RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "2"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Test", " ", "for", " ", "a", " ", "value", " ", "being", " ", "in", 
       " ", "the", " ", "u"}], "-", 
      RowBox[{"layer", ":", " ", 
       RowBox[{"unum", " ", "or", " ", 
        RowBox[{"ubound", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"uQ", "[", "x_", "]"}], ":=", 
    RowBox[{
     RowBox[{"unumQ", "[", "x", "]"}], "\[Or]", 
     RowBox[{"uboundQ", "[", "x", "]"}]}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Trivial", " ", "expression", " ", "of", " ", "a", " ", "floatable", " ",
       "value", " ", "in", " ", "the", " ", "form", " ", "of", " ", "a", " ", 
      "general", " ", 
      RowBox[{"interval", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"f2g", "[", 
     RowBox[{"x_", "/;", 
      RowBox[{"floatQ", "[", "x", "]"}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"x", "===", "NaN"}], ",", GridBox[{
        {"NaN", "NaN"},
        {"open", "open"}
       }], ",", GridBox[{
        {"x", "x"},
        {"closed", "closed"}
       }]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Conversion", " ", "of", " ", "a", " ", "unum", " ", "to", " ", "a", " ",
       "general", " ", 
      RowBox[{"interval", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"unum2g", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], " ", "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "\[Equal]", "qNaNu"}], "\[Or]", 
       RowBox[{"u", "==", "sNaNu"}]}], ",", GridBox[{
        {"NaN", "NaN"},
        {"open", "open"}
       }], ",", "\[IndentingNewLine]", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", "=", 
           RowBox[{"u2f", "[", 
            RowBox[{"exact", "[", "u", "]"}], "]"}]}], ",", 
          RowBox[{"y", "=", 
           RowBox[{"u2f", "[", 
            RowBox[{
             RowBox[{"exact", "[", "u", "]"}], "+", "ulpu"}], "]"}]}]}], 
         "}"}], ",", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"exQ", "[", "u", "]"}], ",", GridBox[{
            {"x", "x"},
            {"closed", "closed"}
           }], ",", " ", "\[IndentingNewLine]", 
          RowBox[{"u", "\[Equal]", 
           RowBox[{
            RowBox[{"bigu", "[", "u", "]"}], "+", " ", "ubitmask"}]}], ",", 
          GridBox[{
            {
             RowBox[{"big", "[", "u", "]"}], "\[Infinity]"},
            {"open", "open"}
           }], ",", " ", "\[IndentingNewLine]", 
          RowBox[{"u", "\[Equal]", 
           RowBox[{
            RowBox[{"signmask", "[", "u", "]"}], "+", 
            RowBox[{"bigu", "[", "u", "]"}], "+", " ", "ubitmask"}]}], ",", 
          GridBox[{
            {
             RowBox[{"-", "\[Infinity]"}], 
             RowBox[{"-", 
              RowBox[{"big", "[", "u", "]"}]}]},
            {"open", "open"}
           }], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"sign", "[", "u", "]"}], "\[Equal]", "1"}], ",", GridBox[{
            {"y", "x"},
            {"open", "open"}
           }], ",", " ", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", " ", "negative"}], ",", 
             RowBox[{"the", " ", 
              StyleBox["left",
               FontSlant->"Italic"], " ", "endpoint", " ", "is", " ", "the", 
              " ", "one", " ", "farther", " ", "from", " ", 
              RowBox[{"zero", "."}]}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
          GridBox[{
            {"x", "y"},
            {"open", "open"}
           }]}], "]"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Conversion", " ", "of", " ", "a", " ", "ubound", " ", "to", " ", "a", 
      " ", "general", " ", 
      RowBox[{"interval", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ubound2g", "[", 
     RowBox[{"ub_", "/;", 
      RowBox[{"uboundQ", "[", "ub", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"gL", ",", "gR", ",", 
        RowBox[{"uL", "=", 
         SubscriptBox["ub", 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
        ",", 
        RowBox[{"uR", "=", 
         SubscriptBox["ub", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}]}], "}"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"uL", "\[Equal]", "qNaNu"}], "\[Or]", 
         RowBox[{"uL", "\[Equal]", "sNaNu"}], "\[Or]", 
         RowBox[{"uR", "\[Equal]", "qNaNu"}], "\[Or]", 
         RowBox[{"uR", "\[Equal]", "sNaNu"}]}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"gL", ",", "gR"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"unum2g", "[", "uL", "]"}], ",", 
            RowBox[{"unum2g", "[", "uR", "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", GridBox[{
           {
            SubscriptBox["gL", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
            SubscriptBox["gR", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]},
           {
            SubscriptBox["gL", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], 
            SubscriptBox["gR", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}
          }]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Conversion", " ", "of", " ", "a", " ", "unum", " ", "or", " ", "ubound",
       " ", "to", " ", "a", " ", "general", " ", 
      RowBox[{"interval", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"u2g", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"unumQ", "[", "u", "]"}], ",", 
      RowBox[{"unum2g", "[", "u", "]"}], ",", 
      RowBox[{"ubound2g", "[", "u", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Conversion", " ", "of", " ", "a", " ", "floatable", " ", "real", " ", 
      "to", " ", "a", " ", 
      RowBox[{"unum", ".", " ", "Same"}], " ", "as", " ", "the", " ", 
      "\"\<^\>\"", " ", 
      RowBox[{"annotation", ".", " ", "Most"}], " ", "of", " ", "the", " ", 
      "complexity", " ", "stems", " ", "from", " ", "seeking", " ", "the", 
      " ", "shortest", " ", "possible", " ", "bit", " ", 
      RowBox[{"string", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"x2u", "[", 
     RowBox[{"x_", "/;", 
      RowBox[{"floatQ", "[", "x", "]"}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{"Exceptional", " ", "nonnumeric", " ", 
        RowBox[{"values", ":"}]}], " ", "*)"}],
      FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"x", "===", "NaN"}], ",", "qNaNu", ",", 
      RowBox[{"x", "\[Equal]", 
       RowBox[{"+", "\[Infinity]"}]}], ",", "posinfu", ",", 
      RowBox[{"x", "\[Equal]", 
       RowBox[{"-", "\[Infinity]"}]}], ",", "neginfu", ",", 
      "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{"Magnitudes", " ", "too", " ", "large", " ", "to", " ", 
         RowBox[{"represent", ":"}]}], " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Abs", "[", "x", "]"}], ">", "maxreal"}], ",", 
      RowBox[{"maxrealu", "+", " ", "ubitmask", "+", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"x", "<", "0"}], ",", "signbigu", ",", "0"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Zero", " ", "is", " ", "a", " ", "special", " ", 
          RowBox[{"case", ".", " ", "The"}], " ", "smallest", " ", "unum", 
          " ", "for", " ", "it", " ", "is", " ", "just", " ", "0"}], ":"}], 
        " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
      RowBox[{"x", "\[Equal]", "0"}], ",", "0", ",", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
        "Magnitudes", " ", "too", " ", "small", " ", "to", " ", "represent", 
         " ", "become", "\[IndentingNewLine]", "\"\<inexact zero\>\"", " ", 
         "with", " ", "the", " ", "maximum", " ", "exponent", " ", "and", " ",
          "fraction", " ", "field", " ", 
         RowBox[{"sizes", ":"}]}], " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Abs", "[", "x", "]"}], "<", "smallsubnormal"}], ",", 
      RowBox[{"utagmask", "+", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"x", "<", "0"}], ",", " ", "signbigu", ",", "0"}], "]"}]}], 
      ",", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"For", " ", "subnormal", " ", "numbers"}], ",", " ", 
         RowBox[{
         "divide", " ", "by", " ", "the", " ", "ULP", " ", "value", " ", "to",
           " ", "get", " ", "the", " ", "fractional", " ", 
          RowBox[{"part", ".", " ", "The"}], " ", "While", " ", "loop", " ", 
          "strips", " ", "off", " ", "trailing", " ", 
          RowBox[{"bits", "."}]}]}], " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Abs", "[", "x", "]"}], "<", 
       RowBox[{"u2f", "[", "smallnormalu", "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", "y", "}"}], ",", 
        RowBox[{
         RowBox[{"y", "=", 
          RowBox[{
           RowBox[{"Abs", "[", "x", "]"}], "/", "smallsubnormal"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"y", "=", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"x", "<", "0"}], ",", " ", "signbigu", ",", "0"}], "]"}],
            "+", "efsizemask", "+", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"y", "\[NotEqual]", 
              RowBox[{"\[LeftFloor]", "y", "\[RightFloor]"}]}], ",", " ", 
             "ubitmask", ",", "0"}], "]"}], "+", 
           RowBox[{"BitShiftLeft", "[", 
            RowBox[{
             RowBox[{"\[LeftFloor]", "y", "\[RightFloor]"}], ",", 
             "utagsize"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"BitAnd", "[", 
             RowBox[{
              RowBox[{"BitShiftLeft", "[", 
               RowBox[{"3", ",", 
                RowBox[{"utagsize", "-", "1"}]}], "]"}], ",", "y"}], "]"}], 
            "\[Equal]", "0"}], ",", 
           RowBox[{"y", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"y", "-", 
                RowBox[{"BitAnd", "[", 
                 RowBox[{"efsizemask", ",", "y"}], "]"}]}], ")"}], "/", "2"}],
              "+", 
             RowBox[{"BitAnd", "[", 
              RowBox[{"efsizemask", ",", "y"}], "]"}], "-", "1"}]}]}], "]"}], 
         ";", "y"}]}], "]"}], ",", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
        "All", " ", "remaining", " ", "cases", " ", "are", " ", "in", " ", 
         "the", " ", "normalized", " ", 
         RowBox[{"range", "."}]}], " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"n", "=", "0"}], ",", "y", ",", "z"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"y", "=", 
          RowBox[{
           RowBox[{"Abs", "[", "x", "]"}], "/", 
           SuperscriptBox["2", 
            RowBox[{"scale", "[", "x", "]"}]]}]}], ";", 
         RowBox[{"n", "=", "0"}], ";", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[LeftFloor]", "y", "\[RightFloor]"}], "\[NotEqual]", 
             "y"}], "\[And]", 
            RowBox[{"n", "<", "fsizemax"}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "++"}], ",", 
             RowBox[{"y", "*=", "2"}]}], "}"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"y", "\[Equal]", 
            RowBox[{"\[LeftFloor]", "y", "\[RightFloor]"}]}], ",", 
           StyleBox[
            RowBox[{"(*", " ", 
             RowBox[{
             "then", " ", "the", " ", "value", " ", "is", " ", 
              "representable", " ", 
              RowBox[{"exactly", ".", " ", "Fill"}], " ", "in", " ", "fields",
               " ", "from", " ", "right", " ", "to", " ", 
              RowBox[{"left", ":"}]}], " ", "*)"}],
            FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"Size", " ", "of", " ", "fraction", " ", "field"}], ",",
               " ", 
              RowBox[{
               RowBox[{
               "fits", " ", "in", " ", "the", " ", "rightmost", " ", 
                "fsizesize", " ", "bits"}], "..."}]}], " ", "*)"}],
            FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"y", "=", 
             RowBox[{"n", "-", 
              RowBox[{"Boole", "[", 
               RowBox[{"n", ">", "0"}], "]"}], "\[IndentingNewLine]", 
              StyleBox[
               RowBox[{"(*", " ", 
                RowBox[{
                 RowBox[{
                 "Size", " ", "of", " ", "exponent", " ", "field", " ", 
                  "minus", " ", "1"}], ",", " ", 
                 RowBox[{
                  RowBox[{
                  "fits", " ", "in", " ", "the", " ", "esizesize", " ", 
                   "bits"}], "..."}]}], " ", "*)"}],
               FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
              RowBox[{"BitShiftLeft", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"ne", "[", "x", "]"}], "-", "1"}], ",", 
                "fsizesize"}], "]"}], "\[IndentingNewLine]", 
              StyleBox[
               RowBox[{"(*", " ", 
                RowBox[{
                 RowBox[{
                 "Significant", " ", "bits", " ", "after", " ", "hidden", " ",
                   "bit"}], ",", " ", 
                 RowBox[{
                  RowBox[{
                  "fits", " ", "left", " ", "of", " ", "the", " ", "unum", 
                   " ", "tag", " ", "bits"}], "..."}]}], " ", "*)"}],
               FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"n", "\[Equal]", "0"}], ",", "0", ",", 
                RowBox[{"BitShiftLeft", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[LeftFloor]", "y", "\[RightFloor]"}], "-", 
                   SuperscriptBox["2", 
                    RowBox[{"scale", "[", "y", "]"}]]}], ",", "utagsize"}], 
                 "]"}]}], "]"}], "\[IndentingNewLine]", 
              StyleBox[
               RowBox[{"(*", " ", 
                RowBox[{
                 RowBox[{"Value", " ", "of", " ", "exponent", " ", "bits"}], 
                 ",", " ", 
                 RowBox[{
                  RowBox[{"adjusted", " ", "for", " ", "bias"}], "..."}]}], 
                " ", "*)"}],
               FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
              RowBox[{"BitShiftLeft", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"scale", "[", "x", "]"}], "+", 
                 SuperscriptBox["2", 
                  RowBox[{
                   RowBox[{"ne", "[", "x", "]"}], "-", "1"}]], "-", "1"}], 
                ",", 
                RowBox[{"utagsize", "+", "n", "+", 
                 RowBox[{"Boole", "[", 
                  RowBox[{"n", "\[Equal]", "0"}], "]"}]}]}], "]"}], 
              "\[IndentingNewLine]", 
              StyleBox[
               RowBox[{"(*", " ", 
                RowBox[{
                 RowBox[{"If", " ", "negative"}], ",", " ", 
                 RowBox[{"add", " ", "the", " ", "sign", " ", "bit"}]}], " ", 
                "*)"}],
               FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"x", "<", "0"}], ",", 
                RowBox[{"BitShiftLeft", "[", 
                 RowBox[{"1", ",", 
                  RowBox[{"utagsize", "+", "n", "+", 
                   RowBox[{"Boole", "[", 
                    RowBox[{"n", "\[Equal]", "0"}], "]"}], "+", 
                   RowBox[{"ne", "[", "x", "]"}]}]}], "]"}], ",", "0"}], 
               "]"}]}]}], ";", "\[IndentingNewLine]", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{
               "If", " ", "a", " ", "number", " ", "is", " ", "more", " ", 
                "concise", " ", "as", " ", "a", " ", "subnormal"}], ",", " ", 
               
               RowBox[{"make", " ", "it", " ", 
                RowBox[{"one", "."}]}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
            RowBox[{"z", "=", 
             RowBox[{"Log", "[", 
              RowBox[{"2", ",", 
               RowBox[{"1", "-", 
                RowBox[{"Log", "[", 
                 RowBox[{"2", ",", 
                  RowBox[{"Abs", "[", "x", "]"}]}], "]"}]}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"IntegerQ", "[", "z", "]"}], "\[And]", 
               RowBox[{"z", "\[GreaterEqual]", "0"}]}], ",", 
              RowBox[{
               RowBox[{"BitShiftLeft", "[", 
                RowBox[{"z", ",", "fsizesize"}], "]"}], "+", "ulpu", "+", 
               RowBox[{
                RowBox[{"Boole", "[", 
                 RowBox[{"x", "<", "0"}], "]"}], 
                RowBox[{"signmask", "[", 
                 RowBox[{"BitShiftLeft", "[", 
                  RowBox[{"z", ",", "fsizesize"}], "]"}], "]"}]}]}], ",", 
              "y"}], "]"}]}], ",", "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", 
             RowBox[{"else", " ", 
              RowBox[{"inexact", ".", " ", "Use"}], " ", "all", " ", 
              "available", " ", "fraction", " ", 
              RowBox[{"bits", "."}]}], " ", "*)"}],
            FontColor->GrayLevel[0.5]], 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"z", "=", 
              RowBox[{
               RowBox[{"\[LeftCeiling]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Abs", "[", "x", "]"}], "/", 
                  SuperscriptBox["2", 
                   RowBox[{
                    RowBox[{"scale", "[", "x", "]"}], "-", "fsizemax"}]]}], 
                 ")"}], "\[RightCeiling]"}], 
               SuperscriptBox["2", 
                RowBox[{
                 RowBox[{"scale", "[", "x", "]"}], "-", "fsizemax"}]]}]}], 
             ";", 
             RowBox[{"n", "=", 
              RowBox[{"Max", "[", 
               RowBox[{
                RowBox[{"ne", "[", "x", "]"}], ",", 
                RowBox[{"ne", "[", "z", "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{
                "All", " ", "bits", " ", "on", " ", "for", " ", "the", " ", 
                 "fraction", " ", "size"}], ",", " ", 
                RowBox[{"since", " ", 
                 RowBox[{"we", "'"}], "re", " ", "using", " ", "the", " ", 
                 "maximum"}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
             RowBox[{"y", "=", 
              RowBox[{"fsizemask", "\[IndentingNewLine]", 
               StyleBox[
                RowBox[{"(*", " ", 
                 RowBox[{
                 "Store", " ", "the", " ", "exponent", " ", "size", " ", 
                  "minus", " ", "1", " ", "in", " ", "the", " ", "exponent", 
                  " ", "size", " ", "field"}], " ", "*)"}],
                FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
               RowBox[{"BitShiftLeft", "[", 
                RowBox[{
                 RowBox[{"n", "-", "1"}], ",", "fsizesize"}], "]"}], 
               "\[IndentingNewLine]", 
               StyleBox[
                RowBox[{"(*", " ", 
                 RowBox[{
                 "Back", " ", "off", " ", "by", " ", "one", " ", "ULP", " ", 
                  "and", " ", "make", " ", "it", " ", "inexact"}], " ", "*)"}],
                FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", " ", 
               "ubitmask", "-", "ulpu", "\[IndentingNewLine]", 
               StyleBox[
                RowBox[{"(*", " ", 
                 RowBox[{
                 "Fraction", " ", "bits", " ", "are", " ", "the", " ", "ones",
                   " ", "to", " ", "the", " ", "left", " ", "of", " ", "the", 
                  " ", "binary", " ", "point", " ", "after", " ", "removing", 
                  " ", "hidden", " ", "bit", " ", "and", " ", "scaling"}], 
                 " ", "*)"}],
                FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
               RowBox[{"BitShiftLeft", "[", 
                RowBox[{
                 RowBox[{"\[LeftFloor]", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"z", "/", 
                    SuperscriptBox["2", 
                    RowBox[{"scale", "[", "z", "]"}]]}], "-", "1"}], ")"}], 
                   SuperscriptBox["2", "fsizemax"]}], "\[RightFloor]"}], ",", 
                 "utagsize"}], "]"}], "\[IndentingNewLine]", 
               StyleBox[
                RowBox[{"(*", " ", 
                 RowBox[{
                 "Exponent", " ", "value", " ", "goes", " ", "in", " ", "the",
                   " ", "exponent", " ", "field"}], " ", "*)"}],
                FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "+", 
               RowBox[{"BitShiftLeft", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"scale", "[", "z", "]"}], "+", 
                  SuperscriptBox["2", 
                   RowBox[{"n", "-", "1"}]], "-", "1"}], ",", 
                 RowBox[{"utagsize", "+", "fsizemax"}]}], "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"If", " ", "x", " ", "is", " ", "negative"}], ",", 
                " ", 
                RowBox[{
                "set", " ", "the", " ", "sign", " ", "bit", " ", "in", " ", 
                 "the", " ", 
                 RowBox[{"unum", "."}]}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"x", "<", "0"}], ",", 
               RowBox[{"y", "+=", 
                RowBox[{"signmask", "[", "y", "]"}]}], ",", "y"}], "]"}]}], 
            ")"}]}], "]"}]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Assign", " ", "the", " ", "x2u", " ", "function", " ", "to", " ", "the",
       " ", "\"\<^\>\"", " ", 
      RowBox[{"notation", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OverHat", "[", "x_", "]"}], ":=", 
     RowBox[{"x2u", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "View", " ", "a", " ", "float", " ", "as", " ", "a", " ", "decimal"}], 
      ",", " ", 
      RowBox[{
      "using", " ", "as", " ", "many", " ", "digits", " ", "as", " ", 
       "needed", " ", "to", " ", "be", " ", 
       RowBox[{"exact", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"autoN", "[", "x_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"y", ",", "z"}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "===", "NaN"}], "\[Or]", 
         RowBox[{"x", "\[Equal]", "0"}], "\[Or]", 
         RowBox[{"x", "\[Equal]", "\[Infinity]"}]}], ",", "x", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"x", "<", "0"}], ",", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{"\"\<\[Dash]\>\"", ",", 
           RowBox[{"autoN", "[", 
            RowBox[{"-", "x"}], "]"}]}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"y", "=", 
          RowBox[{"Log", "[", 
           RowBox[{"2", ",", 
            RowBox[{"Denominator", "[", "x", "]"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"y", "\[Equal]", "0"}]}], ",", 
        RowBox[{"IntegerString", "[", 
         RowBox[{"x", ",", "10", ",", 
          RowBox[{"1", "+", 
           RowBox[{"\[LeftFloor]", 
            RowBox[{"Log", "[", 
             RowBox[{"10", ",", "x"}], "]"}], "\[RightFloor]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Head", "[", "x", "]"}], "\[Equal]", "Rational"}], "\[And]", 
         RowBox[{"y", "\[Equal]", 
          RowBox[{"\[LeftFloor]", "y", "\[RightFloor]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"y", "=", 
          RowBox[{"x", "-", 
           RowBox[{"\[LeftFloor]", "x", "\[RightFloor]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"z", "=", 
          RowBox[{"\[LeftFloor]", 
           RowBox[{"Log", "[", 
            RowBox[{"2", ",", 
             RowBox[{"Denominator", "[", "y", "]"}]}], "]"}], 
           "\[RightFloor]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Row", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[LeftFloor]", "x", "\[RightFloor]"}], ",", "\"\<.\>\"", 
            ",", 
            RowBox[{"IntegerString", "[", 
             RowBox[{
              RowBox[{"y", "*", 
               SuperscriptBox["10", "z"]}], ",", "10", ",", "z"}], "]"}]}], 
           "}"}], "]"}]}], ",", "\[IndentingNewLine]", "True", ",", 
        "\"\<?\>\""}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "unum", " ", "with", " ", "color"}], 
      "-", 
      RowBox[{"coding", " ", "and", " ", 
       RowBox[{"annotation", ".", " ", 
        RowBox[{"Warning", ":", " ", 
         RowBox[{"there", " ", "are", " ", "some", " ", 
          StyleBox["negative",
           FontSlant->"Italic"], 
          StyleBox[" ",
           FontSlant->"Italic"], 
          StyleBox["spaces",
           FontSlant->"Italic"], " ", "in", " ", "the", " ", "StringForm", 
          " ", 
          RowBox[{"expressions", "."}]}]}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"unumview", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"e", "=", 
         RowBox[{"expo", "[", "u", "]"}]}], ",", 
        RowBox[{"es", "=", 
         RowBox[{"esizeminus1", "[", "u", "]"}]}], ",", 
        RowBox[{"f", "=", 
         RowBox[{"frac", "[", "u", "]"}]}], ",", 
        RowBox[{"fs", "=", 
         RowBox[{"fsizeminus1", "[", "u", "]"}]}], ",", 
        RowBox[{"g", "=", 
         RowBox[{"u2g", "[", "u", "]"}]}], ",", 
        RowBox[{"i", "=", 
         RowBox[{"inexQ", "[", "u", "]"}]}], ",", 
        RowBox[{"NaNQ", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "\[Equal]", "sNaNu"}], "\[Or]", 
           RowBox[{"u", "\[Equal]", "qNaNu"}]}], ")"}]}], ",", 
        RowBox[{"s", "=", 
         RowBox[{"sign", "[", "u", "]"}]}], ",", 
        RowBox[{"specQ", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "\[Equal]", "sNaNu"}], "\[Or]", 
           RowBox[{"u", "\[Equal]", "qNaNu"}], "\[Or]", 
           RowBox[{"u", "\[Equal]", "posinfu"}], "\[Or]", 
           RowBox[{"u", "\[Equal]", "neginfu"}]}], ")"}]}]}], "}"}], ",", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{"s", ",", "Red", ",", "\"\<Input\>\""}], "]"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}], ",", 
              RowBox[{"Alignment", "\[Rule]", "\"\<Left\>\""}]}], "]"}], ",", 
            
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"IntegerString", "[", 
                 RowBox[{"e", ",", "2", ",", 
                  RowBox[{"esize", "[", "u", "]"}]}], "]"}], ",", 
                "brightblue", ",", "\"\<Input\>\""}], "]"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", "\"\<\[ThinSpace]\>\"", ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"IntegerString", "[", 
                 RowBox[{"f", ",", "2", ",", 
                  RowBox[{"fsize", "[", "u", "]"}]}], "]"}], ",", 
                "\"\<Input\>\""}], "]"}], ",", 
              RowBox[{"Frame", "\[Rule]", "\"\<True\>\""}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"Boole", "[", "i", "]"}], ",", "Magenta", ",", 
                "\"\<Input\>\"", ",", "Plain"}], "]"}], ",", 
              RowBox[{"Frame", "\[Rule]", "\"\<True\>\""}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"IntegerString", "[", 
                 RowBox[{"es", ",", "2", ",", "esizesize"}], "]"}], ",", 
                "sanegreen", ",", "\"\<Input\>\"", ",", "Plain"}], "]"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Item", "[", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"IntegerString", "[", 
                 RowBox[{"fs", ",", "2", ",", "fsizesize"}], "]"}], ",", 
                RowBox[{"FontColor", "\[Rule]", "Gray"}], ",", 
                "\"\<Input\>\"", ",", "Plain"}], "]"}], ",", 
              RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
            "\[IndentingNewLine]", "\"\<\[ThinSpace]\>\"", ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Not]", "NaNQ"}], "\[And]", 
               RowBox[{"\[Not]", "i"}], "\[And]", 
               RowBox[{
                RowBox[{"u2f", "[", "u", "]"}], "\[NotEqual]", 
                RowBox[{"\[LeftFloor]", 
                 RowBox[{"u2f", "[", "u", "]"}], "\[RightFloor]"}]}]}], ",", 
              RowBox[{"u2f", "[", "u", "]"}], ",", 
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Item", "[", 
                  RowBox[{"Which", "[", 
                   RowBox[{"specQ", ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<special case string\>\"", ",", "Italic"}], 
                    "]"}], ",", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", " ", 
                    RowBox[{"\[LeftFloor]", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[RightFloor]"}]}], "\[And]", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", " ", 
                    RowBox[{"\[LeftFloor]", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "\[RightFloor]"}]}]}], ")"}], ",", "\"\< \>\"", ",", 
                    "True", ",", 
                    RowBox[{"StringForm", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<(``,\>\"", ",", "\"\<[``,\>\""}], "]"}], ",", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
                    "]"}]}], "]"}], "]"}], ",", 
                 RowBox[{"Item", "[", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"NaNQ", "\[Or]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", " ", 
                    RowBox[{"\[LeftFloor]", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[RightFloor]"}]}], "\[And]", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", " ", 
                    RowBox[{"\[LeftFloor]", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "\[RightFloor]"}]}]}], ")"}]}], ",", "\"\< \>\"", ",", 
                    RowBox[{"StringForm", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<``)\>\"", ",", "\"\<``]\>\""}], "]"}], ",", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                    "]"}]}], "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"s", "\[Equal]", "0"}], ",", "\"\<+\>\"", ",", 
                "\"\<\[Dash]\>\""}], "]"}], ",", "Red"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"StringForm", "[", 
               RowBox[{"\"\<``\[Times]\>\"", ",", 
                RowBox[{"Superscript", "[", 
                 RowBox[{"2", ",", 
                  RowBox[{"expovalue", "[", "u", "]"}]}], "]"}]}], "]"}], ",",
               "brightblue"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{"StringForm", "[", 
              RowBox[{
              "\"\<\[NegativeThickSpace]``+\[NegativeThickSpace]\
\[NegativeThickSpace]\>\"", ",", 
               RowBox[{"hidden", "[", "u", "]"}]}], "]"}], "]"}], ",", 
            RowBox[{"DisplayForm", "[", 
             RowBox[{"FractionBox", "[", 
              RowBox[{"f", ",", 
               SuperscriptBox["2", 
                RowBox[{"fs", "+", "1"}]]}], "]"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
               "i", ",", "\"\<\[CenterEllipsis]\>\"", ",", 
                "\"\<\[DownArrow]\>\""}], "]"}], ",", "Magenta"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"es", "+", "1"}], ",", "sanegreen"}], "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"fs", "+", "1"}], ",", "Gray"}], "]"}], ",", 
            "\"\<\[ThinSpace]\>\"", ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Not]", "NaNQ"}], "\[And]", 
               RowBox[{"\[Not]", "i"}]}], ",", 
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"\[Not]", "specQ"}], ",", "\"\<= \>\""}], "]"}], 
                 ",", 
                 RowBox[{"autoN", "[", 
                  SubscriptBox["g", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                  "]"}]}], "}"}], "]"}], ",", 
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Item", "[", 
                  RowBox[{"If", "[", 
                   RowBox[{"NaNQ", ",", "\"\< \>\"", ",", 
                    RowBox[{"StringForm", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<= (``,\>\"", ",", "\"\<= [``,\>\""}], "]"}], ",", 
                    RowBox[{"autoN", "[", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "]"}]}], "]"}]}], "]"}], "]"}], 
                 RowBox[{"Item", "[", 
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{"NaNQ", ",", "\"\<NaN\>\"", ",", 
                    RowBox[{"StringForm", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<``)\>\"", ",", "\"\<``]\>\""}], "]"}], ",", 
                    RowBox[{"autoN", "[", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "]"}]}], "]"}]}], "]"}], ",", 
                   RowBox[{"Alignment", "\[Rule]", "Left"}]}], "]"}]}], "}"}],
                "]"}]}], "]"}]}], "}"}]}], "}"}], ",", 
        RowBox[{"ItemStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Automatic", ",", 
           RowBox[{"2", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<Text\>\"", ",", "12"}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "9"}], "}"}], "\[Rule]", "\"\<Text\>\""}]}], 
          "}"}]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "ubound", " ", "with", " ", "color"}],
       "-", 
      RowBox[{"coding", " ", "and", " ", 
       RowBox[{"annotation", ".", " ", 
        RowBox[{"Warning", ":", " ", 
         RowBox[{"there", " ", "are", " ", "some", " ", 
          StyleBox["negative",
           FontSlant->"Italic"], 
          StyleBox[" ",
           FontSlant->"Italic"], 
          StyleBox["spaces",
           FontSlant->"Italic"], " ", "in", " ", "the", " ", "StringForm", 
          " ", 
          RowBox[{"expressions", "."}]}]}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"uboundview", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uboundQ", "[", "u", "]"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "u", "]"}], "\[Equal]", "1"}], ",", 
      RowBox[{"unumview", "[", 
       SubscriptBox["u", 
        RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
       "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"uL", "=", 
           SubscriptBox["u", 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}],
           ",", 
          RowBox[{"uR", "=", 
           SubscriptBox["u", 
            RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}],
           ",", "eL", ",", "eR", ",", "esL", ",", "esR", ",", "fL", ",", 
          "fsL", ",", "fsR", ",", "fR", ",", "iL", ",", "iR", ",", "NaNQ", 
          ",", "sL", ",", "sR", ",", "t"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"eL", ",", "eR", ",", "fL", ",", "fR"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"expo", "[", "uL", "]"}], ",", 
            RowBox[{"expo", "[", "uR", "]"}], ",", 
            RowBox[{"frac", "[", "uL", "]"}], ",", 
            RowBox[{"frac", "[", "uR", "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"esL", ",", "esR", ",", "fsL", ",", "fsR"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"esizeminus1", "[", "uL", "]"}], ",", 
            RowBox[{"esizeminus1", "[", "uR", "]"}], ",", 
            RowBox[{"fsizeminus1", "[", "uL", "]"}], ",", 
            RowBox[{"fsizeminus1", "[", "uR", "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"iL", ",", "iR", ",", "sL", ",", "sR"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"inexQ", "[", "uL", "]"}], ",", 
            RowBox[{"inexQ", "[", "uR", "]"}], ",", 
            RowBox[{"sign", "[", "uL", "]"}], ",", 
            RowBox[{"sign", "[", "uR", "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"NaNQ", "=", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"uL", "\[Equal]", "qNaNu"}], "\[Or]", 
            RowBox[{"uL", "\[Equal]", "sNaNu"}], "\[Or]", 
            RowBox[{"uR", "\[Equal]", "qNaNu"}], "\[Or]", 
            RowBox[{"uR", "\[Equal]", "sNaNu"}]}], ")"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"t", "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"sL", ",", "Red", ",", "Bold", ",", "9"}], "]"}], 
                ",", 
                RowBox[{"Frame", "\[Rule]", "True"}], ",", 
                RowBox[{"Alignment", "\[Rule]", "\"\<Left\>\""}]}], "]"}], 
              ",", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"eL", ",", "2", ",", 
                    RowBox[{"esL", "+", "1"}]}], "]"}], ",", "Bold", ",", 
                  "brightblue", ",", "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              "\[IndentingNewLine]", "\"\<\[ThinSpace]\>\"", ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"fL", ",", "2", ",", 
                    RowBox[{"fsL", "+", "1"}]}], "]"}], ",", "Bold", ",", 
                  "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "\"\<True\>\""}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"Boole", "[", "iL", "]"}], ",", "Magenta", ",", 
                  "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "\"\<True\>\""}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"esL", ",", "2", ",", "esizesize"}], "]"}], ",", 
                  "sanegreen", ",", "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"fsL", ",", "2", ",", "fsizesize"}], "]"}], ",", 
                  RowBox[{"FontColor", "\[Rule]", "Gray"}], ",", "9"}], "]"}],
                 ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              "\"\< \>\"", ",", "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{"sR", ",", "Red", ",", "Bold", ",", "9"}], "]"}], 
                ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"eR", ",", "2", ",", 
                    RowBox[{"esR", "+", "1"}]}], "]"}], ",", "brightblue", 
                  ",", "Bold", ",", "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              "\[IndentingNewLine]", "\"\<\[ThinSpace]\>\"", ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"fR", ",", "2", ",", 
                    RowBox[{"fsR", "+", "1"}]}], "]"}], ",", "Bold", ",", 
                  "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"Boole", "[", "iR", "]"}], ",", "Magenta", ",", 
                  "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"esR", ",", "2", ",", "esizesize"}], "]"}], ",", 
                  "sanegreen", ",", "9"}], "]"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{"IntegerString", "[", 
                   RowBox[{"fsR", ",", "2", ",", "fsizesize"}], "]"}], ",", 
                  RowBox[{"FontColor", "\[Rule]", "Gray"}], ",", "9"}], "]"}],
                 ",", 
                RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"sL", "\[Equal]", "0"}], ",", "\"\<+\>\"", ",", 
                  "\"\<\[Dash]\>\""}], "]"}], ",", "Red", ",", "9"}], "]"}], 
              ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"StringForm", "[", 
                 RowBox[{"\"\<``\[Times]\>\"", ",", 
                  RowBox[{"Superscript", "[", 
                   RowBox[{"2", ",", 
                    RowBox[{"expovalue", "[", "uL", "]"}]}], "]"}]}], "]"}], 
                ",", "brightblue", ",", "12"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"StringForm", "[", 
                 RowBox[{
                 "\"\<\[NegativeThickSpace]``+\[NegativeThickSpace]\
\[NegativeThickSpace]\>\"", ",", 
                  RowBox[{"hidden", "[", "uL", "]"}]}], "]"}], ",", "12"}], 
               "]"}], ",", 
              RowBox[{"DisplayForm", "[", 
               RowBox[{"FractionBox", "[", 
                RowBox[{"fL", ",", 
                 SuperscriptBox["2", 
                  RowBox[{"fsL", "+", "1"}]]}], "]"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                 "iL", ",", "\"\<\[CenterEllipsis]\>\"", ",", 
                  "\"\<\[DownArrow]\>\""}], "]"}], ",", "Magenta", ",", 
                "12"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"esL", "+", "1"}], ",", "sanegreen", ",", "12"}], 
               "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"fsL", "+", "1"}], ",", "Gray", ",", "12"}], "]"}], 
              ",", "\"\< \>\"", ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"sR", "\[Equal]", "0"}], ",", "\"\<+\>\"", ",", 
                  "\"\<\[Dash]\>\""}], "]"}], ",", "Red", ",", "12"}], "]"}], 
              ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"StringForm", "[", 
                 RowBox[{"\"\<``\[Times]\>\"", ",", 
                  RowBox[{"Superscript", "[", 
                   RowBox[{"2", ",", 
                    RowBox[{"expovalue", "[", "uR", "]"}]}], "]"}]}], "]"}], 
                ",", "brightblue", ",", "12"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"StringForm", "[", 
                 RowBox[{
                 "\"\<\[NegativeThickSpace]``+\[NegativeThickSpace]\
\[NegativeThickSpace]\>\"", ",", 
                  RowBox[{"hidden", "[", "uR", "]"}]}], "]"}], ",", "12"}], 
               "]"}], ",", 
              RowBox[{"DisplayForm", "[", 
               RowBox[{"FractionBox", "[", 
                RowBox[{"fR", ",", 
                 SuperscriptBox["2", 
                  RowBox[{"fsR", "+", "1"}]]}], "]"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                 "iR", ",", "\"\<\[CenterEllipsis]\>\"", ",", 
                  "\"\<\[DownArrow]\>\""}], "]"}], ",", "Magenta", ",", 
                "12"}], "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"esR", "+", "1"}], ",", "sanegreen", ",", "12"}], 
               "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"fsR", "+", "1"}], ",", "Gray", ",", "12"}], "]"}]}], 
             "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{"NaNQ", ",", "\"\< \>\"", ",", 
                  RowBox[{"StringForm", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<= (``,\>\"", ",", "\"\<= [``,\>\""}], "]"}], ",", 
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
                   "]"}]}], "]"}], ",", 
                RowBox[{"Alignment", "\[Rule]", "Right"}]}], "]"}], ",", 
              "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft", ",", 
              "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft", ",", 
              "SpanFromLeft", ",", 
              RowBox[{"Item", "[", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{"NaNQ", ",", "\"\<NaN\>\"", ",", 
                  RowBox[{"StringForm", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<``)\>\"", ",", "\"\<``]\>\""}], "]"}], ",", 
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                   "]"}]}], "]"}], ",", 
                RowBox[{"Alignment", "\[Rule]", "Left"}]}], "]"}], ",", 
              "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft", ",", 
              "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft"}], 
             "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", 
              SubscriptBox[
               RowBox[{"(", 
                RowBox[{"u2g", "[", "u", "]"}], ")"}], 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "]"}], 
             "\[Equal]", "Rational"}], "\[Or]", 
            RowBox[{
             RowBox[{"Head", "[", 
              SubscriptBox[
               RowBox[{"(", 
                RowBox[{"u2g", "[", "u", "]"}], ")"}], 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "]"}], 
             "\[Equal]", "Rational"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"t", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"t", ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Item", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"NaNQ", ",", "\"\< \>\"", ",", 
                    RowBox[{"StringForm", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<= (``,\>\"", ",", "\"\<= [``,\>\""}], "]"}], ",", 
                    RowBox[{"autoN", "[", 
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"Alignment", "\[Rule]", "Right"}]}], "]"}], ",", 
                  "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft", 
                  ",", "SpanFromLeft", ",", "SpanFromLeft", ",", 
                  "SpanFromLeft", ",", "SpanFromLeft", ",", 
                  RowBox[{"Item", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{"NaNQ", ",", "\"\<NaN\>\"", ",", 
                    RowBox[{"StringForm", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
                    "\"\<``)\>\"", ",", "\"\<``]\>\""}], "]"}], ",", 
                    RowBox[{"autoN", "[", 
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "u", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"Alignment", "\[Rule]", "Left"}]}], "]"}], ",", 
                  "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft", 
                  ",", "SpanFromLeft", ",", "SpanFromLeft", ",", 
                  "SpanFromLeft"}], "}"}]}], "}"}]}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Grid", "[", 
          RowBox[{"t", ",", 
           RowBox[{"ItemStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"2", "\[Rule]", "\"\<Text\>\""}], ",", 
                RowBox[{"4", "\[Rule]", "\"\<Text\>\""}], ",", 
                RowBox[{"6", "\[Rule]", "\"\<Text\>\""}]}], "}"}]}], 
             "}"}]}]}], "]"}]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "View", " ", "a", " ", "value", " ", "as", " ", "a", " ", "unum"}], ",",
       " ", 
      RowBox[{"converting", " ", "if", " ", 
       RowBox[{"necessary", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"uview", "[", 
     RowBox[{"x_", "/;", 
      RowBox[{
       RowBox[{"gQ", "[", "x", "]"}], "\[Or]", 
       RowBox[{"uboundQ", "[", "x", "]"}], "\[Or]", 
       RowBox[{"unumQ", "[", "x", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"gQ", "[", "x", "]"}], ",", 
      RowBox[{"uboundview", "[", 
       RowBox[{"g2u", "[", "x", "]"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"uboundQ", "[", "x", "]"}], ",", 
      RowBox[{"uboundview", "[", "x", "]"}], ",", "\[IndentingNewLine]", 
      "True", ",", 
      RowBox[{"unumview", "[", "x", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "View", " ", "a", " ", "value", " ", "as", " ", "a", " ", "general", 
       " ", "interval", " ", 
       RowBox[{"(", 
        RowBox[{"table", " ", "form"}], ")"}]}], ",", " ", 
      RowBox[{"converting", " ", "if", " ", 
       RowBox[{"necessary", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"gview", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{
       RowBox[{"gQ", "[", "g", "]"}], "\[Or]", 
       RowBox[{"uboundQ", "[", "g", "]"}], "\[Or]", 
       RowBox[{"unumQ", "[", "g", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"L", ",", "R", ",", "LQ", ",", "RQ"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"L", ",", "R"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"LQ", ",", "RQ"}], "}"}]}], "}"}], "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"gQ", "[", "g", "]"}], ",", "g", ",", 
          RowBox[{"u2g", "[", "g", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"L", ",", "R"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"LQ", ",", "RQ"}], "}"}]}], "}"}], ",", 
         RowBox[{"Background", "\[Rule]", "chartreuse"}]}], "]"}]}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "View", " ", "a", " ", "value", " ", "in", " ", "normal", " ", 
       "mathematical", " ", "notation"}], ",", " ", 
      RowBox[{"converting", " ", "if", " ", 
       RowBox[{"necessary", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"view", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{
       RowBox[{"gQ", "[", "g", "]"}], "\[Or]", 
       RowBox[{"unumQ", "[", "g", "]"}], "\[Or]", 
       RowBox[{"uboundQ", "[", "g", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"L", ",", "R", ",", "LQ", ",", "RQ"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"L", ",", "R"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"LQ", ",", "RQ"}], "}"}]}], "}"}], "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"gQ", "[", "g", "]"}], ",", "g", ",", 
          RowBox[{"u2g", "[", "g", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"L", "===", "NaN"}], "||", 
          RowBox[{"R", "===", "NaN"}]}], ",", 
         RowBox[{"Style", "[", 
          RowBox[{"\"\<NaN\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"L", "\[Equal]", "R"}], "&&", 
          RowBox[{"!", "LQ"}], "&&", 
          RowBox[{"!", "RQ"}]}], ",", 
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"autoN", "[", "L", "]"}], ",", "\"\<Text\>\""}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"L", "<", "R"}], ",", 
         RowBox[{"Row", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{"LQ", ",", "\"\<(\>\"", ",", "\"\<[\>\""}], "]"}], 
              ",", "\"\<Text\>\""}], "]"}], ",", 
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                 RowBox[{"autoN", "[", "L", "]"}], ",", "\"\<Text\>\""}], 
                "]"}], ",", 
               RowBox[{"Style", "[", 
                RowBox[{"\"\<, \>\"", ",", "\"\<Text\>\""}], "]"}]}], "}"}], 
             "]"}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"autoN", "[", "R", "]"}], ",", "\"\<Text\>\""}], "]"}], 
            ",", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{"RQ", ",", "\"\<)\>\"", ",", "\"\<]\>\""}], "]"}], 
              ",", "\"\<Text\>\""}], "]"}]}], "}"}], "]"}], ",", "True", ",", 
         "\"\<NaN\>\""}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Helper", " ", "function", " ", "for", " ", "conversion"}], 
       ";", " ", 
       RowBox[{"find", " ", "the", " ", "scale", " ", "factor"}]}], ",", " ", 
      
      RowBox[{"with", " ", 
       RowBox[{"exceptions", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"scale", "[", 
     RowBox[{"x_", "/;", 
      RowBox[{
       RowBox[{"floatQ", "[", "x", "]"}], "\[And]", 
       RowBox[{"x", "\[NotEqual]", "\[Infinity]"}], "\[And]", 
       RowBox[{"x", "=!=", "NaN"}]}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"x", "\[Equal]", "0"}], ",", "0", ",", 
      RowBox[{"\[LeftFloor]", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"Abs", "[", "x", "]"}]}], "]"}], "\[RightFloor]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Find", " ", "a", " ", "concise", " ", "number", " ", "of", " ", 
       "exponent", " ", "bits"}], ",", " ", 
      RowBox[{"accounting", " ", "for", " ", 
       RowBox[{"subnormals", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"ne", "[", 
     RowBox[{"x_", "/;", 
      RowBox[{
       RowBox[{"floatQ", "[", "x", "]"}], "\[And]", 
       RowBox[{"x", "\[NotEqual]", "\[Infinity]"}], "\[And]", 
       RowBox[{"x", "=!=", "NaN"}]}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "\[Equal]", "0"}], "\[Or]", 
       RowBox[{
        RowBox[{"scale", "[", "x", "]"}], "\[Equal]", "1"}]}], ",", "1", ",", 
      
      RowBox[{
       RowBox[{"\[LeftCeiling]", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", 
          RowBox[{"1", "+", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"scale", "[", "x", "]"}], "-", "1"}], "]"}]}]}], "]"}], 
        "\[RightCeiling]"}], "+", "1"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Count", " ", "the", " ", "bits", " ", "needed", " ", "to", " ", 
       "store", " ", "a", " ", 
       RowBox[{"ubound", ".", " ", "If"}], " ", "a", " ", "unum"}], ",", " ", 
      
      RowBox[{"make", " ", "it", " ", "a", " ", 
       RowBox[{"ubound", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nbits", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ub", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"unumQ", "[", "u", "]"}], ",", 
          RowBox[{"{", "u", "}"}], ",", "u"}], "]"}]}], "}"}], ",", 
      RowBox[{"1", "+", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "ub", "]"}], "\[Equal]", "2"}], ",", 
         RowBox[{
          RowBox[{"numbits", "[", 
           SubscriptBox["ub", 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "]"}], "+", 
          RowBox[{"numbits", "[", 
           SubscriptBox["ub", 
            RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
           "]"}]}], ",", 
         RowBox[{"numbits", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}]}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Pad", " ", "the", " ", "fraction", " ", "out", " ", "to", " ", "its", 
      " ", "maximum", " ", "size", " ", "by", " ", "shifting", " ", "in", " ",
       "zero", " ", 
      RowBox[{"bits", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"padu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"BitShiftLeft", "[", 
      RowBox[{
       RowBox[{"BitAnd", "[", 
        RowBox[{
         RowBox[{"floatmask", "[", "u", "]"}], ",", "u"}], "]"}], ",", 
       RowBox[{"fsizemax", "-", 
        RowBox[{"fsize", "[", "u", "]"}]}]}], "]"}], "+", 
     RowBox[{"BitAnd", "[", 
      RowBox[{"utagmask", ",", "u"}], "]"}], "+", "fsizemax", "-", 
     RowBox[{"fsize", "[", "u", "]"}]}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Negate", " ", "a", " ", "unum", " ", "or", " ", 
      RowBox[{"ubound", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"negateu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"uboundQ", "[", "u", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "u", "]"}], "\[Equal]", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"u2g", "[", 
             SubscriptBox["u", 
              RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]],
              "]"}], "===", 
            RowBox[{"u2g", "[", "0", "]"}]}], ",", 
           OverscriptBox["0", "^"], ",", 
           RowBox[{"BitXor", "[", 
            RowBox[{
             RowBox[{"signmask", "[", 
              SubscriptBox["u", 
               RowBox[{
               "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "]"}],
              ",", 
             SubscriptBox["u", 
              RowBox[{
              "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
            "]"}]}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"u2g", "[", 
              SubscriptBox["u", 
               RowBox[{
               "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], "]"}],
              "===", 
             RowBox[{"u2g", "[", "0", "]"}]}], ",", 
            OverscriptBox["0", "^"], ",", 
            RowBox[{"BitXor", "[", 
             RowBox[{
              RowBox[{"signmask", "[", 
               SubscriptBox["u", 
                RowBox[{
                "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
               "]"}], ",", 
              SubscriptBox["u", 
               RowBox[{
               "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
             "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"u2g", "[", 
              SubscriptBox["u", 
               RowBox[{
               "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "]"}],
              "===", 
             RowBox[{"u2g", "[", "0", "]"}]}], ",", 
            OverscriptBox["0", "^"], ",", 
            RowBox[{"BitXor", "[", 
             RowBox[{
              RowBox[{"signmask", "[", 
               SubscriptBox["u", 
                RowBox[{
                "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
               "]"}], ",", 
              SubscriptBox["u", 
               RowBox[{
               "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
             "]"}]}], "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      "True", ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"u2g", "[", "u", "]"}], "===", 
         RowBox[{"u2g", "[", "0", "]"}]}], ",", 
        OverscriptBox["0", "^"], ",", 
        RowBox[{"BitXor", "[", 
         RowBox[{
          RowBox[{"signmask", "[", "u", "]"}], ",", "u"}], "]"}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Seek", " ", "a", " ", "single"}], "-", 
      RowBox[{
      "ULP", " ", "enclosure", " ", "for", " ", "a", " ", "ubound", " ", 
       "greater", " ", "than", " ", "or", " ", "equal", " ", "to", " ", 
       RowBox[{"zero", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"unifypos", "[", 
     RowBox[{"ub_", "/;", 
      RowBox[{"uboundQ", "[", "ub", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"u", "=", 
         SubscriptBox["ub", 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
        ",", 
        RowBox[{"v", "=", 
         SubscriptBox["ub", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}], ",", "n"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Which", "[", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{
         "First", " ", "do", " ", "trivial", " ", "case", " ", "where", " ", 
          "endpoints", " ", "express", " ", "the", " ", "same", " ", 
          "value"}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"u2g", "[", "u", "]"}], "===", 
         RowBox[{"u2g", "[", "v", "]"}]}], ",", 
        RowBox[{"g2u", "[", 
         RowBox[{"u2g", "[", "u", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Cannot", " ", "unify", " ", "if", " ", "the", " ", "interval", 
            " ", "includes", " ", "exact", " ", "0"}], ",", "  ", "1", ",", 
           "  ", "2", ",", " ", 
           RowBox[{"or", "  ", "3"}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"ub", "\[TildeTilde]", 
          RowBox[{"{", 
           OverscriptBox["0", "^"], "}"}]}], "\[Or]", 
         RowBox[{"ub", "\[TildeTilde]", 
          RowBox[{"{", 
           OverscriptBox["1", "^"], "}"}]}], "\[Or]", 
         RowBox[{"ub", "\[TildeTilde]", 
          RowBox[{"{", 
           OverscriptBox["2", "^"], "}"}]}], "\[Or]", 
         RowBox[{"ub", "\[TildeTilde]", 
          RowBox[{"{", 
           OverscriptBox["3", "^"], "}"}]}]}], ",", "ub", ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
          "Refine", " ", "the", " ", "endpoints", " ", "for", " ", "the", " ",
            "tightest", " ", "possible", " ", 
           RowBox[{"unification", "."}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"u", "=", 
          RowBox[{
           SubscriptBox[
            RowBox[{"promote", "[", 
             RowBox[{"{", 
              RowBox[{
               OverscriptBox[
                SubscriptBox[
                 RowBox[{"u2g", "[", "u", "]"}], 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "^"], 
               ",", "efsizemask"}], "}"}], "]"}], 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "+", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"inexQ", "[", "u", "]"}], ",", "ubitmask", ",", 
             RowBox[{"-", "ubitmask"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"v", "=", 
          RowBox[{
           SubscriptBox[
            RowBox[{"promote", "[", 
             RowBox[{"{", 
              RowBox[{
               OverscriptBox[
                SubscriptBox[
                 RowBox[{"u2g", "[", "v", "]"}], 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "^"], 
               ",", "efsizemask"}], "}"}], "]"}], 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "-", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"inexQ", "[", "v", "]"}], ",", "ubitmask", ",", 
             RowBox[{"-", "ubitmask"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"u", "\[Equal]", "v"}]}], ",", 
        RowBox[{"{", "u", "}"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{
            "If", " ", "upper", " ", "bound", " ", "is", " ", "open", " ", 
             "\[Infinity]", " ", "and", " ", "lower", " ", "bound"}], " ", 
            ">", " ", "maxreal"}], ",", " ", 
           RowBox[{"special", " ", "handling", " ", "is", " ", 
            RowBox[{"needed", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{
          SubscriptBox[
           RowBox[{"u2g", "[", "v", "]"}], 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
          "\[Infinity]"}], "\[And]", 
         SubscriptBox[
          RowBox[{"u2g", "[", "v", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ltuQ", "[", 
           RowBox[{
            RowBox[{"{", "maxrealu", "}"}], ",", 
            RowBox[{"{", "u", "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"maxrealu", "+", "ubitmask"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
            "Demote", " ", "the", " ", "left", " ", "bound", " ", "until", 
             " ", "the", " ", "upper", " ", "bound", " ", "is", " ", "open", 
             " ", "\[Infinity]"}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], 
          StyleBox["\[IndentingNewLine]",
           FontColor->GrayLevel[0.5]], 
          RowBox[{
           RowBox[{"While", "[", 
            RowBox[{
             RowBox[{
              SubscriptBox[
               RowBox[{"u2g", "[", "u", "]"}], 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "<", 
              "\[Infinity]"}], ",", 
             RowBox[{"u", "=", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"esize", "[", "u", "]"}], ">", "1"}], ",", 
                RowBox[{"demotee", "[", "u", "]"}], ",", 
                RowBox[{"demotef", "[", "u", "]"}]}], "]"}]}]}], "]"}], ";", 
           RowBox[{"{", "u", "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        "True", ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "While", " ", "demoting", " ", "exponents", " ", "is", " ", 
            "possible", " ", "and", " ", "still", " ", "leaves", " ", "unums",
             " ", "within", " ", "the", " ", "ubound"}], ",", " ", 
           RowBox[{"demote", " ", "both", " ", "exponents"}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"u", "\[NotEqual]", "v"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{"(", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 SubscriptBox[
                  RowBox[{"u2g", "[", 
                   RowBox[{"demotee", "[", "u", "]"}], "]"}], 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", 
                 SubscriptBox[
                  RowBox[{"u2g", "[", 
                   RowBox[{"demotee", "[", "v", "]"}], "]"}], 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
                "\[And]", 
                RowBox[{
                 SubscriptBox[
                  RowBox[{"u2g", "[", 
                   RowBox[{"demotee", "[", "u", "]"}], "]"}], 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "<", 
                 SubscriptBox[
                  RowBox[{"u2g", "[", 
                   RowBox[{"demotee", "[", "v", "]"}], "]"}], 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "<", 
                 "\[Infinity]"}]}], ")"}], 
              StyleBox[
               RowBox[{"(*", 
                RowBox[{"\[Or]", 
                 RowBox[{
                  RowBox[{"demotee", "[", "u", "]"}], "\[Equal]", 
                  RowBox[{"demotee", "[", "v", "]"}]}]}], "*)"}],
               FontColor->GrayLevel[0.5]], ")"}], ")"}], "\[And]", 
            RowBox[{
             RowBox[{"esize", "[", "u", "]"}], ">", "1"}]}], ",", 
           RowBox[{
            RowBox[{"u", "=", 
             RowBox[{"demotee", "[", "u", "]"}]}], ";", 
            RowBox[{"v", "=", 
             RowBox[{"demotee", "[", "v", "]"}]}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"u", "\[NotEqual]", "v"}], "\[And]", 
            RowBox[{
             RowBox[{"frac", "[", "v", "]"}], "\[NotEqual]", 
             RowBox[{"frac", "[", "u", "]"}]}], "\[And]", 
            RowBox[{
             RowBox[{"fsize", "[", "u", "]"}], ">", "1"}]}], ",", 
           RowBox[{
            RowBox[{"u", "=", 
             RowBox[{"demotef", "[", "u", "]"}]}], ";", 
            RowBox[{"v", "=", 
             RowBox[{"demotef", "[", "v", "]"}]}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
             RowBox[{
             "If", " ", "u", " ", "is", " ", "inexact", " ", "zero", " ", 
              "and", " ", "v"}], " ", "<", " ", "1"}], ",", " ", 
            RowBox[{
            "a", " ", "little", " ", "special", " ", "handling", " ", "is", 
             " ", 
             RowBox[{"needed", "."}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], 
         StyleBox["\[IndentingNewLine]",
          FontColor->GrayLevel[0.5]], 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"u", "\[NotEqual]", "v"}], "\[And]", 
            RowBox[{
             RowBox[{"BitAnd", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"floatmask", "[", "u", "]"}], "+", "ubitmask"}], ",", 
               "u"}], "]"}], "\[Equal]", "ubitmask"}], "\[And]", 
            RowBox[{"ltuQ", "[", 
             RowBox[{
              RowBox[{"{", "v", "}"}], ",", 
              RowBox[{"{", 
               OverscriptBox["1", "^"], "}"}]}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"n", "=", 
             RowBox[{"Min", "[", 
              RowBox[{"esizemax", ",", 
               RowBox[{"\[LeftFloor]", 
                RowBox[{"Log", "[", 
                 RowBox[{"2", ",", 
                  RowBox[{"1", "-", 
                   RowBox[{"Log", "[", 
                    RowBox[{"2", ",", 
                    SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", 
                    RowBox[{"v", "+", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"exQ", "[", "v", "]"}], ",", "ubitmask", ",", 
                    "0"}], "]"}]}], "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                    "]"}]}]}], "]"}], "\[RightFloor]"}]}], "]"}]}], ";", 
            RowBox[{"{", 
             RowBox[{
              OverscriptBox[
               SuperscriptBox["2", 
                RowBox[{
                 RowBox[{"-", 
                  SuperscriptBox["2", "n"]}], "+", "1"}]], "^"], "-", 
              "ubitmask"}], "}"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"u", "\[Equal]", "v"}], ",", 
             RowBox[{"{", "u", "}"}], ",", "ub"}], "]"}]}], "]"}]}]}], 
       "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Seek", " ", "a", " ", "single"}], "-", 
      RowBox[{"ULP", " ", "enclosure", " ", "for", " ", "a", " ", 
       RowBox[{"ubound", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"unify", "[", 
     RowBox[{"ub_", "/;", 
      RowBox[{"uboundQ", "[", "ub", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"u", "=", 
         SubscriptBox["ub", 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
        ",", 
        RowBox[{"v", "=", 
         SubscriptBox["ub", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}]}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"u", "\[Equal]", "qNaNu"}], "\[Or]", 
         RowBox[{"u", "\[Equal]", "sNaNu"}], "\[Or]", 
         RowBox[{"v", "\[Equal]", "qNaNu"}], "\[Or]", 
         RowBox[{"v", "\[Equal]", "sNaNu"}]}], ",", 
        RowBox[{"{", "qNaNu", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"u", "\[Equal]", "posinfu"}], "\[And]", 
         RowBox[{"v", "\[Equal]", "posinfu"}]}], ",", 
        RowBox[{"{", "posinfu", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"u", "\[Equal]", "neginfu"}], "\[And]", 
         RowBox[{"v", "\[Equal]", "neginfu"}]}], ",", 
        RowBox[{"{", "neginfu", "}"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
          "Skip", " ", "trivial", " ", "cases", " ", "that", " ", "cannot", 
           " ", "be", " ", "unified"}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"u", "\[Equal]", "neginfu"}], "\[Or]", 
         RowBox[{"u", "\[Equal]", "posinfu"}], "\[Or]", 
         RowBox[{"v", "\[Equal]", "neginfu"}], "\[Or]", 
         RowBox[{"v", "\[Equal]", "posinfu"}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"ltuQ", "[", 
            RowBox[{
             RowBox[{"{", "u", "}"}], ",", 
             RowBox[{"{", 
              OverscriptBox["0", "^"], "}"}]}], "]"}], "\[And]", 
           RowBox[{"\[Not]", 
            RowBox[{"ltuQ", "[", 
             RowBox[{
              RowBox[{"{", "v", "}"}], ",", 
              RowBox[{"{", 
               OverscriptBox["0", "^"], "}"}]}], "]"}]}]}], ")"}]}], ",", 
        "ub", ",", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ltuQ", "[", 
           RowBox[{
            RowBox[{"{", "u", "}"}], ",", 
            RowBox[{"{", 
             OverscriptBox["0", "^"], "}"}]}], "]"}], "\[And]", 
          RowBox[{"ltuQ", "[", 
           RowBox[{
            RowBox[{"{", "v", "}"}], ",", 
            RowBox[{"{", 
             OverscriptBox["0", "^"], "}"}]}], "]"}]}], ")"}], ",", 
        RowBox[{"negateu", "[", 
         RowBox[{"unifypos", "[", 
          RowBox[{"negateu", "[", "ub", "]"}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "If", " ", "the", " ", "bounds", " ", "represent", " ", "the", " ",
             "same", " ", "value"}], ",", " ", 
           RowBox[{"use", " ", "the", " ", "smaller", " ", "bit", " ", 
            RowBox[{"string", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"u2g", "[", "u", "]"}], "===", 
         RowBox[{"u2g", "[", "v", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"Min", "[", 
          RowBox[{"u", ",", "v"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
        "True", ",", 
        RowBox[{"unifypos", "[", "ub", "]"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Unify", " ", "if", " ", "information"}], "-", "per", "-", 
      RowBox[{"bit", " ", "improves", " ", "by", " ", "at", " ", "least", " ", 
       RowBox[{"\"\<ratio\>\"", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"smartunify", "[", 
     RowBox[{"ub_", ",", "ratio_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g", "=", 
         RowBox[{"u2g", "[", "ub", "]"}]}], ",", 
        RowBox[{"v", "=", 
         RowBox[{"unify", "[", "ub", "]"}]}], ",", "widthbefore", ",", 
        "widthafter", ",", "nbitsbefore", ",", "nbitsafter"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"widthbefore", "=", 
        RowBox[{
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "-", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"widthafter", "=", 
        RowBox[{
         SubscriptBox[
          RowBox[{"u2g", "[", "v", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "-", 
         SubscriptBox[
          RowBox[{"u2g", "[", "v", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nbitsbefore", "=", 
        RowBox[{"nbits", "[", "ub", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nbitsafter", "=", 
        RowBox[{"nbits", "[", "v", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", 
        RowBox[{
         RowBox[{"widthafter", "\[Equal]", "\[Infinity]"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ratio", "\[GreaterEqual]", "1"}], ",", "v", ",", "ub"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"widthafter", "\[Equal]", "0"}], ",", "v", ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            FractionBox["widthbefore", "widthafter"], ")"}], 
           RowBox[{"(", 
            FractionBox["nbitsbefore", "nbitsafter"], ")"}]}], 
          "\[GreaterEqual]", "ratio"}], ",", "v", ",", "\[IndentingNewLine]", 
         "True", ",", "ub"}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Find", " ", "the", " ", "left", " ", "half", " ", "of", " ", "a", " ", 
      "ubound", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"numerical", " ", "value", " ", "and", " ", "open"}], "-", 
         RowBox[{"closed", " ", "bit"}]}], ")"}], "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ubleft", "[", "xleft_List", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"open", "=", 
         SubscriptBox["xleft", 
          RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
        ",", 
        RowBox[{"u", "=", 
         RowBox[{"x2u", "[", 
          SubscriptBox["xleft", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}]}], ",", 
        RowBox[{"x", "=", 
         SubscriptBox["xleft", 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}]}],
        "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "\[Equal]", 
         RowBox[{"-", "\[Infinity]"}]}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"open", ",", "negopeninfu", ",", "neginfu"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"u2f", "[", "u", "]"}], "===", "x"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"open", ",", 
          RowBox[{"BitOr", "[", 
           RowBox[{
            RowBox[{"u", "-", 
             RowBox[{"ulpu", " ", 
              RowBox[{"Boole", "[", 
               RowBox[{"x", "<", "0"}], "]"}]}]}], ",", " ", "ubitmask"}], 
           "]"}], ",", "u"}], "]"}], ",", "\[IndentingNewLine]", "True", ",", 
        
        RowBox[{"BitOr", "[", 
         RowBox[{"u", ",", 
          RowBox[{
           RowBox[{"Boole", "[", "open", "]"}], " ", "ubitmask"}]}], "]"}]}], 
       "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Find", " ", "the", " ", "right", " ", "half", " ", "of", " ", "a", " ",
        "ubound", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"numerical", " ", "value", " ", "and", " ", "open"}], "-", 
          RowBox[{"closed", " ", "bit"}]}], ")"}], ".", " ", "Not"}], " ", 
       "exactly", " ", "the", " ", "reverse", " ", "of", " ", "ubleft"}], ",",
       " ", 
      RowBox[{"because", " ", "of", " ", 
       RowBox[{"\"\<negative zero\>\"", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"ubright", "[", "xright_List", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"open", "=", 
         SubscriptBox["xright", 
          RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
        ",", 
        RowBox[{"u", "=", 
         RowBox[{"x2u", "[", 
          SubscriptBox["xright", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}]}], ",", 
        RowBox[{"x", "=", 
         SubscriptBox["xright", 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}]}],
        "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "\[Equal]", "\[Infinity]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"open", ",", "posopeninfu", ",", "posinfu"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", "\[Equal]", "0"}], "\[And]", "open"}], ",", 
        "negopenzerou", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"u2f", "[", "u", "]"}], "===", "x"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{"open", ",", 
          RowBox[{"BitOr", "[", 
           RowBox[{
            RowBox[{"u", "-", 
             RowBox[{"ulpu", " ", 
              RowBox[{"Boole", "[", 
               RowBox[{"x", "\[GreaterEqual]", "0"}], "]"}]}]}], ",", " ", 
            "ubitmask"}], "]"}], ",", "u"}], "]"}], ",", 
        "\[IndentingNewLine]", "True", ",", 
        RowBox[{"BitOr", "[", 
         RowBox[{"u", ",", 
          RowBox[{
           RowBox[{"Boole", "[", "open", "]"}], " ", "ubitmask"}]}], "]"}]}], 
       "]"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Convert", " ", "a", " ", "general", " ", "interval", " ", "to", " ", 
      "the", " ", "closest", " ", "possible", " ", 
      RowBox[{"ubound", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"g2u", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ulo", "=", 
         OverscriptBox[
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "^"]}], ",", 
        
        RowBox[{"uhi", "=", 
         OverscriptBox[
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "^"]}], ",", 
        
        RowBox[{"blo", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"bhi", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
      ",", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
        "Get", " ", "rid", " ", "of", " ", "the", " ", "NaN", " ", "cases", 
         " ", "first"}], " ", "*)"}],
       FontColor->RGBColor[
        0.5000076295109483, 0.5000076295109483, 0.5000076295109483]], " ", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ulo", "\[Equal]", "qNaNu"}], "\[Or]", 
         RowBox[{"uhi", "===", "qNaNu"}], "\[Or]", 
         RowBox[{
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ">", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SubscriptBox["g", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
            SubscriptBox["g", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[And]", 
           RowBox[{"(", 
            RowBox[{"blo", "\[Or]", "bhi"}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", "qNaNu", "}"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "If", " ", "both", " ", "unums", " ", "are", " ", "identical"}], 
           ",", " ", 
           RowBox[{
           "and", " ", "both", " ", "open", " ", "or", " ", "both", " ", 
            "closed"}], ",", " ", 
           RowBox[{
            RowBox[{"we", " ", "have", " ", "a", " ", "single"}], "-", 
            RowBox[{"unum", " ", 
             RowBox[{"bound", "."}]}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ulo", "\[Equal]", "uhi"}], "\[And]", 
         RowBox[{"\[Not]", 
          RowBox[{"(", 
           RowBox[{"blo", "\[Xor]", "bhi"}], ")"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"x2u", "[", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "]"}], "}"}],
         ",", "\[IndentingNewLine]", "True", ",", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"u1", "=", 
             RowBox[{"ubleft", "[", 
              RowBox[{"{", 
               RowBox[{
                SubscriptBox["g", 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                "blo"}], "}"}], "]"}]}], ",", 
            RowBox[{"u2", "=", 
             RowBox[{"ubright", "[", 
              RowBox[{"{", 
               RowBox[{
                SubscriptBox["g", 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
                "bhi"}], "}"}], "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
          
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"u2g", "[", 
              RowBox[{"unify", "[", 
               RowBox[{"{", 
                RowBox[{"u1", ",", "u2"}], "}"}], "]"}], "]"}], "===", 
             RowBox[{"u2g", "[", 
              RowBox[{"{", 
               RowBox[{"u1", ",", "u2"}], "}"}], "]"}]}], ",", 
            RowBox[{"unify", "[", 
             RowBox[{"{", 
              RowBox[{"u1", ",", "u2"}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"u1", ",", "u2"}], "}"}]}], "]"}]}], "]"}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "interval", " ", "g", " ", "is", " ", "strictly",
       " ", "less", " ", "than", " ", "interval", " ", 
      RowBox[{"h", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ltgQ", "[", 
     RowBox[{
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], ",", 
      RowBox[{"h_", "/;", 
       RowBox[{"gQ", "[", "h", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", 
        "NaN"}]}], ",", "False", ",", "\[IndentingNewLine]", "True", ",", 
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "<", 
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "==", 
          SubscriptBox["h", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "\[And]", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], "\[Or]", 
           SubscriptBox["h", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ")"}]}], 
        ")"}]}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "ubound", " ", "or", " ", "unum", " ", "u", " ", 
      "is", " ", "strictly", " ", "less", " ", "than", " ", "ubound", " ", 
      "or", " ", "unum", " ", 
      RowBox[{"v", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ltuQ", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"ltgQ", "[", 
     RowBox[{
      RowBox[{"u2g", "[", "u", "]"}], ",", 
      RowBox[{"u2g", "[", "v", "]"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Assign", " ", "the", " ", "\"\<less than\>\"", " ", "test", " ", "the", 
      " ", "\"\<\[Precedes]\>\"", " ", "infix", " ", 
      RowBox[{"symbol", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Precedes", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"ltuQ", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "interval", " ", "g", " ", "is", " ", "strictly",
       " ", "greater", " ", "than", " ", "interval", " ", 
      RowBox[{"h", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gtgQ", "[", 
     RowBox[{
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], ",", 
      RowBox[{"h_", "/;", 
       RowBox[{"gQ", "[", "h", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", 
        "NaN"}]}], ",", "False", ",", "\[IndentingNewLine]", "True", ",", 
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ">", 
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "==", 
          SubscriptBox["h", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[And]", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], "\[Or]", 
           SubscriptBox["h", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], ")"}]}], 
        ")"}]}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "ubound", " ", "or", " ", "unum", " ", "u", " ", 
      "is", " ", "strictly", " ", "greater", " ", "than", " ", "ubound", " ", 
      "or", " ", "unum", " ", 
      RowBox[{"v", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gtuQ", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"gtgQ", "[", 
     RowBox[{
      RowBox[{"u2g", "[", "u", "]"}], ",", 
      RowBox[{"u2g", "[", "v", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Assign", " ", "the", " ", "\"\<greater than\>\"", " ", "test", " ", 
      "the", " ", "\"\<\[Succeeds]\>\"", " ", "infix", " ", 
      RowBox[{"symbol", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"Succeeds", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"gtuQ", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "interval", " ", "g", " ", "is", " ", "nowhere", 
      " ", "equal", " ", "to", " ", "interval", " ", 
      RowBox[{"h", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"neqgQ", "[", 
     RowBox[{
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], ",", 
      RowBox[{"h_", "/;", 
       RowBox[{"gQ", "[", "h", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", 
        "NaN"}]}], ",", "False", ",", "\[IndentingNewLine]", "True", ",", 
      RowBox[{
       RowBox[{"ltgQ", "[", 
        RowBox[{"g", ",", "h"}], "]"}], "\[Or]", 
       RowBox[{"gtgQ", "[", 
        RowBox[{"g", ",", "h"}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "ubound", " ", "or", " ", "unum", " ", "u", " ", 
      "is", " ", "nowhere", " ", "equal", " ", "to", " ", "ubound", " ", "or",
       " ", "unum", " ", 
      RowBox[{"v", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nequQ", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"neqgQ", "[", 
     RowBox[{
      RowBox[{"u2g", "[", "u", "]"}], ",", 
      RowBox[{"u2g", "[", "v", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Assign", " ", "the", " ", "\"\<nowhere equal\>\"", " ", "test", " ", 
      "the", " ", "\"\<\[NotTildeTilde]\>\"", " ", "infix", " ", 
      RowBox[{"symbol", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NotTildeTilde", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"nequQ", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "interval", " ", "g", " ", "is", " ", "not", " ",
       "nowhere", " ", "equal", " ", "to", " ", "interval", " ", 
      RowBox[{"h", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nneqgQ", "[", 
     RowBox[{
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], ",", 
      RowBox[{"h_", "/;", 
       RowBox[{"gQ", "[", "h", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["h", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", 
        "NaN"}]}], ",", "False", ",", "\[IndentingNewLine]", "True", ",", 
      RowBox[{"\[Not]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ltgQ", "[", 
          RowBox[{"g", ",", "h"}], "]"}], "\[Or]", 
         RowBox[{"gtgQ", "[", 
          RowBox[{"g", ",", "h"}], "]"}]}], ")"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "ubound", " ", "or", " ", "unum", " ", "u", " ", 
      "is", " ", "not", " ", "nowhere", " ", "equal", " ", "to", " ", 
      "ubound", " ", "or", " ", "unum", " ", 
      RowBox[{"v", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nnequQ", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"nneqgQ", "[", 
     RowBox[{
      RowBox[{"u2g", "[", "u", "]"}], ",", 
      RowBox[{"u2g", "[", "v", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Assign", " ", "not", " ", "nowhere", " ", "equal", " ", "test", " ", 
      "the", " ", "\"\<\[NotTildeTilde]\>\"", " ", "infix", " ", 
      RowBox[{"symbol", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TildeTilde", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"nnequQ", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "interval", " ", "g", " ", "is", " ", 
      "identical", " ", "to", " ", "interval", " ", 
      RowBox[{"h", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"samegQ", "[", 
     RowBox[{
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], ",", 
      RowBox[{"h_", "/;", 
       RowBox[{"gQ", "[", "h", "]"}]}]}], "]"}], ":=", 
    RowBox[{"g", "===", "h"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "ubound", " ", "or", " ", "unum", " ", "u", " ", 
      "value", " ", "is", " ", "identical", " ", "to", " ", "ubound", " ", 
      "or", " ", "unum", " ", "v", " ", 
      RowBox[{"value", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sameuQ", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"samegQ", "[", 
     RowBox[{
      RowBox[{"u2g", "[", "u", "]"}], ",", 
      RowBox[{"u2g", "[", "v", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Assign", " ", "the", " ", "\"\<identical\>\"", " ", "test", " ", "the", 
      " ", "\"\<\[Congruent]\>\"", " ", "infix", " ", 
      RowBox[{"symbol", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Congruent", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"sameuQ", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Find", " ", "the", " ", "intersection", " ", "of", " ", "two", " ", 
       "general", " ", "intervals", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"intersectg", "[", 
     RowBox[{
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], ",", 
      RowBox[{"h_", "/;", 
       RowBox[{"gQ", "[", "h", "]"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
    
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"glo", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"ghi", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"glob", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"ghib", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"hlo", "=", 
         SubscriptBox["h", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"hhi", "=", 
         SubscriptBox["h", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"hlob", "=", 
         SubscriptBox["h", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"hhib", "=", 
         SubscriptBox["h", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
      ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"glo", "===", "NaN"}], "\[Or]", 
         RowBox[{"ghi", "===", "NaN"}], "\[Or]", 
         RowBox[{"hlo", "===", "NaN"}], "\[Or]", 
         RowBox[{"hhi", "===", "NaN"}]}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"glo", "<", "hlo"}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"glo", "\[Equal]", "hlo"}], "\[And]", "hlob"}], ")"}]}], 
        ",", " ", 
        RowBox[{"Which", "[", 
         StyleBox[" ",
          FontColor->GrayLevel[0.5]], 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "left", " ", "end", " ", "of", " ", "g", " ", "is", " ", "left", 
             " ", "of", " ", "left", " ", "end", " ", "of", " ", 
             RowBox[{"h", ".", " ", "Three"}], " ", "sub"}], "-", 
            RowBox[{"cases", " ", "to", " ", 
             RowBox[{"test", "."}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"ghi", "<", "hlo"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ghi", "\[Equal]", "hlo"}], "\[And]", 
             RowBox[{"(", 
              RowBox[{"ghib", "\[Or]", "hlob"}], ")"}]}], ")"}]}], ",", 
          GridBox[{
            {"NaN", "NaN"},
            {"open", "open"}
           }], ",", " ", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
            "g", " ", "is", " ", "completely", " ", "left", " ", "of", " ", 
             RowBox[{"h", "."}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ghi", "<", "hhi"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ghi", "\[Equal]", "hhi"}], "\[And]", 
             RowBox[{"(", 
              RowBox[{"ghib", "\[Or]", 
               RowBox[{"\[Not]", "hhib"}]}], ")"}]}], ")"}]}], ",", GridBox[{
            {"hlo", "ghi"},
            {"hlob", "ghib"}
           }], ",", " ", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
            "right", " ", "part", " ", "of", " ", "g", " ", "overlaps", " ", 
             "left", " ", "part", " ", "of", " ", 
             RowBox[{"h", "."}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
          GridBox[{
            {"hlo", "hhi"},
            {"hlob", "hhib"}
           }]}], "]"}], ",", " ", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{"h", " ", "is", " ", "entirely", " ", "inside", " ", 
           RowBox[{"g", "."}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"glo", "<", "hhi"}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"glo", "\[Equal]", "hhi"}], "\[And]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Not]", "glob"}], "\[And]", 
             RowBox[{"\[Not]", "hhib"}]}], ")"}]}], ")"}]}], ",", " ", 
        RowBox[{"Which", "[", " ", 
         StyleBox[
          RowBox[{
           StyleBox[
            RowBox[{"(", 
             StyleBox["*",
              FontColor->GrayLevel[0.5]]}]], " ", 
           RowBox[{
            RowBox[{
            "left", " ", "end", " ", "of", " ", "g", " ", "is", " ", "inside",
              " ", 
             RowBox[{"h", ".", " ", "Two"}], " ", "sub"}], "-", 
            RowBox[{"cases", " ", "to", " ", 
             RowBox[{"test", "."}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"ghi", "<", "hhi"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ghi", "\[Equal]", "hhi"}], "\[And]", 
             RowBox[{"(", 
              RowBox[{"ghib", "\[Or]", 
               RowBox[{"\[Not]", "hhib"}]}], ")"}]}], ")"}]}], ",", GridBox[{
            {"glo", "ghi"},
            {"glob", "ghib"}
           }], ",", " ", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{"g", " ", "is", " ", "entirely", " ", "inside", " ", 
             RowBox[{"h", "."}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
          GridBox[{
            {"glo", "hhi"},
            {"glob", "hhib"}
           }]}], "]"}], ",", " ", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
          "left", " ", "end", " ", "of", " ", "g", " ", "overlaps", " ", 
           "right", " ", "end", " ", "of", " ", 
           RowBox[{"h", "."}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
        GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }]}], "]"}]}], " ", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{
       "g", " ", "is", " ", "entirely", " ", "to", " ", "the", " ", "right", 
        " ", "of", " ", 
        RowBox[{"h", "."}]}], " ", "*)"}],
      FontColor->GrayLevel[0.5]], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Intersect", " ", "two", " ", "ubounds", " ", "or", " ", 
      RowBox[{"unums", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"intersectu", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"g2u", "[", 
     RowBox[{"intersectg", "[", 
      RowBox[{
       RowBox[{"u2g", "[", "u", "]"}], ",", 
       RowBox[{"u2g", "[", "v", "]"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Produce", " ", "a", " ", "report", " ", "of", " ", "numbers", " ", 
       "moved"}], ",", " ", 
      RowBox[{"bits", " ", "moved"}], ",", " ", 
      RowBox[{"and", " ", "bits", " ", "per", " ", 
       RowBox[{"number", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"reportdatamotion", "[", 
     RowBox[{"numbersmoved_", ",", "ubitsmoved_"}], "]"}], ":=", 
    RowBox[{"Grid", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<Numbers moved\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
          RowBox[{"Style", "[", 
           RowBox[{"numbersmoved", ",", "\"\<Text\>\""}], "]"}]}], "}"}], ",",
         "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<Unum bits moved\>\"", ",", "\"\<Text\>\""}], "]"}], 
          ",", 
          RowBox[{"Style", "[", 
           RowBox[{"ubitsmoved", ",", "\"\<Text\>\""}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Average bits per number\>\"", ",", "\"\<Text\>\"", ",", 
            "Bold"}], "]"}], ",", 
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{
              RowBox[{"ubitsmoved", "/", "numbersmoved"}], ",", "3"}], "]"}], 
            ",", "\"\<Text\>\"", ",", "Bold"}], "]"}]}], "}"}]}], "}"}], ",", 
      
      RowBox[{"Frame", "\[Rule]", "All"}], ",", 
      RowBox[{"Background", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"LightGreen", ",", "None"}], "}"}], "}"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Add", " ", "two", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"plusg", "[", 
     RowBox[{GridBox[{
        {"xlo_", "xhi_"},
        {"xlob_", "xhib_"}
       }], ",", GridBox[{
        {"ylo_", "yhi_"},
        {"ylob_", "yhib_"}
       }]}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "sumleft", ",", "sumright", ",", "openleft", ",", "openright"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "If", " ", "any", " ", "value", " ", "is", " ", "Indeterminate"}], 
          ",", " ", 
          RowBox[{"the", " ", "result", " ", "is", " ", "also", " ", 
           RowBox[{"Indeterminate", "."}]}]}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"xlo", "===", "NaN"}], "\[Or]", 
         RowBox[{"xhi", "===", "NaN"}], "\[Or]", 
         RowBox[{"ylo", "===", "NaN"}], "\[Or]", 
         RowBox[{"yhi", "===", "NaN"}]}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", 
        RowBox[{"(", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{"Compute", " ", "left", " ", 
            RowBox[{"endpoint", ":"}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"sumleft", ",", "openleft"}], "}"}], "=", 
           RowBox[{"Which", "[", "\[IndentingNewLine]", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{
               "Cases", " ", "involving", " ", "exact", " ", "\[Infinity]", 
                " ", "or"}], " ", "-", 
               RowBox[{"\[Infinity]", ":"}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"xlo", "\[Equal]", 
               RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
              RowBox[{"\[Not]", "xlob"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"NaN", ",", "open"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "closed"}], "}"}]}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"ylo", "\[Equal]", 
               RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
              RowBox[{"\[Not]", "ylob"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"NaN", ",", "open"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "closed"}], "}"}]}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"xlo", "\[Equal]", 
              RowBox[{"-", "\[Infinity]"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "open"}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"ylo", "\[Equal]", 
              RowBox[{"-", "\[Infinity]"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "open"}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"What", "'"}], "s", " ", "left", " ", "is", " ", 
                 "the", " ", "arithmetic", " ", "case"}], ",", " ", 
                RowBox[{"done", " ", "with", " ", "extended", " ", 
                 RowBox[{"precision", "."}]}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], 
             StyleBox["\[IndentingNewLine]",
              FontColor->GrayLevel[0.5]], "True", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"xlo", "+", "ylo"}], ",", 
               RowBox[{"xlob", "\[Or]", "ylob"}]}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Compute", " ", "right", " ", "endpoint"}], ",", " ", 
             RowBox[{"using", " ", "similar", " ", 
              RowBox[{"logic", ":"}]}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"sumright", ",", "openright"}], "}"}], "=", 
           RowBox[{"Which", "[", "\[IndentingNewLine]", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{
               "Cases", " ", "involving", " ", "exact", " ", "\[Infinity]", 
                " ", "or"}], " ", "-", 
               RowBox[{"\[Infinity]", ":"}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"xhi", "\[Equal]", 
               RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
              RowBox[{"\[Not]", "xhib"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"NaN", ",", "open"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "closed"}], "}"}]}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"yhi", "\[Equal]", 
               RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
              RowBox[{"\[Not]", "yhib"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"NaN", ",", "open"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "closed"}], "}"}]}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "\[Infinity]"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}], "\[Or]", 
              RowBox[{
               RowBox[{"yhi", "\[Equal]", "\[Infinity]"}], "\[And]", 
               RowBox[{"\[Not]", "yhib"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"xhi", "\[Equal]", "\[Infinity]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"yhi", "\[Equal]", 
                 RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "closed"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"yhi", "\[Equal]", "\[Infinity]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"xhi", "\[Equal]", 
                 RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], ",", "closed"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", "True", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"xhi", "+", "yhi"}], ",", 
               RowBox[{"xhib", "\[Or]", "yhib"}]}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"sumleft", ",", "sumright"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"openleft", ",", "openright"}], "}"}]}], "}"}]}], 
         ")"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Addition", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], 
      ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "numbers", " ", "moved", " ", 
       "and", " ", "bits", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"plusu", "[", 
      RowBox[{
       RowBox[{"u_", "/;", 
        RowBox[{"uQ", "[", "u", "]"}]}], ",", 
       RowBox[{"v_", "/;", 
        RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"w", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"plusg", "[", 
           RowBox[{
            RowBox[{"u2g", "[", "u", "]"}], ",", 
            RowBox[{"u2g", "[", "v", "]"}]}], "]"}], "]"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ubitsmoved", "+=", 
         RowBox[{
          RowBox[{"nbits", "[", "u", "]"}], "+", 
          RowBox[{"nbits", "[", "v", "]"}], "+", 
          RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
        RowBox[{"numbersmoved", "+=", "3"}], ";", "w"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Assign", " ", "the", " ", "\"\<\[CirclePlus]\>\"", " ", "infix", " ", 
       "operator", " ", "to", " ", "u"}], "-", 
      RowBox[{"level", " ", 
       RowBox[{"subtraction", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CirclePlus", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"plusu", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Negate", " ", "a", " ", "general", " ", 
      RowBox[{"interval", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"negateg", "[", GridBox[{
       {"x_", "y_"},
       {"xb_", "yb_"}
      }], "]"}], ":=", GridBox[{
      {
       RowBox[{"-", "y"}], 
       RowBox[{"-", "x"}]},
      {"yb", "xb"}
     }]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Subtraction", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"minusg", "[", 
     RowBox[{GridBox[{
        {"xlo_", "xhi_"},
        {"xlob_", "xhib_"}
       }], ",", GridBox[{
        {"ylo_", "yhi_"},
        {"ylob_", "yhib_"}
       }]}], "]"}], ":=", 
    RowBox[{"plusg", "[", 
     RowBox[{GridBox[{
        {"xlo", "xhi"},
        {"xlob", "xhib"}
       }], ",", 
      RowBox[{"negateg", "[", GridBox[{
         {"ylo", "yhi"},
         {"ylob", "yhib"}
        }], "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Subtraction", " ", "in", " ", "the", " ", "u"}], "-", 
       "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "numbers", " ", "moved", " ", 
       "and", " ", "bits", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"minusu", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", "=", 
        RowBox[{"g2u", "[", 
         RowBox[{"minusg", "[", 
          RowBox[{
           RowBox[{"u2g", "[", "u", "]"}], ",", 
           RowBox[{"u2g", "[", "v", "]"}]}], "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}], "+", 
         RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "3"}], ";", "w"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Assign", " ", "the", " ", "\"\<\[CircleMinus]\>\"", " ", "infix", " ", 
       "operator", " ", "to", " ", "u"}], "-", 
      RowBox[{"level", " ", 
       RowBox[{"subtraction", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CircleMinus", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"minusu", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Initialize", " ", "the", " ", "tallies", " ", "so", " ", "Mathematica", 
      " ", "treats", " ", "them", " ", "as", " ", "numerical", " ", 
      RowBox[{"values", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ubitsmoved", "=", 
     RowBox[{"numbersmoved", "=", "0"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Check", " ", "if", " ", "we", " ", "have", " ", "hit", " ", "the", " ", 
      "dynamic", " ", "range", " ", 
      RowBox[{"limits", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"needmoreexpQ", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"g", "=", 
         RowBox[{"u2g", "[", "u", "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SubscriptBox["g", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               RowBox[{"-", "maxreal"}]}], "\[Or]", 
              RowBox[{
               SubscriptBox["g", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               RowBox[{"-", "smallsubnormal"}]}]}], ")"}], "\[And]", 
            SubscriptBox["g", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ")"}], 
          "\[Or]", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SubscriptBox["g", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", "maxreal"}], "\[Or]", 
              RowBox[{
               SubscriptBox["g", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", "smallsubnormal"}]}], ")"}], "\[And]", 
            SubscriptBox["g", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], ")"}]}], 
         ",", "True", ",", "False"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Find", " ", "the", " ", "relative", " ", "width", " ", "in", " ", "a", 
      " ", "unum", " ", "or", " ", 
      RowBox[{"ubound", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"relwidth", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"lo", "=", 
          SubscriptBox[
           RowBox[{"(", 
            RowBox[{"u2g", "[", "u", "]"}], ")"}], 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"hi", "=", 
          SubscriptBox[
           RowBox[{"(", 
            RowBox[{"u2g", "[", "u", "]"}], ")"}], 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
       ",", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"lo", "===", "NaN"}], ",", "\[Infinity]", ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", "lo", "]"}], "\[Equal]", "\[Infinity]"}], 
          "\[Or]", 
          RowBox[{
           RowBox[{"Abs", "[", "hi", "]"}], "\[Equal]", "\[Infinity]"}]}], 
         ",", "1", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"lo", "\[Equal]", "0"}], "\[And]", 
          RowBox[{"hi", "\[Equal]", "0"}]}], ",", "0", ",", 
         "\[IndentingNewLine]", "True", ",", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"hi", "-", "lo"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Abs", "[", "lo", "]"}], "+", 
            RowBox[{"Abs", "[", "hi", "]"}]}], ")"}]}]}], "]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Test", " ", "if", " ", "a", " ", "larger", " ", "fraction", " ", 
      "field", " ", "is", " ", 
      RowBox[{"needed", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"needmorefracQ", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"relwidth", "[", "u", "]"}], ">", "relwidthtolerance"}], ",", 
      "True", ",", "False"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Default", " ", "setting", " ", "for", " ", "relative", " ", "width", 
      " ", "tolerance", " ", "is", " ", "three", " ", 
      RowBox[{"decimals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"relwidthtolerance", "=", "0.001"}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "The", " ", "\"\<left\>\"", " ", "multiplication", " ", "table", " ", 
      "for", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"timesposleft", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "xb_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y_", ",", "yb_"}], "}"}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "\[Times]", "y"}], ",", 
        RowBox[{"xb", "\[Or]", "yb"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "The", " ", "\"\<right\>\"", " ", "multiplication", " ", "table", " ", 
      "for", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"timesposright", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "xb_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y_", ",", "yb_"}], "}"}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "closed"}], "}"}], ",", "\[IndentingNewLine]", 
      "True", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "\[Times]", "y"}], ",", 
        RowBox[{"xb", "\[Or]", "yb"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Helper", " ", "function", " ", "for", " ", "times"}], ";", " ", 
      RowBox[{
      "negates", " ", "numerical", " ", "part", " ", "of", " ", "an", " ", 
       RowBox[{"endpoint", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"neg", "[", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "xb_"}], "}"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "x"}], ",", "xb"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "The", " ", "following", " ", "fixes", " ", "a", " ", "bug", " ", "in", 
       " ", "Mathematica"}], ",", " ", 
      RowBox[{
       RowBox[{"which", " ", "orders"}], " ", "-", 
       RowBox[{
       "\[Infinity]", " ", "as", " ", "\"\<greater\>\"", " ", "than", " ", 
        "any", " ", "numeric", " ", 
        RowBox[{"value", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"unionfix", "[", 
     RowBox[{"end1_", ",", "end2_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"temp", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"end1", ",", "end2"}], "]"}]}], ",", "e1", ",", "e2"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "temp", "]"}], "\[Equal]", "2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"e1", ",", "e2"}], "}"}], "=", "temp"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            SubscriptBox["temp", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], "===", 
            RowBox[{"-", "\[Infinity]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"e2", ",", "e1"}], "}"}], ",", "temp"}], "]"}]}], ",", 
        "\[IndentingNewLine]", "temp"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Multiplication", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"timesg", "[", 
     RowBox[{GridBox[{
        {"xlo_", "xhi_"},
        {"xlob_", "xhib_"}
       }], ",", GridBox[{
        {"ylo_", "yhi_"},
        {"ylob_", "yhib_"}
       }]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "timesleft", ",", "timesright", ",", "openleft", ",", "openright", ",", 
        RowBox[{"lcan", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"rcan", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"If", " ", "any", " ", "value", " ", "is", " ", "NaN"}], 
          ",", " ", 
          RowBox[{"the", " ", "result", " ", "is", " ", "also", " ", 
           RowBox[{"NaN", "."}]}]}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"xlo", "===", "NaN"}], "\[Or]", 
         RowBox[{"xhi", "===", "NaN"}], "\[Or]", 
         RowBox[{"ylo", "===", "NaN"}], "\[Or]", 
         RowBox[{"yhi", "===", "NaN"}]}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Lower", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
            "upper", " ", "right", " ", "quadrant"}], ",", " ", 
           RowBox[{"facing", " ", 
            RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xlo", "\[GreaterEqual]", "0"}], "\[And]", 
            RowBox[{"ylo", "\[GreaterEqual]", "0"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"timesposleft", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xlo", ",", "xlob"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"ylo", ",", "ylob"}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}], ")"}]}],
              ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", "yhib"}], ")"}]}],
              ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"timesposleft", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "xhi"}], ",", "xhib"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "yhi"}], ",", "yhib"}], "}"}]}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xlo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"timesposright", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "xlo"}], ",", "xlob"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"yhi", ",", "yhib"}], "}"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"timesposright", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xhi", ",", "xhib"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "ylo"}], ",", "ylob"}], "}"}]}], "]"}], 
                "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"timesposright", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xhi", ",", "xhib"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"yhi", ",", "yhib"}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xlo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"timesposright", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "xlo"}], ",", "xlob"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "ylo"}], ",", "ylob"}], "}"}]}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}], ")"}]}],
              ")"}], "\[And]", 
            RowBox[{"ylo", "\[GreaterEqual]", " ", "0"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"timesposleft", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "xhi"}], ",", "xhib"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"ylo", ",", "ylob"}], "}"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xlo", "\[GreaterEqual]", "0"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", "yhib"}], ")"}]}],
              ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"timesposleft", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xlo", ",", "xlob"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "yhi"}], ",", "yhib"}], "}"}]}], "]"}], 
                "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", "lcan", "]"}], ",", "NaN"}], "]"}], 
            "\[Or]", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", "rcan", "]"}], ",", "NaN"}], "]"}]}], 
           ",", 
           RowBox[{GridBox[{
              {"timesleft", "timesright"},
              {"openleft", "openright"}
             }], "=", GridBox[{
              {"NaN", "NaN"},
              {"open", "open"}
             }]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{GridBox[{
            {"timesleft", "timesright"},
            {"openleft", "openright"}
           }], "=", GridBox[{
            {
             SubscriptBox["lcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
             SubscriptBox["rcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]]},
            {
             SubscriptBox["lcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
             SubscriptBox["rcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "2"}], "\[RightDoubleBracket]"}]]}
           }]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "lcan", "]"}], ">", "1"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["lcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["lcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
              "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Not]", 
                 SubscriptBox["lcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                "\[Or]", 
                RowBox[{"\[Not]", 
                 SubscriptBox["lcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
               ")"}]}], ",", 
             RowBox[{"openleft", "=", "closed"}]}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "rcan", "]"}], ">", "1"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["rcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["rcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"-", "2"}], ",", "1"}], 
                 "\[RightDoubleBracket]"}]]}], "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Not]", 
                 SubscriptBox["rcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]]}], "\[Or]", 
                RowBox[{"\[Not]", 
                 SubscriptBox["rcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"-", "2"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]]}]}], ")"}]}], ",", 
             RowBox[{"openright", "=", "closed"}]}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", GridBox[{
           {"timesleft", "timesright"},
           {"openleft", "openright"}
          }]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Multiplication", " ", "in", " ", "the", " ", "u"}], "-", 
       "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"timesu", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", "=", 
        RowBox[{"g2u", "[", 
         RowBox[{"timesg", "[", 
          RowBox[{
           RowBox[{"u2g", "[", "u", "]"}], ",", 
           RowBox[{"u2g", "[", "v", "]"}]}], "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}], "+", 
         RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "3"}], ";", "w"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Assignment", " ", "of", " ", "u"}], "-", 
      RowBox[{
      "layer", " ", "multiplication", " ", "to", " ", "the", " ", 
       "\"\<\[CircleTimes]\>\"", " ", 
       RowBox[{"symbol", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CircleTimes", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"timesu", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{"Test", " ", "if", " ", "a", " ", "ubound", " ", "spans", " ", 
      RowBox[{"zero", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"spanszeroQ", "[", 
     RowBox[{"ub_", "/;", 
      RowBox[{"uboundQ", "[", "ub", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g1", "=", 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{"u2g", "[", "ub", "]"}], ")"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"g2", "=", 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{"u2g", "[", "ub", "]"}], ")"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b1", "=", 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{"u2g", "[", "ub", "]"}], ")"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b2", "=", 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{"u2g", "[", "ub", "]"}], ")"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
      ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"g1", "\[Equal]", "0"}], "\[And]", 
            RowBox[{"\[Not]", "b1"}]}], "\[Or]", 
           RowBox[{
            RowBox[{"g2", "\[Equal]", "0"}], "\[And]", 
            RowBox[{"\[Not]", "b2"}]}]}], ")"}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"g1", "<", "0"}], "\[And]", 
           RowBox[{"g2", ">", "0"}]}], ")"}]}], ",", "True", ",", "False"}], 
       "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "The", " ", "\"\<left\>\"", " ", "division", " ", "table", " ", "for", 
      " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"divideposleft", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "xb_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y_", ",", "yb_"}], "}"}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"NaN", ",", "open"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "closed"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "open"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "open"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "open"}], "}"}], ",", "\[IndentingNewLine]", "True", 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "/", "y"}], ",", 
        RowBox[{"xb", "\[Or]", "yb"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "The", " ", "\"\<right\>\"", " ", "division", " ", "table", " ", "for", 
      " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"divideposright", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x_", ",", "xb_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y_", ",", "yb_"}], "}"}]}], "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"NaN", ",", "open"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "closed"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "open"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Infinity]", ",", "open"}], "}"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "/", "y"}], ",", 
        RowBox[{"xb", "\[Or]", "yb"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Division", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"divideg", "[", 
     RowBox[{GridBox[{
        {"xlo_", "xhi_"},
        {"xlob_", "xhib_"}
       }], ",", GridBox[{
        {"ylo_", "yhi_"},
        {"ylob_", "yhib_"}
       }]}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "divleft", ",", "divright", ",", "openleft", ",", "openright", ",", 
        RowBox[{"lcan", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"rcan", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"If", " ", "any", " ", "value", " ", "is", " ", "NaN"}], 
          ",", " ", 
          RowBox[{"or", " ", "denominator", " ", "contains", " ", "0"}], ",", 
          " ", 
          RowBox[{"the", " ", "result", " ", "is", " ", "a", " ", 
           RowBox[{"NaN", "."}]}]}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"xlo", "===", "NaN"}], "\[Or]", 
         RowBox[{"xhi", "===", "NaN"}], "\[Or]", 
         RowBox[{"ylo", "===", "NaN"}], "\[Or]", 
         RowBox[{"yhi", "===", "NaN"}], "\[Or]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ylo", "<", "0"}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
              RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}], "\[And]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"yhi", ">", "0"}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
              RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}]}], ",", 
        GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Upper", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
            "upper", " ", "right", " ", "quadrant"}], ",", " ", 
           RowBox[{"facing", " ", 
            RowBox[{"uphill", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xlo", "\[GreaterEqual]", "  ", "0"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"divideposleft", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xlo", ",", "xlob"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"yhi", ",", "yhib"}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}], ")"}]}],
              ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"divideposleft", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "xhi"}], ",", "xhib"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "ylo"}], ",", "ylob"}], "}"}]}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xlo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"ylo", "\[GreaterEqual]", "0"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"divideposright", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "xlo"}], ",", "xlob"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"ylo", ",", "ylob"}], "}"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", "yhib"}], ")"}]}],
              ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"divideposright", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xhi", ",", "xhib"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "yhi"}], ",", "yhib"}], "}"}]}], "]"}], 
                "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"ylo", "\[GreaterEqual]", "0"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"divideposright", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xhi", ",", "xhib"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"ylo", ",", "ylob"}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xlo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", "yhib"}], ")"}]}],
              ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"divideposright", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "xlo"}], ",", "xlob"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "yhi"}], ",", "yhib"}], "}"}]}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}], ")"}]}],
              ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"divideposleft", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "xhi"}], ",", "xhib"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"yhi", ",", "yhib"}], "}"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xlo", "\[GreaterEqual]", "0"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"unionfix", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"neg", "[", 
                RowBox[{"divideposleft", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xlo", ",", "xlob"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "ylo"}], ",", "ylob"}], "}"}]}], "]"}], 
                "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", "lcan", "]"}], ",", "NaN"}], "]"}], 
            "\[Or]", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Flatten", "[", "rcan", "]"}], ",", "NaN"}], "]"}]}], 
           ",", 
           RowBox[{GridBox[{
              {"divleft", "divright"},
              {"openleft", "openright"}
             }], "=", GridBox[{
              {"NaN", "NaN"},
              {"open", "open"}
             }]}]}], "]"}], ";", 
         RowBox[{GridBox[{
            {"divleft", "divright"},
            {"openleft", "openright"}
           }], "=", GridBox[{
            {
             SubscriptBox["lcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
             SubscriptBox["rcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]]},
            {
             SubscriptBox["lcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
             SubscriptBox["rcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "2"}], "\[RightDoubleBracket]"}]]}
           }]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "lcan", "]"}], ">", "1"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["lcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["lcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
              "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Not]", 
                 SubscriptBox["lcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                "\[Or]", 
                RowBox[{"\[Not]", 
                 SubscriptBox["lcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
               ")"}]}], ",", 
             RowBox[{"openleft", "=", "closed"}]}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "rcan", "]"}], ">", "1"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["rcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["rcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"-", "2"}], ",", "1"}], 
                 "\[RightDoubleBracket]"}]]}], "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Not]", 
                 SubscriptBox["rcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]]}], "\[Or]", 
                RowBox[{"\[Not]", 
                 SubscriptBox["rcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"-", "2"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]]}]}], ")"}]}], ",", 
             RowBox[{"openright", "=", "closed"}]}], "]"}]}], "]"}], ";", 
         GridBox[{
           {"divleft", "divright"},
           {"openleft", "openright"}
          }]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Division", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], 
      ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"divideu", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"nbits", "[", "u", "]"}]}], ",", 
        RowBox[{"j", "=", 
         RowBox[{"nbits", "[", "v", "]"}]}], ",", 
        RowBox[{"w", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"divideg", "[", 
           RowBox[{
            RowBox[{"u2g", "[", "u", "]"}], ",", 
            RowBox[{"u2g", "[", "v", "]"}]}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}], "+", 
         RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "3"}], ";", "w"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Assignment", " ", "of", " ", "u"}], "-", 
      RowBox[{
      "layer", " ", "multiplication", " ", "to", " ", "the", " ", 
       "\"\<\[CircleDot]\>\"", " ", 
       RowBox[{"symbol", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CircleDot", "[", 
     RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
    RowBox[{"divideu", "[", 
     RowBox[{"u", ",", "v"}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Square", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"squareg", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"g2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
      ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"g1", "===", "Indeterminate"}], "\[Or]", 
         RowBox[{"g2", "===", "Indeterminate"}]}], ",", 
        RowBox[{"f2g", "[", "Indeterminate", "]"}], ",", 
        "\[IndentingNewLine]", "True", ",", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"t1", "=", 
             SuperscriptBox["g1", "2"]}], ",", 
            RowBox[{"t2", "=", 
             SuperscriptBox["g2", "2"]}], ",", "tset"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"tset", "=", 
            RowBox[{"Sort", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"t1", ",", "b1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"t2", ",", "b2"}], "}"}]}], "}"}], "]"}]}], ";", 
           RowBox[{"Which", "[", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{
              "See", " ", "if", " ", "0", " ", "is", " ", "in", " ", "the", 
               " ", "range"}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", "<", "0"}], "\[And]", 
                RowBox[{"g2", ">", "0"}]}], ")"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", ">", "0"}], "\[And]", 
                RowBox[{"g2", "<", "0"}]}], ")"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g1", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "b1"}]}], ")"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"g2", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "b2"}]}], ")"}]}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"t1", "\[Equal]", "t2"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", "t1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"closed", ",", 
                   RowBox[{"b1", "\[And]", "b2"}]}], "}"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"0", ",", 
                   SubscriptBox["tset", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"closed", ",", 
                   SubscriptBox["tset", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                  "}"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", "True",
              ",", 
             RowBox[{"Transpose", "[", "tset", "]"}]}], "]"}]}]}], "]"}]}], 
       "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Square", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], 
      ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"squareu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"nbits", "[", "u", "]"}]}], ",", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"squareg", "[", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Square", " ", "root", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sqrtg", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", "NaN"}],
        "\[Or]", 
       RowBox[{
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", "0"}]}], 
      ",", 
      RowBox[{"f2g", "[", "NaN", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SqrtBox[
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]], ",", 
          SqrtBox[
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], "}"}]}], 
       "}"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Square", " ", "root", " ", "in", " ", "the", " ", "u"}], "-", 
       "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"sqrtu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"nbits", "[", "u", "]"}]}], ",", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"sqrtg", "[", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "The", " ", "\"\<left\>\"", " ", "power", " ", "function", " ", "tables",
       " ", "for", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"powposleft", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x_", "/;", 
         RowBox[{"x", "\[GreaterEqual]", "1"}]}], ",", "xb_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"y_", "/;", 
         RowBox[{"y", "\[GreaterEqual]", "0"}]}], ",", "yb_"}], "}"}]}], 
     "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Infinity]", ",", "closed"}], "}"}], ",", 
      "\[IndentingNewLine]", "True", ",", 
      RowBox[{"{", 
       RowBox[{
        SuperscriptBox["x", "y"], ",", 
        RowBox[{"xb", "\[Or]", "yb"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "The", " ", "\"\<left\>\"", " ", "power", " ", "function", " ", "tables",
       " ", "for", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"powposright", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x_", "/;", 
         RowBox[{"x", "\[GreaterEqual]", "1"}]}], ",", "xb_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"y_", "/;", 
         RowBox[{"y", "\[GreaterEqual]", "0"}]}], ",", "yb_"}], "}"}]}], 
     "]"}], ":=", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"NaN", ",", "open"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y", ",", "yb"}], "}"}], "\[Equal]", 
       RowBox[{"{", 
        RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "xb"}], "}"}], "\[Equal]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "closed"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "closed"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Infinity]", ",", "open"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "xb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"1", ",", "closed"}], "}"}]}], "\[Or]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"y", ",", "yb"}], "}"}], "==", 
        RowBox[{"{", 
         RowBox[{"0", ",", "closed"}], "}"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "closed"}], "}"}], ",", "\[IndentingNewLine]", 
      "True", ",", 
      RowBox[{"{", 
       RowBox[{
        SuperscriptBox["x", "y"], ",", 
        RowBox[{"xb", "\[Or]", "yb"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Reciprocal", " ", "helper", " ", "function", " ", "for", " ", "the", 
      " ", "power", " ", 
      RowBox[{"function", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rec", "[", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "xb_"}], "}"}], "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Which", "[", 
       RowBox[{
        RowBox[{"x", "===", "NaN"}], ",", "NaN", ",", 
        RowBox[{"x", "\[Equal]", "0"}], ",", "\[Infinity]", ",", "True", ",", 
        
        RowBox[{"1", "/", "x"}]}], "]"}], ",", "xb"}], "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Power", " ", "function", " ", "in", " ", "the", " ", "g"}], 
      "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"powg", "[", 
     RowBox[{GridBox[{
        {"xlo_", "xhi_"},
        {"xlob_", "xhib_"}
       }], ",", GridBox[{
        {"ylo_", "yhi_"},
        {"ylob_", "yhib_"}
       }]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NaNg", "=", GridBox[{
           {"NaN", "NaN"},
           {"open", "open"}
          }]}], ",", 
        RowBox[{"lcan", "=", 
         RowBox[{"{", "}"}]}], ",", "openleft", ",", "openright", ",", 
        "powleft", ",", "powright", ",", 
        RowBox[{"rcan", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Which", "[", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"If", " ", "any", " ", "value", " ", "is", " ", "NaN"}], 
          ",", " ", 
          RowBox[{"the", " ", "result", " ", "is", " ", "also", " ", 
           RowBox[{"NaN", "."}]}]}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"xlo", "===", "NaN"}], "\[Or]", 
         RowBox[{"xhi", "===", "NaN"}], "\[Or]", 
         RowBox[{"ylo", "===", "NaN"}], "\[Or]", 
         RowBox[{"yhi", "===", "NaN"}]}], ",", "NaNg", ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Do", " ", "not", " ", "allow", " ", "exact", " ", "zero", " ", 
            "to", " ", "a", " ", "negative", " ", "or", " ", "zero", " ", 
            "power"}], ",", " ", 
           RowBox[{
           "unless", " ", "the", " ", "negative", " ", "power", " ", "is", 
            " ", "an", " ", "exact", " ", "even", " ", 
            RowBox[{"integer", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xlo", "<", "0"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", 
             RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xhi", ">", "0"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", 
             RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"ylo", "<", "0"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ylo", "==", "0"}], "\[And]", 
             RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}], "\[And]", 
         RowBox[{"\[Not]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ylo", "\[Equal]", "yhi"}], "\[And]", 
            RowBox[{"ylo", "<", "0"}], "\[And]", 
            RowBox[{"EvenQ", "[", "ylo", "]"}]}], ")"}]}]}], ",", "NaNg", ",",
         "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{"Weird", " ", 
           RowBox[{"case", ":", " ", 
            RowBox[{
            "complex", " ", "number", " ", "of", " ", "zero", " ", 
             "magnitude", " ", "is", " ", 
             RowBox[{"real", ".", " ", "Zero", "."}]}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"yhi", "\[Equal]", 
          RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
         RowBox[{"\[Not]", "yhib"}], "\[And]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xlo", ">", "1"}], "\[Or]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"xlo", "\[Equal]", "1"}], "\[And]", "xlob"}], ")"}]}], 
            ")"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xhi", "<", "1"}], "\[Or]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"xhi", "\[Equal]", "1"}], "\[And]", "xhib"}], ")"}]}], 
            ")"}]}], ")"}]}], ",", GridBox[{
          {"0", "0"},
          {"closed", "closed"}
         }], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "If", " ", "y", " ", "is", " ", "an", " ", "exact", " ", 
            "integer"}], ",", " ", 
           RowBox[{"loads", " ", "of", " ", "special", " ", 
            RowBox[{"cases", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ylo", "\[Equal]", "yhi"}], "\[And]", 
         RowBox[{"\[Not]", "ylob"}], "\[And]", 
         RowBox[{"\[Not]", "yhib"}], "\[And]", 
         RowBox[{"IntegerQ", "[", "ylo", "]"}]}], ",", "\[IndentingNewLine]", 
        
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
          "Finite", " ", "nonzero", " ", "numbers", " ", "to", " ", "the", 
           " ", "power", " ", "0", " ", "equals", " ", "1."}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{"ylo", "\[Equal]", "0"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"0", "<", "xlo"}], "\[Or]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"0", "\[Equal]", "xlo"}], "\[And]", "xlob"}], 
                 ")"}]}], ")"}], "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "<", "\[Infinity]"}], "\[Or]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"xhi", "\[Equal]", "\[Infinity]"}], "\[And]", 
                  "xhib"}], ")"}]}], ")"}]}], "\[Or]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "\[Infinity]"}], "<", "xlo"}], "\[Or]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "\[Infinity]"}], "\[Equal]", "xlo"}], 
                  "\[And]", "xlob"}], ")"}]}], ")"}], "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "<", "0"}], "\[Or]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}], 
                 ")"}]}], ")"}]}]}], ",", GridBox[{
              {"1", "1"},
              {"closed", "closed"}
             }], ",", "NaNg"}], "]"}], ",", "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
             "Positive", " ", "even", " ", "power", " ", "is", " ", "like", 
              " ", "square", " ", "function"}], ";", " ", 
             RowBox[{"test", " ", "for", " ", "zero", " ", 
              RowBox[{"straddle", "."}]}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"EvenQ", "[", "ylo", "]"}], "\[And]", 
           RowBox[{"ylo", ">", "0"}]}], ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"Which", "[", "\[IndentingNewLine]", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{"Range", " ", "is", " ", "strictly", " ", 
               RowBox[{"negative", ".", " ", "Order"}], " ", "of", " ", 
               "endpoints", " ", 
               RowBox[{"reverses", "."}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"xhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}], ")"}]}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 SuperscriptBox["xhi", "ylo"], ",", "xhib"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 SuperscriptBox["xlo", "ylo"], ",", "xlob"}], "}"}]}], "}"}], 
             ",", "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{"Range", " ", "is", " ", "strictly", " ", 
                RowBox[{"positive", ".", " ", "Endpoints"}], " ", "preserve", 
                " ", 
                RowBox[{"ordering", "."}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"xlo", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", "xlob"}], ")"}]}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 SuperscriptBox["xlo", "ylo"], ",", "xlob"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 SuperscriptBox["xhi", "ylo"], ",", "xhib"}], "}"}]}], "}"}], 
             ",", "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Range", " ", "straddles", " ", 
                 RowBox[{"zero", ".", " ", "Closed"}], " ", "zero", " ", "is",
                  " ", "lower", " ", 
                 RowBox[{"bound", ".", " ", "Larger"}], " ", 
                 SuperscriptBox["x", "y"], " ", "is", " ", "upper", " ", 
                 "bound"}], ",", " ", 
                RowBox[{
                "but", " ", "beware", " ", "of", " ", "ties", " ", "between", 
                 " ", "open", " ", "and", " ", 
                 RowBox[{"closed", "."}]}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
             
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"t1", "=", 
                  SuperscriptBox["xlo", "ylo"]}], ",", 
                 RowBox[{"t2", "=", 
                  SuperscriptBox["xhi", "ylo"]}]}], "}"}], ",", 
               RowBox[{"Which", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"t1", "<", "t2"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "closed"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"t2", ",", "xhib"}], "}"}]}], "}"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"t1", ">", "t2"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "closed"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"t1", ",", "xlob"}], "}"}]}], "}"}], ",", 
                 "\[IndentingNewLine]", "True", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "closed"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"t1", ",", 
                    RowBox[{"xlob", "\[And]", "xhib"}]}], "}"}]}], "}"}]}], 
                "]"}]}], "]"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Negative", " ", "even", " ", "power", " ", "includes"}],
              " ", "+", 
             RowBox[{"\[Infinity]", " ", "if", " ", "zero", " ", 
              RowBox[{"straddle", "."}]}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"EvenQ", "[", "ylo", "]"}], "\[And]", 
           RowBox[{"ylo", "<", "0"}]}], ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"Which", "[", "\[IndentingNewLine]", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{"Range", " ", "is", " ", "strictly", " ", 
               RowBox[{"positive", ".", " ", "Order"}], " ", "of", " ", 
               "endpoints", " ", 
               RowBox[{"reverses", "."}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"xlo", ">", "0"}], "\[Or]", 
              RowBox[{
               RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", "xlob"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 SuperscriptBox["xhi", "ylo"], ",", "xhib"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"xlo", "\[Equal]", "0"}], ",", "\[Infinity]", ",", 
                   
                   SuperscriptBox["xlo", "ylo"]}], "]"}], ",", "xlob"}], 
                "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{"Range", " ", "is", " ", "strictly", " ", 
                RowBox[{"negative", ".", " ", "Endpoints"}], " ", "preserve", 
                " ", 
                RowBox[{"ordering", "."}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"xhi", "<", "0"}], "\[Or]", 
              RowBox[{
               RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", "xhib"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 SuperscriptBox["xlo", "ylo"], ",", "xlob"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"xhi", "\[Equal]", "0"}], ",", "\[Infinity]", ",", 
                   
                   SuperscriptBox["xhi", "ylo"]}], "]"}], ",", "xhib"}], 
                "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"Range", " ", "straddles", " ", 
                 RowBox[{"zero", ".", " ", "Closed"}], " ", "infinity", " ", 
                 "is", " ", "upper", " ", 
                 RowBox[{"bound", ".", " ", "smaller"}], " ", 
                 SuperscriptBox["x", "y"], " ", "is", " ", "lower", " ", 
                 "bound"}], ",", " ", 
                RowBox[{
                "but", " ", "beware", " ", "of", " ", "ties", " ", "between", 
                 " ", "open", " ", "and", " ", 
                 RowBox[{"closed", "."}]}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
             
             RowBox[{"Module", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"t1", "=", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"xlo", "\[Equal]", "0"}], "\[And]", 
                    RowBox[{"ylo", "<", "0"}]}], ",", "\[Infinity]", ",", 
                    SuperscriptBox["xlo", "ylo"]}], "]"}]}], ",", 
                 RowBox[{"t2", "=", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"xhi", "\[Equal]", "0"}], "\[And]", 
                    RowBox[{"ylo", "<", "0"}]}], ",", "\[Infinity]", ",", 
                    SuperscriptBox["xhi", "ylo"]}], "]"}]}]}], "}"}], ",", 
               RowBox[{"Which", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"t1", ">", "t2"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"t2", ",", "xhib"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "}"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"t1", "<", "t2"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"t1", ",", "xlob"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "}"}], 
                 ",", "\[IndentingNewLine]", "True", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"t1", ",", 
                    RowBox[{"xlob", "\[And]", "xhib"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Infinity]", ",", "closed"}], "}"}]}], "}"}]}], 
                "]"}]}], "\[IndentingNewLine]", "]"}]}], "]"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{"That", " ", "leaves", " ", "odd", " ", "integer", " ", 
             RowBox[{"powers", ".", " ", "Preserves"}], " ", "ordering", " ", 
             "if", " ", 
             RowBox[{"positive", "."}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
          RowBox[{"ylo", ">", "0"}], ",", GridBox[{
            {
             SuperscriptBox["xlo", "ylo"], 
             SuperscriptBox["xhi", "ylo"]},
            {"xlob", "xhib"}
           }], ",", "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"(*", " ", 
            RowBox[{"Negative", " ", "odd", " ", 
             RowBox[{"power", ".", " ", "Reverses"}], " ", 
             RowBox[{"ordering", "."}]}], " ", "*)"}],
           FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
          GridBox[{
            {
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"xhi", "\[Equal]", "0"}], ",", 
               RowBox[{"-", "\[Infinity]"}], ",", 
               SuperscriptBox["xhi", "ylo"]}], "]"}], 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"xlo", "\[Equal]", "0"}], ",", "\[Infinity]", ",", 
               SuperscriptBox["xlo", "ylo"]}], "]"}]},
            {"xhib", "xlob"}
           }]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"xlo", "<", "0"}], ",", "NaNg", ",", " ", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{"Otherwise", ",", " ", 
           RowBox[{"negative", " ", "x", " ", "not", " ", 
            RowBox[{"allowed", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"Non", "-", 
            RowBox[{"integer", " ", "exponent"}]}], ",", " ", 
           RowBox[{"and", " ", "x", " ", "is", " ", 
            RowBox[{"nonnegative", ".", " ", "Find"}], " ", 
            RowBox[{"candidates", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Lower", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
            "upper", " ", "right", " ", "quadrant"}], ",", " ", 
           RowBox[{"facing", " ", 
            RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xlo", "\[GreaterEqual]", "1"}], "\[And]", 
            RowBox[{"ylo", "\[GreaterEqual]", "0"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"powposleft", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xlo", ",", "xlob"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"ylo", ",", "ylob"}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", "<", "1"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "1"}], "\[And]", "xhib"}], ")"}]}],
              ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", "yhib"}], ")"}]}],
              ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"powposleft", "[", 
                RowBox[{
                 RowBox[{"rec", "[", 
                  RowBox[{"{", 
                   RowBox[{"xhi", ",", "xhib"}], "}"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "yhi"}], ",", "yhib"}], "}"}]}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xlo", "<", " ", "1"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "1"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"rec", "[", 
                RowBox[{"powposright", "[", 
                 RowBox[{
                  RowBox[{"rec", "[", 
                   RowBox[{"{", 
                    RowBox[{"xlo", ",", "xlob"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"yhi", ",", "yhib"}], "}"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"uphill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", ">", "1"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "1"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"lcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"lcan", ",", 
              RowBox[{"{", 
               RowBox[{"rec", "[", 
                RowBox[{"powposright", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xhi", ",", "xhib"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "ylo"}], ",", "ylob"}], "}"}]}], "]"}], 
                "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", ">", "1"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "1"}], "\[And]", 
                RowBox[{"\[Not]", "xhib"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", ">", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "yhib"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"powposright", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"xhi", ",", "xhib"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"yhi", ",", "yhib"}], "}"}]}], "]"}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xlo", "<", " ", "1"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xlo", "\[Equal]", "1"}], "\[And]", 
                RowBox[{"\[Not]", "xlob"}]}], ")"}]}], ")"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"ylo", "<", " ", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ylo", "\[Equal]", "0"}], "\[And]", 
                RowBox[{"\[Not]", "ylob"}]}], ")"}]}], ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"powposright", "[", 
                RowBox[{
                 RowBox[{"rec", "[", 
                  RowBox[{"{", 
                   RowBox[{"xlo", ",", "xlob"}], "}"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "ylo"}], ",", "ylob"}], "}"}]}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Lower", " ", "right", " ", "corner", " ", "is", " ", "in", " ", 
             "upper", " ", "left", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"xhi", "<", "1"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"xhi", "\[Equal]", "1"}], "\[And]", "xhib"}], ")"}]}],
              ")"}], "\[And]", 
            RowBox[{"ylo", "\[GreaterEqual]", " ", "0"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"rec", "[", 
                RowBox[{"powposleft", "[", 
                 RowBox[{
                  RowBox[{"rec", "[", 
                   RowBox[{"{", 
                    RowBox[{"xhi", ",", "xhib"}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"ylo", ",", "ylob"}], "}"}]}], "]"}], "]"}], 
               "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "Upper", " ", "left", " ", "corner", " ", "is", " ", "in", " ", 
             "lower", " ", "right", " ", "quadrant"}], ",", " ", 
            RowBox[{"facing", " ", 
             RowBox[{"downhill", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xlo", "\[GreaterEqual]", "1"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"yhi", "<", "0"}], "\[Or]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"yhi", "\[Equal]", "0"}], "\[And]", "yhib"}], ")"}]}],
              ")"}]}], ",", 
           RowBox[{"rcan", "=", 
            RowBox[{"Union", "[", 
             RowBox[{"rcan", ",", 
              RowBox[{"{", 
               RowBox[{"rec", "[", 
                RowBox[{"powposleft", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"xlo", ",", "xlob"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "yhi"}], ",", "yhib"}], "}"}]}], "]"}], 
                "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         
         RowBox[{GridBox[{
            {"powleft", "powright"},
            {"openleft", "openright"}
           }], "=", GridBox[{
            {
             SubscriptBox["lcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
             SubscriptBox["rcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]]},
            {
             SubscriptBox["lcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
             SubscriptBox["rcan", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "2"}], "\[RightDoubleBracket]"}]]}
           }]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "lcan", "]"}], ">", "1"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["lcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["lcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
              "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Not]", 
                 SubscriptBox["lcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
                "\[Or]", 
                RowBox[{"\[Not]", 
                 SubscriptBox["lcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
               ")"}]}], ",", 
             RowBox[{"openleft", "=", "closed"}]}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "rcan", "]"}], ">", "1"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["rcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["rcan", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{
                  RowBox[{"-", "2"}], ",", "1"}], 
                 "\[RightDoubleBracket]"}]]}], "\[And]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Not]", 
                 SubscriptBox["rcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]]}], "\[Or]", 
                RowBox[{"\[Not]", 
                 SubscriptBox["rcan", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"-", "2"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]]}]}], ")"}]}], ",", 
             RowBox[{"openright", "=", "closed"}]}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", GridBox[{
           {"powleft", "powright"},
           {"openleft", "openright"}
          }]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Power", " ", "function", " ", "in", " ", "the", " ", "u"}], 
       "-", "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"powu", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], ",", 
      RowBox[{"v_", "/;", 
       RowBox[{"uQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", "=", 
        RowBox[{"g2u", "[", 
         RowBox[{"powg", "[", 
          RowBox[{
           RowBox[{"u2g", "[", "u", "]"}], ",", 
           RowBox[{"u2g", "[", "v", "]"}]}], "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}], "+", 
         RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "3"}], ";", "w"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Exponential", " ", "function", " ", "in", " ", "the", " ", "g"}], "-", 
      
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expg", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"g2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"lo", "=", 
         RowBox[{"Log", "[", "smallsubnormal", "]"}]}], ",", 
        RowBox[{"hi", "=", 
         RowBox[{"Log", "[", "maxreal", "]"}]}], ",", "glo", ",", "ghi"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"glo", "=", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"g1", "===", "NaN"}], "\[Or]", 
           RowBox[{"g2", "===", "NaN"}]}], ",", GridBox[{
            {"NaN"},
            {"open"}
           }], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"g1", "\[Equal]", 
            RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
           RowBox[{"\[Not]", "b1"}]}], ",", GridBox[{
            {"0"},
            {"closed"}
           }], ",", 
          RowBox[{
           RowBox[{"g1", "\[Equal]", "0"}], "\[And]", 
           RowBox[{"\[Not]", "b1"}]}], ",", GridBox[{
            {"1"},
            {"closed"}
           }], ",", 
          RowBox[{
           RowBox[{"g1", "\[Equal]", "\[Infinity]"}], "\[And]", 
           RowBox[{"\[Not]", "b1"}]}], ",", GridBox[{
            {"\[Infinity]"},
            {"closed"}
           }], ",", "\[IndentingNewLine]", 
          RowBox[{"g1", "<", "lo"}], ",", GridBox[{
            {"0"},
            {"open"}
           }], ",", 
          RowBox[{"g1", ">", "hi"}], ",", GridBox[{
            {"maxreal"},
            {"open"}
           }], ",", "True", ",", GridBox[{
            {
             RowBox[{"Exp", "[", "g1", "]"}]},
            {"open"}
           }]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ghi", "=", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"g1", "===", "NaN"}], "\[Or]", 
           RowBox[{"g2", "===", "NaN"}]}], ",", GridBox[{
            {"NaN"},
            {"open"}
           }], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"g2", "\[Equal]", 
            RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
           RowBox[{"\[Not]", "b2"}]}], ",", GridBox[{
            {"0"},
            {"closed"}
           }], ",", 
          RowBox[{
           RowBox[{"g2", "\[Equal]", "0"}], "\[And]", 
           RowBox[{"\[Not]", "b2"}]}], ",", GridBox[{
            {"1"},
            {"closed"}
           }], ",", 
          RowBox[{
           RowBox[{"g2", "\[Equal]", "\[Infinity]"}], "\[And]", 
           RowBox[{"\[Not]", "b2"}]}], ",", GridBox[{
            {"\[Infinity]"},
            {"closed"}
           }], ",", "\[IndentingNewLine]", 
          RowBox[{"g2", "<", "lo"}], ",", GridBox[{
            {"smallsubnormal"},
            {"open"}
           }], ",", 
          RowBox[{"g2", ">", "hi"}], ",", GridBox[{
            {"\[Infinity]"},
            {"open"}
           }], ",", "True", ",", GridBox[{
            {
             RowBox[{"Exp", "[", "g2", "]"}]},
            {"open"}
           }]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"g1", "===", "g2"}], ",", 
         RowBox[{"f2g", "[", 
          RowBox[{"Exp", "[", "g1", "]"}], "]"}], ",", GridBox[{
           {
            SubscriptBox["glo", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
            SubscriptBox["ghi", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]},
           {
            SubscriptBox["glo", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], 
            SubscriptBox["ghi", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}
          }]}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "Exponential", " ", "function", " ", "in", " ", "the", " ", "u"}], "-",
        "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"nbits", "[", "u", "]"}]}], ",", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"expg", "[", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Absolute", " ", "value", " ", "in", " ", "the", " ", "g"}], 
      "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"absg", "[", "g_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"g2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
      ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"g1", "===", "NaN"}], "\[Or]", 
         RowBox[{"g2", "===", "NaN"}]}], ",", 
        RowBox[{"f2g", "[", "NaN", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"g2", "\[LessEqual]", "0"}], ",", GridBox[{
          {
           RowBox[{"Abs", "[", "g2", "]"}], 
           RowBox[{"Abs", "[", "g1", "]"}]},
          {"b2", "b1"}
         }], ",", "\[IndentingNewLine]", 
        RowBox[{"g1", "\[LessEqual]", "0"}], ",", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", "g1", "]"}], "<", 
           RowBox[{"Abs", "[", "g2", "]"}]}], ",", GridBox[{
            {"0", 
             RowBox[{"Abs", "[", "g2", "]"}]},
            {"closed", "b2"}
           }], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Abs", "[", "g1", "]"}], ">", 
           RowBox[{"Abs", "[", "g2", "]"}]}], ",", GridBox[{
            {"0", 
             RowBox[{"Abs", "[", "g1", "]"}]},
            {"closed", "b1"}
           }], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", "True", ",",
           GridBox[{
            {"0", 
             RowBox[{"Abs", "[", "g2", "]"}]},
            {"closed", 
             RowBox[{"(", 
              RowBox[{"b1", "\[And]", "b2"}], ")"}]}
           }]}], "]"}], ",", "\[IndentingNewLine]", "True", ",", GridBox[{
          {
           RowBox[{"Abs", "[", "g1", "]"}], 
           RowBox[{"Abs", "[", "g2", "]"}]},
          {"b1", "b2"}
         }]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Absolute", " ", "value", " ", "in", " ", "the", " ", "u"}], 
       "-", "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"absu", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"i", "=", 
         RowBox[{"nbits", "[", "u", "]"}]}], ",", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"absg", "[", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "u", "]"}], "+", 
         RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Logarithm", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"logg", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"g1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"g2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b1", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"b2", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", "glo", 
        ",", "ghi"}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"g1", "===", "NaN"}], "\[Or]", 
         RowBox[{"g2", "===", "NaN"}]}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", 
        RowBox[{"g1", "<", "0"}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"glo", "=", 
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"g1", "==", "0"}], ",", GridBox[{
              {
               RowBox[{"-", "\[Infinity]"}]},
              {"b1"}
             }], ",", 
            RowBox[{"g1", "\[Equal]", "1"}], ",", GridBox[{
              {"0"},
              {"b1"}
             }], ",", 
            RowBox[{"g1", "\[Equal]", "\[Infinity]"}], ",", GridBox[{
              {"\[Infinity]"},
              {"closed"}
             }], ",", "\[IndentingNewLine]", "True", ",", GridBox[{
              {
               RowBox[{"Log", "[", "g1", "]"}]},
              {"open"}
             }]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"ghi", "=", 
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"g2", "\[Equal]", "0"}], "\[And]", 
             RowBox[{"\[Not]", "b2"}]}], ",", GridBox[{
              {
               RowBox[{"-", "\[Infinity]"}]},
              {"closed"}
             }], ",", 
            RowBox[{"g2", "\[Equal]", "1"}], ",", GridBox[{
              {"0"},
              {"b2"}
             }], ",", 
            RowBox[{"g2", "\[Equal]", "\[Infinity]"}], ",", GridBox[{
              {"\[Infinity]"},
              {"b2"}
             }], ",", "\[IndentingNewLine]", "True", ",", GridBox[{
              {
               RowBox[{"Log", "[", "g2", "]"}]},
              {"open"}
             }]}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"g1", "===", "g2"}], ",", 
           RowBox[{"f2g", "[", 
            RowBox[{"Log", "[", "g1", "]"}], "]"}], ",", GridBox[{
             {
              SubscriptBox["glo", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
              SubscriptBox["ghi", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]},
             {
              SubscriptBox["glo", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], 
              SubscriptBox["ghi", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}
            }]}], "]"}]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Logarithm", " ", "in", " ", "the", " ", "u"}], "-", "layer"}],
       ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logu", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"nbits", "[", "u", "]"}]}], ",", 
         RowBox[{"v", "=", 
          RowBox[{"g2u", "[", 
           RowBox[{"logg", "[", 
            RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ubitsmoved", "+=", 
         RowBox[{
          RowBox[{"nbits", "[", "u", "]"}], "+", 
          RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
        RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Cosine", " ", "in", " ", "the", " ", "u"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"cosg", "[", 
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"g1", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"g2", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"b1", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"b2", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"g1", "===", "NaN"}], "||", 
          RowBox[{"g2", "===", "NaN"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"g1", "===", "\[Infinity]"}], "\[Or]", 
          RowBox[{"g2", "===", "\[Infinity]"}], "\[Or]", 
          RowBox[{"g1", "===", 
           RowBox[{"-", "\[Infinity]"}]}], "\[Or]", 
          RowBox[{"g2", "===", 
           RowBox[{"-", "\[Infinity]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"closed", ",", "closed"}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"g2", "-", "g1"}], ">", "360"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"closed", ",", "closed"}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{" ", 
               RowBox[{
               "Translate", " ", "g1", " ", "and", " ", "g2", " ", "so", " ", 
                "g1", " ", "is", " ", 
                RowBox[{"in", " ", "[", 
                 RowBox[{"0", ",", "360"}]}]}], ")"}], ".", " ", "This"}], 
             " ", "also", " ", "assures", " ", "that", " ", "g2", " ", "is", 
             " ", 
             RowBox[{"in", " ", "[", 
              RowBox[{"0", ",", "720"}], "]"}]}], ",", " ", 
            RowBox[{
            "because", " ", "of", " ", "the", " ", "previous", " ", "If", " ", 
             RowBox[{"test", "."}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"g1", ",", "g2"}], "}"}], "-=", 
           RowBox[{
            RowBox[{"\[LeftFloor]", 
             FractionBox["g1", "360"], "\[RightFloor]"}], "360"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"g1", "<", "180"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"g2", "<", "180"}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", "\[Equal]", "180"}], "\[And]", "b2"}], ")"}]}], 
           ",", 
           StyleBox[
            RowBox[{"(*", " ", 
             RowBox[{
             "Cos", " ", "is", " ", "monotone", " ", "decreasing", " ", "on", 
              " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"0", "\[Degree]"}], ",", 
                RowBox[{"180", "\[Degree]"}]}], ")"}]}], " ", "*)"}],
            FontColor->GrayLevel[0.5]], 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"g2", " ", "\[Degree]"}], "]"}], ",", 
               RowBox[{"Cos", "[", 
                RowBox[{"g1", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"b2", ",", "b1"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"g2", "<", "360"}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", "\[Equal]", "360"}], "\[And]", "b2"}], ")"}]}], 
           ",", "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"Angle", " ", "spans", " ", "180", " ", "degrees"}], 
              ";", " ", 
              RowBox[{
              "break", " ", "the", " ", "tie", " ", "for", " ", "the", " ", 
               "high", " ", "bound"}]}], " ", "*)"}],
            FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
           RowBox[{"Which", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"g1", " ", "\[Degree]"}], "]"}], "<", 
              RowBox[{"Cos", "[", 
               RowBox[{"g2", " ", "\[Degree]"}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", 
                 RowBox[{"Cos", "[", 
                  RowBox[{"g2", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"closed", ",", "b2"}], "}"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"g1", " ", "\[Degree]"}], "]"}], ">", 
              RowBox[{"Cos", "[", 
               RowBox[{"g2", " ", "\[Degree]"}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", 
                 RowBox[{"Cos", "[", 
                  RowBox[{"g1", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"closed", ",", "b1"}], "}"}]}], "}"}], ",", 
             "\[IndentingNewLine]", "True", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", 
                 RowBox[{"Cos", "[", 
                  RowBox[{"g1", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"closed", ",", 
                 RowBox[{"b1", "\[And]", "b2"}]}], "}"}]}], "}"}]}], "]"}], 
           ",", "\[IndentingNewLine]", "True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"closed", ",", "closed"}], "}"}]}], "}"}]}], "]"}], ",",
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", 
           RowBox[{
            RowBox[{" ", 
             RowBox[{"g1", " ", "is", " ", "in", " ", 
              RowBox[{"interval", " ", "[", 
               RowBox[{
                RowBox[{"180", "\[Degree]"}], ",", 
                RowBox[{"360", "\[Degree]"}]}]}]}], ")"}], ":"}], " ", "*)"}],
          
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
         "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", 
           RowBox[{
            RowBox[{" ", 
             RowBox[{
             "Cosine", " ", "is", " ", "monotone", " ", "increasing", " ", 
              RowBox[{"on", " ", "[", 
               RowBox[{
                RowBox[{"180", "\[Degree]"}], ",", 
                RowBox[{"360", "\[Degree]"}]}]}]}], ")"}], ":"}], " ", "*)"}],
          
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"g2", "<", "360"}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"g2", "\[Equal]", "360"}], "\[And]", "b2"}], ")"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"g1", " ", "\[Degree]"}], "]"}], ",", 
               RowBox[{"Cos", "[", 
                RowBox[{"g2", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"b1", ",", "b2"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", "True", ",", " ", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Angle", " ", "spans", " ", "360", " ", "degrees"}], ";",
              " ", 
             RowBox[{
             "break", " ", "the", " ", "tie", " ", "for", " ", "the", " ", 
              "low", " ", "bound"}]}], " ", "*)"}], " ", 
           RowBox[{"Which", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"g1", " ", "\[Degree]"}], "]"}], ">", 
              RowBox[{"Cos", "[", 
               RowBox[{"g2", " ", "\[Degree]"}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{"g2", " ", "\[Degree]"}], "]"}], ",", "1"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"b2", ",", "closed"}], "}"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{"g1", " ", "\[Degree]"}], "]"}], "<", 
              RowBox[{"Cos", "[", 
               RowBox[{"g2", " ", "\[Degree]"}], "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{"g1", " ", "\[Degree]"}], "]"}], ",", "1"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"b1", ",", "closed"}], "}"}]}], "}"}], ",", 
             "\[IndentingNewLine]", "True", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Cos", "[", 
                  RowBox[{"g1", " ", "\[Degree]"}], "]"}], ",", "1"}], "}"}], 
               ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"b1", "\[And]", "b2"}], ",", "closed"}], "}"}]}], 
              "}"}]}], "]"}], ",", "\[IndentingNewLine]", "True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"closed", ",", "closed"}], "}"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cosine", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], 
      ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"cosu", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"nbits", "[", "u", "]"}]}], ",", 
         RowBox[{"v", "=", 
          RowBox[{"g2u", "[", 
           RowBox[{"cosg", "[", " ", 
            RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ubitsmoved", "+=", 
         RowBox[{
          RowBox[{"nbits", "[", "u", "]"}], "+", 
          RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
        RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Sine", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sing", "[", 
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
     RowBox[{"cosg", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"90", "-", 
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
          RowBox[{"90", "-", 
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], "}"}]}], 
       "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Sine", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], ",",
       " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"sinu", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"sing", "[", " ", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ubitsmoved", "+=", 
         RowBox[{
          RowBox[{"nbits", "[", "u", "]"}], "+", 
          RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
        RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Cotangent", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"cotg", "[", 
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"g1", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"g2", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"b1", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
         RowBox[{"b2", "=", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"g1", "===", "NaN"}], "||", 
          RowBox[{"g2", "===", "NaN"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", "g1", "]"}], "\[Equal]", "\[Infinity]"}], 
            "\[Or]", 
            RowBox[{
             RowBox[{"Abs", "[", "g2", "]"}], "\[Equal]", "\[Infinity]"}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"g2", "-", "g1"}], ">", "180"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{" ", 
                   RowBox[{
                   "Translate", " ", "g1", " ", "and", " ", "g2", " ", "so", 
                    " ", "g1", " ", "is", " ", 
                    RowBox[{"in", " ", "[", 
                    RowBox[{"0", ",", "180"}]}]}], ")"}], ".", " ", "This"}], 
                 " ", "also", " ", "assures", " ", "that", " ", "g2", " ", 
                 "is", " ", 
                 RowBox[{"in", " ", "[", 
                  RowBox[{"0", ",", "360"}], "]"}]}], ",", " ", 
                RowBox[{
                "because", " ", "of", " ", "the", " ", "previous", " ", "If", 
                 " ", 
                 RowBox[{"test", "."}]}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"g1", ",", "g2"}], "}"}], "-=", 
               RowBox[{
                RowBox[{"\[LeftFloor]", 
                 FractionBox["g1", "180"], "\[RightFloor]"}], "180"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"Which", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"g1", "\[Equal]", "0"}], "\[And]", 
                 RowBox[{"\[Not]", "b1"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", " ", 
                StyleBox[
                 RowBox[{"(*", " ", 
                  RowBox[{
                   RowBox[{"Cot", "[", 
                    RowBox[{"0", "\[Degree]"}], "]"}], " ", "is", " ", 
                   "treated", " ", "like", " ", 
                   RowBox[{"1", "/", "0"}]}], " ", "*)"}],
                 FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"g1", "\[Equal]", "0"}], "\[And]", "b1"}], ",", 
                RowBox[{"Which", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"g2", "<", "180"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cot", "[", 
                    RowBox[{"g2", " ", "\[Degree]"}], "]"}], ",", 
                    "\[Infinity]"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"b2", ",", "open"}], "}"}]}], "}"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"g2", "\[Equal]", "180"}], "\[And]", "b2"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}],
                     ",", 
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", 
                  "\[IndentingNewLine]", "True", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}]}], "]"}], 
                ",", "\[IndentingNewLine]", 
                RowBox[{"g1", "<", "180"}], ",", 
                RowBox[{"Which", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"g2", "<", "180"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Cot", "[", 
                    RowBox[{"g2", " ", "\[Degree]"}], "]"}], ",", 
                    RowBox[{"Cot", "[", 
                    RowBox[{"g1", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"b2", ",", "b1"}], "}"}]}], "}"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"g2", "\[Equal]", "180"}], "\[And]", "b2"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "\[Infinity]"}], ",", 
                    RowBox[{"Cot", "[", 
                    RowBox[{"g1", " ", "\[Degree]"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"open", ",", "b1"}], "}"}]}], "}"}], ",", 
                  "\[IndentingNewLine]", "True", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}]}], "]"}], 
                ",", "\[IndentingNewLine]", "True", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"NaN", ",", "NaN"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"open", ",", "open"}], "}"}]}], "}"}]}], "]"}]}]}],
             "]"}]}], "]"}]}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cotangent", " ", "in", " ", "the", " ", "u"}], "-", "layer"}],
       ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"cotu", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"cotg", "[", " ", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ubitsmoved", "+=", 
         RowBox[{
          RowBox[{"nbits", "[", "u", "]"}], "+", 
          RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
        RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Tangent", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"tang", "[", 
      RowBox[{"g_", "/;", 
       RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
     RowBox[{"cotg", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"90", "-", 
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
          RowBox[{"90", "-", 
           SubscriptBox["g", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
          SubscriptBox["g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}], "}"}]}], 
       "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Cotangent", " ", "in", " ", "the", " ", "u"}], "-", "layer"}],
       ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"tanu", "[", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"v", "=", 
         RowBox[{"g2u", "[", 
          RowBox[{"tang", "[", " ", 
           RowBox[{"u2g", "[", "u", "]"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ubitsmoved", "+=", 
         RowBox[{
          RowBox[{"nbits", "[", "u", "]"}], "+", 
          RowBox[{"nbits", "[", "v", "]"}]}]}], ";", 
        RowBox[{"numbersmoved", "+=", "2"}], ";", "v"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "multiply"}], "-", 
      RowBox[{"add", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fmag", "[", 
     RowBox[{
      RowBox[{"ag_", "/;", 
       RowBox[{"gQ", "[", "ag", "]"}]}], ",", 
      RowBox[{"bg_", "/;", 
       RowBox[{"gQ", "[", "bg", "]"}]}], ",", 
      RowBox[{"cg_", "/;", 
       RowBox[{"gQ", "[", "cg", "]"}]}]}], "]"}], ":=", 
    RowBox[{"plusg", "[", 
     RowBox[{
      RowBox[{"timesg", "[", 
       RowBox[{"ag", ",", "bg"}], "]"}], ",", "cg"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Fused", " ", "multiply"}], "-", 
       RowBox[{"add", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], ",", 
      " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fmau", "[", 
     RowBox[{
      RowBox[{"au_", "/;", 
       RowBox[{"uQ", "[", "au", "]"}]}], ",", 
      RowBox[{"bu_", "/;", 
       RowBox[{"uQ", "[", "bu", "]"}]}], ",", 
      RowBox[{"cu_", "/;", 
       RowBox[{"uQ", "[", "cu", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", "=", 
        RowBox[{"g2u", "[", 
         RowBox[{"fmag", "[", 
          RowBox[{
           RowBox[{"u2g", "[", "au", "]"}], ",", 
           RowBox[{"u2g", "[", "bu", "]"}], ",", 
           RowBox[{"u2g", "[", "cu", "]"}]}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "au", "]"}], "+", 
         RowBox[{"nbits", "[", "bu", "]"}], "+", 
         RowBox[{"nbits", "[", "cu", "]"}], "+", 
         RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "4"}], ";", "w"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "dot", " ", "product"}], ",", " ", 
      RowBox[{
       RowBox[{"entirely", " ", "in", " ", "the", " ", "g"}], "-", 
       RowBox[{"layer", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fdotg", "[", 
     RowBox[{"ag_List", ",", "bg_List"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", 
        RowBox[{"sumg", "=", GridBox[{
           {"0", "0"},
           {"closed", "closed"}
          }]}]}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "ag", "]"}], "\[NotEqual]", 
         RowBox[{"Length", "[", "bg", "]"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Vectors must be of equal length.\>\"", ",", "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ag", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"gQ", "[", 
                SubscriptBox["ag", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}], "\[And]", 
               RowBox[{"gQ", "[", 
                SubscriptBox["bg", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}]}], ")"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Not]", "legitQ"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Vector entries must be general intervals.\>\"", ",", 
          "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", "True", ",", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ag", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"sumg", "=", 
            RowBox[{"plusg", "[", 
             RowBox[{"sumg", ",", 
              RowBox[{"timesg", "[", 
               RowBox[{
                SubscriptBox["ag", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], ",", 
                SubscriptBox["bg", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], 
               "]"}]}], "]"}]}]}], "]"}], ";", "sumg"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Fused", " ", "dot", " ", "product", " ", "in", " ", "g"}], 
       "-", "layer"}], ",", " ", 
      RowBox[{
       RowBox[{
       "with", " ", "inputs", " ", "and", " ", "output", " ", "in", " ", 
        "the", " ", "u"}], "-", 
       RowBox[{
       "layer", " ", "and", " ", "with", " ", "tallying", " ", "of", " ", 
        "bits", " ", "moved", " ", "and", " ", "numbers", " ", 
        RowBox[{"moved", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fdotu", "[", 
     RowBox[{"au_List", ",", "bu_List"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", 
        RowBox[{"sumg", "=", GridBox[{
           {"0", "0"},
           {"closed", "closed"}
          }]}], ",", "w"}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "au", "]"}], "\[NotEqual]", 
         RowBox[{"Length", "[", "bu", "]"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Vectors must be of equal length.\>\"", ",", "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "au", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"uQ", "[", 
                SubscriptBox["au", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}], "\[And]", 
               RowBox[{"uQ", "[", 
                SubscriptBox["bu", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}]}], ")"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Not]", "legitQ"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Vector entries must be unums or ubounds.\>\"", ",", 
          "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", "True", ",", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "au", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ubitsmoved", "+=", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"nbits", "[", 
                SubscriptBox["au", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}], "+", 
               RowBox[{"nbits", "[", 
                SubscriptBox["bu", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}]}], ")"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"sumg", "=", 
             RowBox[{"plusg", "[", 
              RowBox[{"sumg", ",", 
               RowBox[{"timesg", "[", 
                RowBox[{
                 RowBox[{"u2g", "[", 
                  SubscriptBox["au", 
                   RowBox[{
                   "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                  "]"}], ",", 
                 RowBox[{"u2g", "[", 
                  SubscriptBox["bu", 
                   RowBox[{
                   "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                  "]"}]}], "]"}]}], "]"}]}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"w", "=", 
          RowBox[{"g2u", "[", "sumg", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"ubitsmoved", "+=", 
          RowBox[{"nbits", "[", "w", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"numbersmoved", "+=", 
          RowBox[{
           RowBox[{"2", "*", 
            RowBox[{"Length", "[", "au", "]"}]}], "+", "1"}]}], ";", 
         "\[IndentingNewLine]", "w"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "sum", " ", "of", " ", "a", " ", "list"}], ",", 
      " ", 
      RowBox[{
       RowBox[{"entirely", " ", "in", " ", "the", " ", "g"}], "-", 
       RowBox[{"layer", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fsumg", "[", "ag_List", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", 
        RowBox[{"sumg", "=", GridBox[{
           {"0", "0"},
           {"closed", "closed"}
          }]}]}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ag", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"gQ", "[", 
              SubscriptBox["ag", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Not]", "legitQ"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<List entries must be general intervals.\>\"", ",", 
          "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", "True", ",", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ag", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"sumg", "=", 
            RowBox[{"plusg", "[", 
             RowBox[{"sumg", ",", 
              SubscriptBox["ag", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], 
             "]"}]}]}], "]"}], ";", "sumg"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "sum", " ", "of", " ", "a", " ", "list"}], ",", 
      " ", 
      RowBox[{
       RowBox[{
       "with", " ", "inputs", " ", "and", " ", "output", " ", "in", " ", 
        "the", " ", "u"}], "-", 
       RowBox[{
       "layer", " ", "and", " ", "with", " ", "tallying", " ", "of", " ", 
        "bits", " ", "and", " ", "numbers", " ", 
        RowBox[{"moved", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fsumu", "[", "au_List", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", 
        RowBox[{"sumg", "=", GridBox[{
           {"0", "0"},
           {"closed", "closed"}
          }]}], ",", "w"}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "au", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"uQ", "[", 
              SubscriptBox["au", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Not]", "legitQ"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<List entries must be unums or ubounds.\>\"", ",", 
          "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", "True", ",", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "au", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ubitsmoved", "+=", 
             RowBox[{"nbits", "[", 
              SubscriptBox["au", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"sumg", "=", 
             RowBox[{"plusg", "[", 
              RowBox[{"sumg", ",", 
               RowBox[{"u2g", "[", 
                SubscriptBox["au", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}]}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"w", "=", 
          RowBox[{"g2u", "[", "sumg", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"ubitsmoved", "+=", 
          RowBox[{"nbits", "[", "w", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"numbersmoved", "+=", 
          RowBox[{
           RowBox[{"Length", "[", "au", "]"}], "+", "1"}]}], ";", 
         "\[IndentingNewLine]", "w"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "product", " ", "of", " ", "a", " ", "list"}], 
      ",", " ", 
      RowBox[{
       RowBox[{"entirely", " ", "in", " ", "the", " ", "g"}], "-", 
       RowBox[{"layer", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fprodg", "[", "ag_List", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", 
        RowBox[{"prodg", "=", GridBox[{
           {"1", "1"},
           {"closed", "closed"}
          }]}]}], "}"}], ",", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ag", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"gQ", "[", 
              SubscriptBox["ag", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Not]", "legitQ"}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<List entries must be general intervals.\>\"", ",", 
          "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", "True", ",", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ag", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"prodg", "=", 
            RowBox[{"timesg", "[", 
             RowBox[{"prodg", ",", 
              SubscriptBox["ag", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], 
             "]"}]}]}], "]"}], ";", "prodg"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "product", " ", "of", " ", "a", " ", "list"}], 
      ",", " ", 
      RowBox[{
       RowBox[{
       "with", " ", "inputs", " ", "and", " ", "output", " ", "in", " ", 
        "the", " ", "u"}], "-", 
       RowBox[{
       "layer", " ", "and", " ", "with", " ", "tallying", " ", "of", " ", 
        "bits", " ", "and", " ", "numbers", " ", 
        RowBox[{"moved", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fprodu", "[", "au_List", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", 
        RowBox[{"prodg", "=", GridBox[{
           {"1", "1"},
           {"closed", "closed"}
          }]}], ",", "w"}], "}"}], ",", 
      RowBox[{
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "au", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"legitQ", "=", 
             RowBox[{"legitQ", "\[And]", 
              RowBox[{"uQ", "[", 
               SubscriptBox["au", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Not]", "legitQ"}]}], ",", 
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<List entries must be unums or ubounds.\>\"", ",", 
           "\"\<Text\>\"", ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"{", 
              RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
         ",", "\[IndentingNewLine]", "True", ",", 
         RowBox[{
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "au", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ubitsmoved", "+=", 
              RowBox[{"nbits", "[", 
               SubscriptBox["au", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"prodg", "=", 
              RowBox[{"timesg", "[", 
               RowBox[{"prodg", ",", 
                RowBox[{"u2g", "[", 
                 SubscriptBox["au", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                 "]"}]}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"w", "=", 
           RowBox[{"g2u", "[", "prodg", "]"}]}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{"nbits", "[", "w", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"numbersmoved", "+=", 
        RowBox[{
         RowBox[{"Length", "[", "au", "]"}], "+", "1"}]}], ";", 
       "\[IndentingNewLine]", "w"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "add"}], "-", 
      RowBox[{"multiply", " ", "in", " ", "the", " ", "g"}], "-", 
      RowBox[{"layer", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"famg", "[", 
     RowBox[{
      RowBox[{"ag_", "/;", 
       RowBox[{"gQ", "[", "ag", "]"}]}], ",", 
      RowBox[{"bg_", "/;", 
       RowBox[{"gQ", "[", "bg", "]"}]}], ",", 
      RowBox[{"cg_", "/;", 
       RowBox[{"gQ", "[", "cg", "]"}]}]}], "]"}], ":=", 
    RowBox[{"timesg", "[", 
     RowBox[{
      RowBox[{"plusg", "[", 
       RowBox[{"ag", ",", "bg"}], "]"}], ",", "cg"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Fused", " ", "add"}], "-", 
       RowBox[{"multiply", " ", "in", " ", "the", " ", "u"}], "-", "layer"}], 
      ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"famu", "[", 
     RowBox[{
      RowBox[{"au_", "/;", 
       RowBox[{"uQ", "[", "au", "]"}]}], ",", 
      RowBox[{"bu_", "/;", 
       RowBox[{"uQ", "[", "bu", "]"}]}], ",", 
      RowBox[{"cu_", "/;", 
       RowBox[{"uQ", "[", "cu", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", "=", 
        RowBox[{"g2u", "[", 
         RowBox[{"famg", "[", 
          RowBox[{
           RowBox[{"u2g", "[", "au", "]"}], ",", 
           RowBox[{"u2g", "[", "bu", "]"}], ",", 
           RowBox[{"u2g", "[", "cu", "]"}]}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{
       RowBox[{"ubitsmoved", "+=", 
        RowBox[{
         RowBox[{"nbits", "[", "au", "]"}], "+", 
         RowBox[{"nbits", "[", "bu", "]"}], "+", 
         RowBox[{"nbits", "[", "cu", "]"}], "+", 
         RowBox[{"nbits", "[", "w", "]"}]}]}], ";", 
       RowBox[{"numbersmoved", "+=", "4"}], ";", "w"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Fused", " ", "product", " ", "ratio"}], ",", " ", 
      RowBox[{
       RowBox[{"entirely", " ", "in", " ", "the", " ", "g"}], "-", 
       RowBox[{"layer", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fprodratiog", "[", 
     RowBox[{"numeratorsg_List", ",", "denominatorsg_List"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}]}], "}"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "numeratorsg", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"legitQ", "=", 
          RowBox[{"legitQ", "\[And]", 
           RowBox[{"gQ", "[", 
            SubscriptBox["numeratorsg", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "denominatorsg", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"legitQ", "=", 
          RowBox[{"legitQ", "\[And]", 
           RowBox[{"gQ", "[", 
            SubscriptBox["denominatorsg", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"\[Not]", "legitQ"}], ",", 
         RowBox[{"Style", "[", 
          RowBox[{
          "\"\<Vector entries must be general intervals.\>\"", ",", 
           "\"\<Text\>\"", ",", 
           RowBox[{"Background", "\[Rule]", 
            RowBox[{"RGBColor", "[", 
             RowBox[{"{", 
              RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"divideg", "[", 
          RowBox[{
           RowBox[{"fprodg", "[", "numeratorsg", "]"}], ",", 
           RowBox[{"fprodg", "[", "denominatorsg", "]"}]}], "]"}]}], 
        "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "Fused", " ", "product", " ", "ratio", " ", "in", " ", "the", " ", 
        "u"}], "-", "layer"}], ",", " ", 
      RowBox[{
      "with", " ", "tallying", " ", "of", " ", "bits", " ", "and", " ", 
       "numbers", " ", 
       RowBox[{"moved", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\n", 
   RowBox[{
    RowBox[{"fprodratiou", "[", 
     RowBox[{"numeratorsu_List", ",", "denominatorsu_List"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"legitQ", "=", "True"}], ",", "\[IndentingNewLine]", 
        RowBox[{"lengthden", "=", 
         RowBox[{"Length", "[", "denominatorsu", "]"}]}], ",", 
        RowBox[{"lengthnum", "=", 
         RowBox[{"Length", "[", "numeratorsu", "]"}]}], ",", 
        RowBox[{"proddeng", "=", GridBox[{
           {"1", "1"},
           {"closed", "closed"}
          }]}], ",", 
        RowBox[{"prodnumg", "=", GridBox[{
           {"1", "1"},
           {"closed", "closed"}
          }]}], ",", "w"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", "lengthden"}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"uQ", "[", 
              SubscriptBox["denominatorsu", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", "lengthnum"}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"legitQ", "=", 
            RowBox[{"legitQ", "\[And]", 
             RowBox[{"uQ", "[", 
              SubscriptBox["numeratorsu", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Not]", "legitQ"}], "\[Or]", 
          RowBox[{"lengthden", "<", "1"}], "\[Or]", 
          RowBox[{"lengthnum", "<", "1"}]}]}], ",", 
        RowBox[{"Style", "[", 
         RowBox[{
         "\"\<Vector entries must be unums or ubounds\>\"", ",", 
          "\"\<Text\>\"", ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", ".9", ",", ".7"}], "}"}], "]"}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", "lengthden"}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ubitsmoved", "+=", 
             RowBox[{"nbits", "[", 
              SubscriptBox["denominatorsu", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"proddeng", "=", 
             RowBox[{"timesg", "[", 
              RowBox[{"proddeng", ",", 
               RowBox[{"u2g", "[", 
                SubscriptBox["denominatorsu", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}]}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", "lengthnum"}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ubitsmoved", "+=", 
             RowBox[{"nbits", "[", 
              SubscriptBox["numeratorsu", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"prodnumg", "=", 
             RowBox[{"timesg", "[", 
              RowBox[{"prodnumg", ",", 
               RowBox[{"u2g", "[", 
                SubscriptBox["numeratorsu", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                "]"}]}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"w", "=", 
          RowBox[{"g2u", "[", 
           RowBox[{"divideg", "[", 
            RowBox[{"prodnumg", ",", "proddeng"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ubitsmoved", "+=", 
          RowBox[{"nbits", "[", "w", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"numbersmoved", "+=", 
          RowBox[{"lengthden", "+", "lengthnum", "+", "1"}]}], ";", 
         "\[IndentingNewLine]", "w"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Complex", " ", "Fast", " ", "Fourier", " ", "Transform", " ", "using", 
      " ", "unum", " ", 
      RowBox[{"arithmetic", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cfftu", "[", 
     RowBox[{"rru_List", ",", "n_Integer", ",", "iflg_Integer"}], "]"}], ":=",
     "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ggu", "=", "rru"}], ",", "i", ",", "j", ",", 
        RowBox[{"k", "=", 
         RowBox[{"n", "/", "2"}]}], ",", 
        RowBox[{"th", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"iflg", "\[GreaterEqual]", "0"}], ",", 
           RowBox[{"-", "\[Pi]"}], ",", "\[Pi]"}], "]"}]}], ",", "tru", ",", 
        "tiu", ",", "twiddleu", ",", "wwu"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"k", "\[GreaterEqual]", "1"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"wwu", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              OverscriptBox[
               RowBox[{
                RowBox[{"-", "2"}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"Sin", "[", 
                   RowBox[{"th", "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "k"}], ")"}]}], "]"}], ")"}], "2"]}], "^"], 
              "}"}], ",", 
             RowBox[{"{", " ", 
              OverscriptBox[
               RowBox[{"Sin", "[", 
                RowBox[{"th", "/", "k"}], "]"}], "^"], "}"}]}], "}"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"twiddleu", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              OverscriptBox["1", "^"], "}"}], ",", 
             RowBox[{"{", 
              OverscriptBox["0", "^"], "}"}]}], "}"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "0"}], ",", 
            RowBox[{"j", "<", "k"}], ",", 
            RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"i", "=", "1"}], ",", 
               RowBox[{"i", "\[LessEqual]", "n"}], ",", 
               RowBox[{"i", "+=", 
                RowBox[{"2", "k"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"tru", ",", "tiu"}], "}"}], "=", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"smartunify", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j"}], ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "\[CircleMinus]", 
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j", "+", "k"}], ",", "1"}], 
                    "\[RightDoubleBracket]"}]]}], ",", "1"}], "]"}], ",", 
                   RowBox[{"smartunify", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j"}], ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "\[CircleMinus]", 
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j", "+", "k"}], ",", "2"}], 
                    "\[RightDoubleBracket]"}]]}], ",", "1"}], "]"}]}], 
                  "}"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 SubscriptBox["ggu", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"i", "+", "j"}], "\[RightDoubleBracket]"}]], "=", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"smartunify", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j"}], ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "\[CirclePlus]", 
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j", "+", "k"}], ",", "1"}], 
                    "\[RightDoubleBracket]"}]]}], ",", "1"}], "]"}], ",", 
                   RowBox[{"smartunify", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j"}], ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "\[CirclePlus]", 
                    SubscriptBox["ggu", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"i", "+", "j", "+", "k"}], ",", "2"}], 
                    "\[RightDoubleBracket]"}]]}], ",", "1"}], "]"}]}], 
                  "}"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 SubscriptBox["ggu", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"i", "+", "j", "+", "k"}], ",", "1"}], 
                   "\[RightDoubleBracket]"}]], "=", 
                 RowBox[{"smartunify", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                    "\[CircleTimes]", "tru"}], " ", "\[CircleMinus]", " ", 
                    RowBox[{
                    SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
                    "\[CircleTimes]", "tiu"}]}], ",", "1"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 SubscriptBox["ggu", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"i", "+", "j", "+", "k"}], ",", "2"}], 
                   "\[RightDoubleBracket]"}]], "=", 
                 RowBox[{"smartunify", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                    "\[CircleTimes]", "tiu"}], " ", "\[CirclePlus]", " ", 
                    RowBox[{
                    SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
                    "\[CircleTimes]", "tru"}]}], ",", "1"}], "]"}]}]}]}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"tru", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                   "\[CircleTimes]", 
                   SubscriptBox["wwu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}],
                   ")"}], "\[CircleMinus]", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
                   "\[CircleTimes]", 
                   SubscriptBox["wwu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}],
                   ")"}]}], ")"}], "\[CirclePlus]", 
               SubscriptBox["twiddleu", 
                RowBox[{
                "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
              SubscriptBox["twiddleu", 
               RowBox[{
               "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                   "\[CircleTimes]", 
                   SubscriptBox["wwu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}],
                   ")"}], "\[CirclePlus]", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["twiddleu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
                   "\[CircleTimes]", 
                   SubscriptBox["wwu", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}],
                   ")"}]}], ")"}], "\[CirclePlus]", 
               SubscriptBox["twiddleu", 
                RowBox[{
                "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{
              SubscriptBox["twiddleu", 
               RowBox[{
               "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "=", 
              "tru"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"k", "=", 
           RowBox[{"k", "/", "2"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"j", "=", "0"}]}], ",", 
         RowBox[{"i", "<", 
          RowBox[{"n", "-", "1"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"i", "<", "j"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"tru", ",", "tiu"}], "}"}], "=", 
              SubscriptBox["ggu", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"j", "+", "1"}], "\[RightDoubleBracket]"}]]}], ";", 
             RowBox[{
              SubscriptBox["ggu", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"j", "+", "1"}], "\[RightDoubleBracket]"}]], "=", 
              SubscriptBox["ggu", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]]}], ";", 
             RowBox[{
              SubscriptBox["ggu", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]], "=", 
              RowBox[{"{", 
               RowBox[{"tru", ",", "tiu"}], "}"}]}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"k", "=", 
           RowBox[{"n", "/", "2"}]}], ";", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"k", "\[LessEqual]", "j"}], ",", 
            RowBox[{
             RowBox[{"j", "=", 
              RowBox[{"j", "-", "k"}]}], ";", 
             RowBox[{"k", "=", 
              RowBox[{"k", "/", "2"}]}]}]}], "]"}], ";", 
          RowBox[{"j", "=", 
           RowBox[{"j", "+", "k"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       "ggu"}]}], "]"}]}]}]}]], "Input",
 CellMargins->{{49, Inherited}, {1, 1}},
 InitializationCell->True,
 CellChangeTimes->{{3.580298050513713*^9, 3.580298159783435*^9}, {
   3.580298199572612*^9, 3.580298272767013*^9}, {3.580298436671176*^9, 
   3.5802984392809877`*^9}, {3.580298486368454*^9, 3.580298508119864*^9}, {
   3.580298892709241*^9, 3.5802989898516808`*^9}, {3.580299036933043*^9, 
   3.5802990759411497`*^9}, {3.580301096553261*^9, 3.580301107900325*^9}, 
   3.580407185618232*^9, {3.5804073411934566`*^9, 3.5804074162225933`*^9}, {
   3.580409883925783*^9, 3.580409966611824*^9}, {3.5804100146695833`*^9, 
   3.5804100498518457`*^9}, {3.5804100829154263`*^9, 
   3.5804101128653603`*^9}, {3.580425448449752*^9, 3.580425448779365*^9}, {
   3.5804261201173267`*^9, 3.580426208877038*^9}, {3.580426265284741*^9, 
   3.580426350403449*^9}, {3.580426485679954*^9, 3.5804264905641737`*^9}, 
   3.5804279203282843`*^9, 3.580428142103916*^9, {3.5804282229099073`*^9, 
   3.580428236525876*^9}, {3.580428596651292*^9, 3.580428636427302*^9}, 
   3.580428697853199*^9, {3.5804288226414557`*^9, 3.580428899491375*^9}, {
   3.580429105490171*^9, 3.580429114809146*^9}, {3.58047836218604*^9, 
   3.580478387135298*^9}, {3.580478426265153*^9, 3.580478432336335*^9}, {
   3.580478546403347*^9, 3.5804785478701687`*^9}, {3.58050672117647*^9, 
   3.580506907360235*^9}, {3.580506966415413*^9, 3.580507005277861*^9}, {
   3.580507064963773*^9, 3.580507067911181*^9}, {3.580507106619545*^9, 
   3.580507133988846*^9}, {3.5805173485253267`*^9, 3.5805173614119787`*^9}, {
   3.5805174649883432`*^9, 3.5805174904422617`*^9}, {3.580517982687579*^9, 
   3.580517983270061*^9}, {3.580518225267564*^9, 3.580518274450782*^9}, {
   3.580553307093566*^9, 3.580553314032319*^9}, {3.580564151300725*^9, 
   3.580564156005431*^9}, {3.580564198852427*^9, 3.580564217883697*^9}, {
   3.580564271980632*^9, 3.5805642844351788`*^9}, {3.580564410577867*^9, 
   3.58056442844328*^9}, 3.5805670555833*^9, {3.580567795170231*^9, 
   3.580567804792451*^9}, {3.5805681765764*^9, 3.580568178149033*^9}, {
   3.580568247798682*^9, 3.580568272596991*^9}, {3.580568508184713*^9, 
   3.580568537933886*^9}, {3.580568653258788*^9, 3.580568656162497*^9}, {
   3.5805687034983*^9, 3.58056875067342*^9}, {3.580569020825623*^9, 
   3.5805690326636677`*^9}, 3.5807399271706133`*^9, {3.580839338424562*^9, 
   3.580839352590754*^9}, {3.58083938395133*^9, 3.5808394159264107`*^9}, {
   3.58179076605632*^9, 3.5817908291653023`*^9}, {3.581791726054412*^9, 
   3.581791751892557*^9}, {3.5817918449016743`*^9, 3.58179187167181*^9}, {
   3.5828199539226913`*^9, 3.5828199616691113`*^9}, {3.5834302529567213`*^9, 
   3.583430254556594*^9}, {3.587909478641012*^9, 3.587909479129734*^9}, {
   3.5879096375190372`*^9, 3.5879096436539183`*^9}, {3.587909712515162*^9, 
   3.587909715539117*^9}, {3.587909855809832*^9, 3.587909889495844*^9}, {
   3.5879099949218683`*^9, 3.587909996489438*^9}, {3.587910035431437*^9, 
   3.5879100375866547`*^9}, {3.587910096690349*^9, 3.587910125274394*^9}, {
   3.587910256394767*^9, 3.587910285202273*^9}, {3.587910341109633*^9, 
   3.587910353597309*^9}, {3.587910506851668*^9, 3.5879105076531267`*^9}, {
   3.5879105757037897`*^9, 3.587910576200951*^9}, {3.5879107669811*^9, 
   3.58791076850147*^9}, {3.587910872927346*^9, 3.587910890624839*^9}, {
   3.5879109802010593`*^9, 3.587910981642737*^9}, {3.587911057509115*^9, 
   3.587911080717304*^9}, {3.5879111858543873`*^9, 3.587911186713225*^9}, {
   3.5879112599940987`*^9, 3.587911263475442*^9}, {3.587911294119294*^9, 
   3.5879112958912687`*^9}, {3.58791137719527*^9, 3.587911377974805*^9}, {
   3.5879114983323317`*^9, 3.587911499527094*^9}, {3.587911544970408*^9, 
   3.5879115740591507`*^9}, {3.587911623670957*^9, 3.587911624785001*^9}, {
   3.5879116795158577`*^9, 3.587911679854506*^9}, {3.587911901622241*^9, 
   3.587911901913745*^9}, {3.5879119539881*^9, 3.587912022940012*^9}, {
   3.5879120642548103`*^9, 3.587912065009788*^9}, {3.587912175432179*^9, 
   3.587912189362751*^9}, {3.587912246132987*^9, 3.587912260447584*^9}, {
   3.587912294833497*^9, 3.5879122963564568`*^9}, {3.587912730239882*^9, 
   3.5879127318148108`*^9}, {3.5879127919161987`*^9, 3.587912813600243*^9}, {
   3.587912891382753*^9, 3.587912949517733*^9}, {3.5879129805235157`*^9, 
   3.587912982980937*^9}, {3.5879131859655867`*^9, 3.587913187306343*^9}, {
   3.587913249738021*^9, 3.587913252245919*^9}, {3.587913338419718*^9, 
   3.587913380564851*^9}, {3.587913535777323*^9, 3.587913537068199*^9}, {
   3.587913702885401*^9, 3.587913704067244*^9}, {3.587913750548087*^9, 
   3.587913786866914*^9}, {3.587914093852672*^9, 3.587914094236862*^9}, {
   3.587914261475312*^9, 3.58791426184097*^9}, {3.587914360629822*^9, 
   3.58791438068326*^9}, {3.587914484783248*^9, 3.587914533658374*^9}, {
   3.5879146411322927`*^9, 3.587914646313336*^9}, {3.587914701697352*^9, 
   3.587914757310111*^9}, 3.587914837025895*^9, 3.587915003417149*^9, {
   3.5879327627788773`*^9, 3.5879328427292557`*^9}, {3.5922158927441273`*^9, 
   3.5922158931839647`*^9}, 3.592215959764965*^9, 3.59277611871113*^9, 
   3.5938994900977087`*^9, {3.5943258152811337`*^9, 3.594325816213779*^9}, {
   3.5943521340055027`*^9, 3.5943522496649237`*^9}, {3.594390382458068*^9, 
   3.594390389164937*^9}, {3.5943904841050177`*^9, 3.594390490284296*^9}, {
   3.594390554971953*^9, 3.594390559788272*^9}, {3.5944516933232317`*^9, 
   3.594451694655644*^9}, {3.594451749679246*^9, 3.594451763602281*^9}, {
   3.594451877380302*^9, 3.594451887463608*^9}, {3.594452197178338*^9, 
   3.5944521985075407`*^9}, {3.594452241914612*^9, 3.594452252526926*^9}, {
   3.594452684167313*^9, 3.5944527921951847`*^9}, {3.594452936178753*^9, 
   3.594452941698814*^9}, {3.594453188520314*^9, 3.594453189971349*^9}, {
   3.594453653107585*^9, 3.594453654309108*^9}, {3.594468747216604*^9, 
   3.5944687774963417`*^9}, {3.594469007875073*^9, 3.5944690297845793`*^9}, {
   3.5944984781041737`*^9, 3.594498502092618*^9}, {3.59449871647021*^9, 
   3.594498879755804*^9}, {3.594498938800415*^9, 3.594498942055294*^9}, {
   3.594499263378154*^9, 3.594499285842998*^9}, {3.594499348860486*^9, 
   3.594499351334875*^9}, {3.59450416127113*^9, 3.594504172146974*^9}, {
   3.594504307321096*^9, 3.59450434971206*^9}, {3.594504752623733*^9, 
   3.5945047554061003`*^9}, {3.594504871225806*^9, 3.594504877936388*^9}, {
   3.5945055596668262`*^9, 3.594505568425068*^9}, {3.594652239886821*^9, 
   3.594652267738048*^9}, {3.59467142959534*^9, 3.594671431027108*^9}, {
   3.594932848207707*^9, 3.594932849799758*^9}, {3.594935348185996*^9, 
   3.594935350732348*^9}, {3.5949366625927267`*^9, 3.594936675178787*^9}, 
   3.595016298168294*^9, {3.595098352380693*^9, 3.59509838081502*^9}, {
   3.5950984859828587`*^9, 3.5950984975538483`*^9}, {3.5950992060014563`*^9, 
   3.595099209200944*^9}, {3.595106755617092*^9, 3.59510675682261*^9}, {
   3.595107319003234*^9, 3.595107326236487*^9}, {3.5951073744774647`*^9, 
   3.5951073843720512`*^9}, {3.5951117379493723`*^9, 3.595111746063115*^9}, {
   3.5951119238417053`*^9, 3.595111932456912*^9}, 3.595365716483788*^9, {
   3.596223353341857*^9, 3.596223359166494*^9}, {3.596227444951634*^9, 
   3.5962274497080107`*^9}, {3.596273577984915*^9, 3.596273605071785*^9}, 
   3.59646386845551*^9, {3.5965515766090918`*^9, 3.5965515896029987`*^9}, {
   3.596722017251544*^9, 3.5967220304878397`*^9}, {3.596761099718512*^9, 
   3.596761109185371*^9}, {3.59706725444414*^9, 3.5970672563701468`*^9}, {
   3.5970676907405777`*^9, 3.597067708722151*^9}, {3.5970991684417887`*^9, 
   3.597099168913548*^9}, {3.597319798822302*^9, 3.597319811922399*^9}, 
   3.597319850413365*^9, {3.597857215471332*^9, 3.597857267226129*^9}, {
   3.5978573137256327`*^9, 3.597857326631215*^9}, {3.59801452019693*^9, 
   3.598014521531755*^9}, 3.599851751650032*^9, {3.600706606144747*^9, 
   3.600706659773452*^9}, {3.60339581989427*^9, 3.6033958214954157`*^9}, {
   3.603409145758832*^9, 3.603409147201283*^9}, {3.603542970928772*^9, 
   3.6035429724744463`*^9}, {3.603550173037918*^9, 3.603550174671896*^9}, {
   3.603807370507317*^9, 3.60380738211386*^9}, {3.6038074877638063`*^9, 
   3.603807519807238*^9}, {3.603816404753533*^9, 3.603816406053636*^9}, {
   3.6039676533349133`*^9, 3.6039676768589697`*^9}, {3.603968007083645*^9, 
   3.603968014243576*^9}, {3.603971334990003*^9, 3.6039713803342733`*^9}, {
   3.603981691772496*^9, 3.603981692121807*^9}, {3.604003465394865*^9, 
   3.604003466630534*^9}, {3.6040040079694347`*^9, 3.6040040692227783`*^9}, {
   3.604004197041348*^9, 3.604004241826613*^9}, {3.604004276313704*^9, 
   3.6040043349571238`*^9}, {3.6040043805692053`*^9, 3.604004421463447*^9}, {
   3.604004469895645*^9, 3.604004513922512*^9}, {3.6040046278857517`*^9, 
   3.604004635042556*^9}, {3.604052919653323*^9, 3.604052921074033*^9}, 
   3.604056132882725*^9, {3.6040561814003143`*^9, 3.6040562364912148`*^9}, {
   3.604058052219502*^9, 3.604058053788744*^9}, {3.604081585639173*^9, 
   3.604081586818005*^9}, {3.6041012628885098`*^9, 3.604101263982148*^9}, {
   3.6041526413593903`*^9, 3.604152778317606*^9}, {3.604161038154252*^9, 
   3.604161044412672*^9}, {3.6041612029800053`*^9, 3.604161208063031*^9}, {
   3.6045165038236322`*^9, 3.604516506129974*^9}, {3.605041402439681*^9, 
   3.6050414034227552`*^9}, {3.605094441465953*^9, 3.605094442533757*^9}, {
   3.605905669180859*^9, 3.605905670413966*^9}, {3.606504052876608*^9, 
   3.606504053852453*^9}, {3.60656524662658*^9, 3.606565247870693*^9}, 
   3.60770074465532*^9, {3.607700894491021*^9, 3.6077009437496147`*^9}, {
   3.6077010589554567`*^9, 3.60770108050249*^9}, {3.607701173447282*^9, 
   3.6077013476842003`*^9}, 3.607708952229067*^9, {3.6077090649010468`*^9, 
   3.6077091270652313`*^9}, {3.607709164485268*^9, 3.607709167121694*^9}, {
   3.609681343399515*^9, 3.6096813721101437`*^9}, {3.609697539767413*^9, 
   3.6096975414792*^9}, {3.609784526919179*^9, 3.60978462056979*^9}, {
   3.6097850440602703`*^9, 3.609785056318077*^9}, 3.6098593388850737`*^9, {
   3.6105006460914288`*^9, 3.6105006471020927`*^9}, {3.610501797082596*^9, 
   3.6105019212384987`*^9}, {3.610541389991515*^9, 3.610541410604353*^9}, {
   3.610543438875368*^9, 3.61054344260537*^9}, {3.610543504896633*^9, 
   3.610543535107634*^9}, {3.610543612572315*^9, 3.610543684484585*^9}, 
   3.6105437227991667`*^9, 3.610543773069769*^9, {3.610657404227602*^9, 
   3.610657412986354*^9}, {3.610830808462391*^9, 3.610830947947979*^9}, {
   3.611057852565778*^9, 3.611057891313137*^9}, {3.6113244162270184`*^9, 
   3.611324525005494*^9}, {3.611325842651414*^9, 3.611325964787428*^9}, {
   3.6113301791609898`*^9, 3.611330204158825*^9}, 3.611334908508106*^9, 
   3.611335183756899*^9, {3.6113364162237377`*^9, 3.611336472433091*^9}, {
   3.611336504227975*^9, 3.6113365053152027`*^9}, {3.611337235444765*^9, 
   3.611337273708741*^9}, {3.611337377922061*^9, 3.611337397816841*^9}, 
   3.611337434170796*^9, {3.6113378787222967`*^9, 3.611337920455288*^9}, {
   3.6113384139425898`*^9, 3.611338524437406*^9}, {3.6113403309763823`*^9, 
   3.611340341607003*^9}, {3.6113403952528553`*^9, 3.6113405634536953`*^9}, {
   3.611344200446971*^9, 3.611344417316568*^9}, {3.611344449296412*^9, 
   3.611344614866522*^9}, {3.611344737207652*^9, 3.611344895274699*^9}, {
   3.6113449318963947`*^9, 3.6113449552207823`*^9}, {3.6113452968814096`*^9, 
   3.6113453496805487`*^9}, {3.611345388511642*^9, 3.611345540872859*^9}, {
   3.6113456025478287`*^9, 3.6113457898957577`*^9}, {3.611345841698388*^9, 
   3.611346110093336*^9}, {3.611346605656618*^9, 3.611346659455295*^9}, {
   3.6113467023446302`*^9, 3.611346786711089*^9}, {3.611346877714183*^9, 
   3.61134701911701*^9}, {3.611347067421777*^9, 3.611347560003193*^9}, {
   3.611347617686076*^9, 3.611347623661186*^9}, {3.611352285431233*^9, 
   3.611352325555724*^9}, {3.611352411160118*^9, 3.6113524116636333`*^9}, {
   3.611352466830634*^9, 3.6113524684418297`*^9}, 3.6113526502197647`*^9, 
   3.611352786606023*^9, {3.6113530238330584`*^9, 3.6113531511383543`*^9}, {
   3.611401934112834*^9, 3.6114019892534027`*^9}, {3.611402144957292*^9, 
   3.611402184563339*^9}, {3.611402226086554*^9, 3.611402453604703*^9}, {
   3.611402689136094*^9, 3.6114027230610533`*^9}, {3.611402818278263*^9, 
   3.611402940785427*^9}, {3.611402971768086*^9, 3.611403099005699*^9}, {
   3.6114031514786043`*^9, 3.611403161452056*^9}, {3.611403355055861*^9, 
   3.61140340816798*^9}, {3.611403464421294*^9, 3.611403501780781*^9}, {
   3.611403553132329*^9, 3.611403581168152*^9}, {3.61140363195821*^9, 
   3.611403633073916*^9}, {3.611403672052104*^9, 3.6114037409089327`*^9}, {
   3.61140377668631*^9, 3.611403945457706*^9}, {3.611404060585659*^9, 
   3.6114040867769938`*^9}, {3.6114043793308973`*^9, 3.611404413656144*^9}, {
   3.611404580949699*^9, 3.611404606189232*^9}, {3.6114048023772697`*^9, 
   3.611404825416172*^9}, {3.611404883691124*^9, 3.611404927119955*^9}, {
   3.611404981701631*^9, 3.611405002996537*^9}, {3.611406857101919*^9, 
   3.611406920422085*^9}, {3.6114069956593447`*^9, 3.611407016893119*^9}, {
   3.6114090858805647`*^9, 3.611409129508759*^9}, {3.611409175567478*^9, 
   3.61140921737576*^9}, {3.611409253019392*^9, 3.611409311418614*^9}, {
   3.611409346039339*^9, 3.611409359112913*^9}, {3.611409433481669*^9, 
   3.6114095085067873`*^9}, {3.611409539830052*^9, 3.611409563104268*^9}, {
   3.611409648183095*^9, 3.611409680785637*^9}, {3.611409719884927*^9, 
   3.611409735773966*^9}, {3.6114111843873253`*^9, 3.6114112154973993`*^9}, {
   3.611428594619253*^9, 3.611428613320983*^9}, {3.611503089447872*^9, 
   3.6115033934831676`*^9}, 3.611503448539278*^9, {3.611503479980041*^9, 
   3.6115035000955544`*^9}, {3.611505715430374*^9, 3.611505772130348*^9}, {
   3.611505805718206*^9, 3.611505817598289*^9}, {3.611505928692836*^9, 
   3.6115059296782637`*^9}, {3.61150610514246*^9, 3.611506168097466*^9}, {
   3.6115908447877913`*^9, 3.611590992206379*^9}, {3.611591312323811*^9, 
   3.611591415450995*^9}, {3.611591446993956*^9, 3.611591533353236*^9}, {
   3.6115917671362953`*^9, 3.611591781865183*^9}, {3.611591845643044*^9, 
   3.611591873296452*^9}, {3.611591948171556*^9, 3.611591980731173*^9}, {
   3.611592078859605*^9, 3.611592106896896*^9}, {3.611592203972699*^9, 
   3.611592224256708*^9}, {3.6115922551789637`*^9, 3.61159225528025*^9}, {
   3.611602129828635*^9, 3.6116021785686502`*^9}, {3.611602310562924*^9, 
   3.6116023409990673`*^9}, {3.611602383670669*^9, 3.611602490258275*^9}, {
   3.611602602367505*^9, 3.611602629061698*^9}, {3.611602662396019*^9, 
   3.611602664210948*^9}, {3.6116027568029213`*^9, 3.6116028432384653`*^9}, {
   3.611602928737363*^9, 3.611602934801454*^9}, {3.611603001580304*^9, 
   3.611603026937208*^9}, {3.611603194235249*^9, 3.611603199486364*^9}, {
   3.611603273589836*^9, 3.611603284247612*^9}, {3.611603515262145*^9, 
   3.6116036793511143`*^9}, {3.611603736896163*^9, 3.611603807345518*^9}, {
   3.611604839983081*^9, 3.6116048565128593`*^9}, {3.6116049285067377`*^9, 
   3.61160495140959*^9}, {3.611604997674511*^9, 3.611605004604744*^9}, 
   3.611607719047611*^9, {3.6116095283711452`*^9, 3.611609536781147*^9}, {
   3.6116098104981318`*^9, 3.611609843469531*^9}, {3.611612426581737*^9, 
   3.611612470036147*^9}, {3.611612556944491*^9, 3.6116125618311462`*^9}, 
   3.611614052823285*^9, {3.611614295234661*^9, 3.61161430136981*^9}, {
   3.611616632537026*^9, 3.611616662391904*^9}, {3.611616736943976*^9, 
   3.6116167840951557`*^9}, {3.611616817425606*^9, 3.611616820700158*^9}, {
   3.611616887527769*^9, 3.611616907819735*^9}, {3.611616994562722*^9, 
   3.611617035714443*^9}, {3.611617073553857*^9, 3.611617131949247*^9}, {
   3.6116171626984987`*^9, 3.6116172278120947`*^9}, {3.611617279131094*^9, 
   3.6116172851157427`*^9}, {3.6116214556237173`*^9, 3.611621521450667*^9}, 
   3.611645384454369*^9, {3.611645447226398*^9, 3.6116454481442823`*^9}, {
   3.6116606243403473`*^9, 3.611660637124936*^9}, {3.611660672869735*^9, 
   3.6116606842035427`*^9}, {3.611660764767602*^9, 3.611660806596868*^9}, {
   3.611660839072846*^9, 3.611660904064067*^9}, 3.6116609390431633`*^9, {
   3.611661027073657*^9, 3.611661066539721*^9}, {3.611662263323892*^9, 
   3.611662268539956*^9}, {3.611662408059132*^9, 3.611662553491457*^9}, {
   3.611662662679879*^9, 3.6116627117447157`*^9}, {3.611662923948555*^9, 
   3.611662929533847*^9}, {3.611662977803617*^9, 3.611663058956764*^9}, {
   3.611663089909041*^9, 3.611663104018507*^9}, {3.611663141620193*^9, 
   3.6116631614014997`*^9}, {3.6116636725641003`*^9, 3.611663804623563*^9}, {
   3.6116638376366863`*^9, 3.6116639911985693`*^9}, {3.611770295393733*^9, 
   3.6117703038462877`*^9}, {3.6118344094276457`*^9, 3.611834413541534*^9}, 
   3.61202964405189*^9, {3.612030464816306*^9, 3.6120304673500843`*^9}, {
   3.612038530581665*^9, 3.6120385530358353`*^9}, {3.612038677745232*^9, 
   3.6120386961277523`*^9}, {3.612039787786324*^9, 3.612039844720715*^9}, {
   3.612039896245668*^9, 3.6120398984752274`*^9}, {3.6120399491878223`*^9, 
   3.612039964938209*^9}, {3.612040141366255*^9, 3.61204022567817*^9}, {
   3.6120402666214113`*^9, 3.6120402791189213`*^9}, {3.6120403983146057`*^9, 
   3.6120404147866917`*^9}, {3.6120404708941097`*^9, 3.612040485387714*^9}, {
   3.612040535471334*^9, 3.612040577773923*^9}, {3.6120406727611313`*^9, 
   3.612040676615737*^9}, {3.612040725911175*^9, 3.6120408591467953`*^9}, {
   3.6120415957773113`*^9, 3.612041653989353*^9}, {3.612041906958583*^9, 
   3.612041944105445*^9}, {3.612041977938911*^9, 3.612041978658618*^9}, {
   3.6120420201878633`*^9, 3.6120421165004168`*^9}, {3.612042163106473*^9, 
   3.61204216471154*^9}, {3.6120940316965837`*^9, 3.6120940386582327`*^9}, {
   3.612094077533141*^9, 3.612094174529667*^9}, 3.612095804000678*^9, {
   3.6120958793269167`*^9, 3.612095894821218*^9}, {3.6120959317496243`*^9, 
   3.612095993606543*^9}, {3.612096634369329*^9, 3.612096640992239*^9}, {
   3.61209956121142*^9, 3.612099601596951*^9}, {3.61209967291033*^9, 
   3.612099739569571*^9}, {3.612099797732602*^9, 3.612099886816708*^9}, {
   3.612099967677156*^9, 3.612100022806437*^9}, {3.612100089948083*^9, 
   3.612100180475606*^9}, {3.6121002325001163`*^9, 3.6121002530443373`*^9}, {
   3.6121003598869247`*^9, 3.612100431919997*^9}, {3.612123869528582*^9, 
   3.61212387641847*^9}, {3.612124095545298*^9, 3.6121240967194347`*^9}, {
   3.6121242999416847`*^9, 3.612124309348521*^9}, {3.61213280493814*^9, 
   3.612132828697994*^9}, 3.61226765757825*^9, {3.612385597998209*^9, 
   3.612385647061499*^9}, {3.612385678049781*^9, 3.612385678663199*^9}, {
   3.612385746164057*^9, 3.61238579297582*^9}, {3.61238583213284*^9, 
   3.612385875044321*^9}, {3.612386076098205*^9, 3.612386138330822*^9}, {
   3.61238621406568*^9, 3.6123864871546097`*^9}, {3.612386592834424*^9, 
   3.612386595345366*^9}, {3.61238669783259*^9, 3.612386719465087*^9}, {
   3.612386763049239*^9, 3.6123869754467688`*^9}, {3.612387081523037*^9, 
   3.612387086900037*^9}, {3.61238714210116*^9, 3.6123871635919657`*^9}, {
   3.612387218495696*^9, 3.612387272597714*^9}, {3.612388453163433*^9, 
   3.612388509729362*^9}, {3.612388689937704*^9, 3.612388823354988*^9}, {
   3.612388922035955*^9, 3.6123889423713512`*^9}, {3.612438584739971*^9, 
   3.612438586018125*^9}, {3.612459504380815*^9, 3.6124596080047913`*^9}, {
   3.612459642327042*^9, 3.6124596681867943`*^9}, {3.6124597174275*^9, 
   3.612459756932399*^9}, {3.612529932459811*^9, 3.612529940999262*^9}, {
   3.612530094866077*^9, 3.612530135823183*^9}, {3.6125301707999067`*^9, 
   3.612530192472035*^9}, {3.612530357725339*^9, 3.612530393366385*^9}, {
   3.6125423297007847`*^9, 3.612542395897833*^9}, {3.612542460850719*^9, 
   3.612542823834886*^9}, {3.6125428915754547`*^9, 3.612542954087964*^9}, 
   3.61254309873851*^9, {3.612543659237805*^9, 3.612543659932743*^9}, {
   3.61254374455721*^9, 3.612543745300645*^9}, {3.612545901906189*^9, 
   3.6125459412764597`*^9}, {3.612546166832563*^9, 3.612546171467997*^9}, 
   3.61264208909579*^9, 3.612646148971404*^9, {3.612708599574895*^9, 
   3.612708622753731*^9}, 3.612987534341853*^9, {3.6129877145340233`*^9, 
   3.612987718080566*^9}, {3.6132637653718777`*^9, 3.613263780994561*^9}, 
   3.613264226482449*^9, {3.613266745099494*^9, 3.613266963706663*^9}, {
   3.613267026181794*^9, 3.613267027422632*^9}, {3.613305053919121*^9, 
   3.613305115693572*^9}, {3.6133052552237787`*^9, 3.613305256898961*^9}, {
   3.613563600431302*^9, 3.613563601016981*^9}, 3.613583059747168*^9, {
   3.6135861791155243`*^9, 3.613586270864945*^9}, {3.613586353476955*^9, 
   3.613586384603867*^9}, {3.6135865368771477`*^9, 3.613586564694858*^9}, {
   3.613771643041127*^9, 3.613771677849854*^9}, {3.613842066498301*^9, 
   3.6138421149241667`*^9}, 3.613842156519615*^9, 3.613842243285387*^9, 
   3.6148825743409357`*^9, {3.615706381595963*^9, 3.6157063973895683`*^9}, {
   3.615766831046301*^9, 3.615766832068151*^9}, 3.6169357045061398`*^9, 
   3.616965541571431*^9, {3.6169668951879396`*^9, 3.616966960415564*^9}, {
   3.6169686958968678`*^9, 3.616969104429738*^9}, 3.61696929738767*^9, {
   3.616969435414283*^9, 3.6169694769956093`*^9}, {3.616969598002757*^9, 
   3.616969598493371*^9}, {3.616969690318234*^9, 3.616969854967506*^9}, {
   3.616969901844253*^9, 3.616970074094339*^9}, {3.616970145842664*^9, 
   3.616970163123555*^9}, 3.6171199773011227`*^9, 3.617120015619646*^9, 
   3.61745540923536*^9, {3.617986855263095*^9, 3.617986881384048*^9}, {
   3.618000615882044*^9, 3.618000654968944*^9}, {3.618000700196775*^9, 
   3.6180007780171757`*^9}, {3.618000982719067*^9, 3.618000984414953*^9}, {
   3.618533170396345*^9, 3.618533175793386*^9}, 3.6186955773993998`*^9, {
   3.618738015350525*^9, 3.618738033085267*^9}, {3.6189309871383123`*^9, 
   3.618931014323516*^9}, {3.618954367451046*^9, 3.618954370931837*^9}, {
   3.620725270314445*^9, 3.6207253522822237`*^9}, {3.6279225915429363`*^9, 
   3.6279225925021667`*^9}, {3.627922780200569*^9, 3.6279228063315983`*^9}, {
   3.6279228608718653`*^9, 3.6279229207763977`*^9}, {3.627922967435993*^9, 
   3.627923441321862*^9}, {3.6437088547903433`*^9, 3.64370887653539*^9}, {
   3.643709722672995*^9, 3.6437097236592493`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Add", " ", "a", " ", "zero", " ", "bit", " ", "to", " ", "the", " ", 
      "fraction", " ", "length", " ", "of", " ", "an", " ", "exact", " ", 
      "unum"}], ",", " ", 
     RowBox[{"if", " ", 
      RowBox[{"possible", "."}]}]}], " ", "*)"}],
   FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"promotef", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{
       RowBox[{"unumQ", "[", "u", "]"}], "\[And]", 
       RowBox[{"exQ", "[", "u", "]"}]}]}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"fsize", "[", "u", "]"}], "<", "fsizemax"}], ",", 
      RowBox[{
       RowBox[{"2", 
        RowBox[{"BitAnd", "[", 
         RowBox[{
          RowBox[{"floatmask", "[", "u", "]"}], ",", "u"}], "]"}]}], "+", 
       RowBox[{"BitAnd", "[", 
        RowBox[{"utagmask", ",", "u"}], "]"}], "+", "1"}], ",", "u"}], 
     "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Increase", " ", "the", " ", "length", " ", "of", " ", "the", " ", 
       "exponent", " ", "field", " ", "of", " ", "an", " ", "exact", " ", 
       "unum"}], ",", " ", 
      RowBox[{"if", " ", 
       RowBox[{"possible", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"promotee", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{
       RowBox[{"unumQ", "[", "u", "]"}], "\[And]", 
       RowBox[{"exQ", "[", "u", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"e", "=", 
         RowBox[{"expo", "[", "u", "]"}]}], ",", 
        RowBox[{"es", "=", 
         RowBox[{"esize", "[", "u", "]"}]}], ",", 
        RowBox[{"f", "=", 
         RowBox[{"frac", "[", "u", "]"}]}], ",", 
        RowBox[{"fs", "=", 
         RowBox[{"fsize", "[", "u", "]"}]}], ",", 
        RowBox[{"s", "=", 
         RowBox[{"BitAnd", "[", 
          RowBox[{
           RowBox[{"signmask", "[", "u", "]"}], ",", "u"}], "]"}]}], ",", 
        RowBox[{"ut", "=", 
         RowBox[{
          RowBox[{"BitAnd", "[", 
           RowBox[{"utagmask", ",", "u"}], "]"}], "+", "fsizemax"}]}], ",", 
        "nsigbits"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "If", " ", "already", " ", "maximum", " ", "exponent", " ", 
           "size"}], ",", " ", 
          RowBox[{"do", " ", 
           RowBox[{"nothing", ".", " ", "This"}], " ", "also", " ", "handles",
            " ", "NaN", " ", "and", " ", "\[Infinity]", " ", 
           RowBox[{"values", "."}]}]}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], 
       StyleBox["\[IndentingNewLine]",
        FontColor->GrayLevel[0.5]], 
       RowBox[{
        RowBox[{"es", "\[Equal]", "esizemax"}], ",", "u", ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Take", " ", "care", " ", "of", " ", "u"}], "=", 
            RowBox[{"0", " ", "case"}]}], ",", " ", 
           RowBox[{"ignoring", " ", "the", " ", "sign", " ", 
            RowBox[{"bit", ".", " ", 
             RowBox[{"It", "'"}]}], "s", " ", "simply", " ", "the", " ", 
            "new", " ", 
            RowBox[{"utag", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"e", "\[Equal]", "0"}], "\[And]", 
         RowBox[{"f", "\[Equal]", "0"}]}], ",", "ut", ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"If", " ", "normal", " ", 
            RowBox[{"(", 
             RowBox[{"nonzero", " ", "exponent"}], ")"}]}], ",", " ", 
           RowBox[{"slide", " ", "sign", " ", "bit", " ", "left"}], ",", " ", 
           
           RowBox[{"add", " ", 
            SuperscriptBox["2", 
             RowBox[{"es", "-", "1"}]]}], ",", " ", 
           RowBox[{"increment", " ", 
            RowBox[{"esize", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{"e", ">", "0"}], ",", 
        RowBox[{
         RowBox[{"2", "s"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"e", "+", 
            SuperscriptBox["2", 
             RowBox[{"es", "-", "1"}]]}], ")"}], 
          RowBox[{"hiddenmask", "[", "u", "]"}]}], "+", 
         RowBox[{"BitAnd", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"hiddenmask", "[", "u", "]"}], "-", "1"}], ",", "u"}], 
          "]"}], "+", "fsizemax"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"Subnormal", ".", " ", "Room"}], " ", "to", " ", "shift", 
           " ", "and", " ", "stay", " ", 
           RowBox[{"subnormal", "?"}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"fs", "-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[LeftFloor]", 
             RowBox[{"Log", "[", 
              RowBox[{"2", ",", "f"}], "]"}], "\[RightFloor]"}], "+", "1"}], 
           ")"}]}], "\[GreaterEqual]", 
         SuperscriptBox["2", 
          RowBox[{"es", "-", "1"}]]}], ",", 
        RowBox[{
         RowBox[{"2", "s"}], "+", 
         RowBox[{
          RowBox[{"frac", "[", "u", "]"}], 
          SuperscriptBox["2", 
           SuperscriptBox["2", 
            RowBox[{"es", "-", "1"}]]], "ulpu"}], "+", "ut"}], ",", 
        "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{"Subnormal", " ", "becomes", " ", 
           RowBox[{"normal", ".", " ", "Trickiest"}], " ", 
           RowBox[{"case", "."}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
          "The", " ", "fraction", " ", "slides", " ", "left", " ", "such", 
           " ", "that", " ", "the", " ", "leftmost", " ", "1", " ", "becomes",
            " ", "the", " ", "hidden", " ", "bit"}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], "True", ",", 
        RowBox[{
         RowBox[{"nsigbits", "=", 
          RowBox[{
           RowBox[{"\[LeftFloor]", 
            RowBox[{"Log", "[", 
             RowBox[{"2", ",", "f"}], "]"}], "\[RightFloor]"}], "+", "1"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"2", "s"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["2", 
              RowBox[{"es", "-", "1"}]], "+", "1", "-", "fs", "+", 
             "nsigbits"}], ")"}], 
           RowBox[{"hiddenmask", "[", "u", "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"f", "-", 
             SuperscriptBox["2", "nsigbits"]}], ")"}], 
           SuperscriptBox["2", 
            RowBox[{"fs", "-", "nsigbits", "+", "1"}]], "ulpu"}], "+", 
          RowBox[{"BitAnd", "[", 
           RowBox[{"utagmask", ",", "u"}], "]"}], "+", "fsizemax"}]}]}], 
       "]"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Promote", " ", "a", " ", "pair", " ", "of", " ", "exact", " ", "unums", 
      " ", "to", " ", "the", " ", "same", " ", "esize", " ", "and", " ", 
      RowBox[{"fsize", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"promote", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u_", ",", "v_"}], "}"}], "/;", 
      RowBox[{
       RowBox[{"unumQ", "[", "u", "]"}], "\[And]", 
       RowBox[{"unumQ", "[", "v", "]"}], "\[And]", 
       RowBox[{"exQ", "[", "u", "]"}], "\[And]", 
       RowBox[{"exQ", "[", "v", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"eu", "=", 
         RowBox[{"esize", "[", "u", "]"}]}], ",", 
        RowBox[{"ev", "=", 
         RowBox[{"esize", "[", "v", "]"}]}], ",", 
        RowBox[{"fu", "=", 
         RowBox[{"fsize", "[", "u", "]"}]}], ",", 
        RowBox[{"fv", "=", 
         RowBox[{"fsize", "[", "v", "]"}]}], ",", 
        RowBox[{"ut", "=", "u"}], ",", 
        RowBox[{"vt", "=", "v"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"eu", "<", "ev"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ut", "=", 
            RowBox[{"promotee", "[", "ut", "]"}]}], ";", 
           RowBox[{"eu", "+=", "1"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"ev", "<", "eu"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"vt", "=", 
            RowBox[{"promotee", "[", "vt", "]"}]}], ";", 
           RowBox[{"ev", "+=", "1"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"fu", "<", "fv"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ut", "=", 
            RowBox[{"promotef", "[", "ut", "]"}]}], ";", 
           RowBox[{"fu", "+=", "1"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"fv", "<", "fu"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"vt", "=", 
            RowBox[{"promotef", "[", "vt", "]"}]}], ";", 
           RowBox[{"fv", "+=", "1"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"ut", ",", "vt"}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Demote", " ", "the", " ", "fraction", " ", "of", " ", "a", " ", "unum",
        " ", "if", " ", "possible"}], ",", " ", 
      RowBox[{"even", " ", "if", " ", "it", " ", "makes", " ", "it", " ", 
       RowBox[{"inexact", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"demotef", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     StyleBox[
      RowBox[{"(*", " ", 
       RowBox[{
       "Cannot", " ", "make", " ", "the", " ", "fraction", " ", "any", " ", 
        "smaller"}], " ", "*)"}],
      FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"fsize", "[", "u", "]"}], "\[Equal]", "1"}], "\[Or]", 
       RowBox[{"u", "\[Equal]", "posinfu"}], "\[Or]", 
       RowBox[{"u", "\[Equal]", "neginfu"}], "\[Or]", 
       RowBox[{"u", "\[Equal]", "qNaNu"}], "\[Or]", 
       RowBox[{"u", "\[Equal]", "sNaNu"}]}], ",", "u", ",", 
      "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
        "Else", " ", "shift", " ", "fraction", " ", "right", " ", "one", " ", 
         
         RowBox[{"bit", "."}]}], " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
      RowBox[{"BitOr", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"BitAnd", "[", 
          RowBox[{"u", ",", 
           RowBox[{"floatmask", "[", "u", "]"}]}], "]"}], "/", "2"}], ",", 
        RowBox[{
         RowBox[{"BitAnd", "[", 
          RowBox[{"utagmask", ",", "u"}], "]"}], "-", "1"}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"demotee", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{"unumQ", "[", "u", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"es", "=", 
         RowBox[{"esize", "[", "u", "]"}]}], ",", 
        RowBox[{"mask", "=", 
         RowBox[{
          RowBox[{"signmask", "[", "u", "]"}], "/", "4"}]}], ",", 
        RowBox[{"fm", "=", 
         RowBox[{"floatmask", "[", "u", "]"}]}], ",", 
        RowBox[{"ut", "=", 
         RowBox[{"BitAnd", "[", 
          RowBox[{"u", ",", "utagmask"}], "]"}]}], ",", "left2", ",", "ibit", 
        ",", 
        RowBox[{"s", "=", 
         RowBox[{"BitAnd", "[", 
          RowBox[{
           RowBox[{"signmask", "[", "u", "]"}], ",", "u"}], "]"}]}], ",", "e",
         ",", 
        RowBox[{"f", "=", 
         RowBox[{"frac", "[", "u", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"left2", "=", 
        RowBox[{
         RowBox[{"BitAnd", "[", 
          RowBox[{"u", ",", 
           RowBox[{"3", "mask"}]}], "]"}], "/", "mask"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
          "Cannot", " ", "make", " ", "the", " ", "exponent", " ", "any", " ", 
           RowBox[{"smaller", ":"}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{
          RowBox[{"es", "\[Equal]", "1"}], "\[Or]", 
          RowBox[{"u", "\[Equal]", "posinfu"}], "\[Or]", 
          RowBox[{"u", "\[Equal]", "neginfu"}], "\[Or]", 
          RowBox[{"u", "\[Equal]", "qNaNu"}], "\[Or]", 
          RowBox[{"u", "\[Equal]", "sNaNu"}]}], ",", "u", ",", 
         "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{"Subnormal", ",", " ", 
            RowBox[{
            "so", " ", "decreasing", " ", "expo", " ", "size", " ", "means", 
             " ", "shifting", " ", "fraction", " ", "right", " ", "by", " ", 
             SuperscriptBox["2", 
              SuperscriptBox["2", 
               RowBox[{"es", "-", "2"}]]], " ", 
             RowBox[{"bits", "."}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], 
         StyleBox["\[IndentingNewLine]",
          FontColor->GrayLevel[0.5]], 
         RowBox[{
          RowBox[{"expo", "[", "u", "]"}], "\[Equal]", "0"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"f", "=", 
           RowBox[{"f", "/", 
            SuperscriptBox["2", 
             SuperscriptBox["2", 
              RowBox[{"es", "-", "2"}]]]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"ibit", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"FractionalPart", "[", "f", "]"}], ">", "0"}], ",", 
             "ubitmask", ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"BitOr", "[", 
           RowBox[{"ibit", ",", 
            RowBox[{
             RowBox[{"s", "/", "2"}], "+", 
             RowBox[{
              RowBox[{"IntegerPart", "[", "f", "]"}], " ", "ulpu"}], "+", 
             "ut", "-", "fsizemax"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "If", " ", "the", " ", "left", " ", "two", " ", "exponent", " ", 
             "bits", " ", "are", " ", "00", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"but", " ", 
                RowBox[{"it", "'"}], "s", " ", "normal"}], ",", " ", 
               RowBox[{
               "since", " ", "we", " ", "fell", " ", "through", " ", "the", 
                " ", "previous", " ", "test"}]}], ")"}]}], ",", " ", 
            RowBox[{
             RowBox[{"result", " ", "switches", " ", "to", " ", 
              RowBox[{"subnormal", ".", " ", "The"}], " ", "exponent", " ", 
              "after", " ", "the", " ", "first", " ", "two", " ", "bits", " ",
               "joins", " ", "the", " ", "fraction", " ", "like", " ", "a", 
              " ", "fixed"}], "-", 
             RowBox[{"point", " ", "number"}]}], ",", " ", 
            RowBox[{
            "before", " ", "shifting", " ", "the", " ", "fraction", " ", "to",
              " ", "the", " ", 
             RowBox[{"right", ".", " ", "The"}], " ", "new", " ", "exponent", 
             " ", "is", " ", "zero"}], ",", " ", 
            RowBox[{"of", " ", 
             RowBox[{"course", "."}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"left2", "\[Equal]", "2^^00"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"f", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["2", 
               RowBox[{"fsize", "[", "u", "]"}]], "+", "f"}], ")"}], "/", 
            SuperscriptBox["2", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"expo", "[", "u", "]"}]}], "+", 
              SuperscriptBox["2", 
               RowBox[{"es", "-", "2"}]], "+", "1"}]]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"ibit", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"FractionalPart", "[", "f", "]"}], ">", "0"}], ",", 
             "ubitmask", ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"BitOr", "[", 
           RowBox[{"ibit", ",", 
            RowBox[{
             RowBox[{"s", "/", "2"}], "+", 
             RowBox[{
              RowBox[{"IntegerPart", "[", "f", "]"}], "ulpu"}], "+", "ut", 
             "-", "fsizemax"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "If", " ", "the", " ", "left", " ", "two", " ", "exponent", " ", 
             "bits", " ", "are", " ", "01", " ", "or", " ", "10"}], ",", " ", 
            
            RowBox[{
             RowBox[{
             "squeeze", " ", "out", " ", "the", " ", "second", " ", "bit"}], 
             ";", " ", 
             RowBox[{
             "if", " ", "that", " ", "leaves", " ", "a", " ", "subnormal", 
              " ", "exponent"}]}], ",", " ", 
            RowBox[{
            "shift", " ", "the", " ", "hidden", " ", "bit", " ", "and", " ", 
             "fraction", " ", "bits", " ", 
             RowBox[{"right", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], 
         StyleBox["\[IndentingNewLine]",
          FontColor->GrayLevel[0.5]], 
         RowBox[{"left2", "\[LessEqual]", "2^^10"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"e", "=", 
           RowBox[{
            RowBox[{"BitAnd", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"expomask", "[", "u", "]"}], "-", 
               RowBox[{"3", "mask"}]}], ",", "u"}], "]"}], "+", 
            RowBox[{
             RowBox[{"BitAnd", "[", 
              RowBox[{"u", ",", 
               RowBox[{"2", "mask"}]}], "]"}], "/", "2"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"e", "\[Equal]", "0"}], ",", 
            RowBox[{"f", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["2", 
                 RowBox[{"fsize", "[", "u", "]"}]], "+", "f"}], ")"}], "/", 
              "2"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"ibit", "=", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"FractionalPart", "[", "f", "]"}], ">", "0"}], ",", 
             "ubitmask", ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"BitOr", "[", 
           RowBox[{"ibit", ",", 
            RowBox[{
             RowBox[{"s", "/", "2"}], "+", "e", "+", 
             RowBox[{
              RowBox[{"IntegerPart", "[", "f", "]"}], "ulpu"}], "+", "ut", 
             "-", "fsizemax"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "If", " ", "the", " ", "first", " ", "two", " ", "exponent", " ", 
             "bits", " ", "are", " ", "11"}], ",", " ", 
            RowBox[{
            "always", " ", "get", " ", "an", " ", "unbounded", " ", "unum"}], 
            ",", " ", 
            RowBox[{"all", " ", "1", "s", " ", "for", " ", 
             RowBox[{"fraction", ":"}]}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], 
         StyleBox["\[IndentingNewLine]",
          FontColor->GrayLevel[0.5]], "True", ",", 
         RowBox[{
          RowBox[{"BitOr", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"BitAnd", "[", 
                RowBox[{"u", ",", 
                 RowBox[{"signmask", "[", "u", "]"}]}], "]"}], "+", 
               RowBox[{"(", 
                RowBox[{"fm", "-", 
                 RowBox[{"signmask", "[", "u", "]"}]}], ")"}]}], ")"}], "/", 
             "2"}], ",", "ut"}], "]"}], "-", "fsizemax"}]}], "]"}]}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Find", " ", "the", " ", "width", " ", "of", " ", "the", " ", "ULP", " ",
       "to", " ", "the", " ", "right", " ", "of", " ", "an", " ", "exact", 
      " ", "unum"}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ulphi", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{
       RowBox[{"unumQ", "[", "u", "]"}], "\[And]", 
       RowBox[{"exQ", "[", "u", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"s", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"ltuQ", "[", 
           RowBox[{
            RowBox[{"{", "u", "}"}], ",", 
            RowBox[{"{", 
             OverscriptBox["0", "^"], "}"}]}], "]"}], ",", 
          RowBox[{"-", "1"}], ",", "1"}], "]"}]}], "}"}], ",", 
      RowBox[{
       SubscriptBox[
        RowBox[{"u2g", "[", 
         RowBox[{"u", "+", 
          RowBox[{"s", " ", "ubitmask"}]}], "]"}], 
        RowBox[{"\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "-", 
       SubscriptBox[
        RowBox[{"u2g", "[", 
         RowBox[{"u", "+", 
          RowBox[{"s", " ", "ubitmask"}]}], "]"}], 
        RowBox[{"\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Look", " ", "for", " ", "alternative", " ", "unum", " ", "string", " ", 
      "that", " ", "favors", " ", "the", " ", 
      RowBox[{"exponent", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"favore", "[", 
     RowBox[{"unum_", "/;", 
      RowBox[{"unumQ", "[", "unum", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u", "=", 
        RowBox[{"demotef", "[", 
         RowBox[{"promotee", "[", "unum", "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"inexQ", "[", "u", "]"}], "\[Or]", 
         RowBox[{
          RowBox[{"esize", "[", "u", "]"}], "\[Equal]", "esizemax"}], "\[Or]", 
         RowBox[{
          RowBox[{"fsize", "[", "u", "]"}], "\[Equal]", "1"}], "\[Or]", 
         RowBox[{"inexQ", "[", "u", "]"}]}], ",", "u", ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"fsize", "[", "u", "]"}], ">", "1"}], "\[And]", 
            RowBox[{"exQ", "[", 
             RowBox[{"demotef", "[", "u", "]"}], "]"}]}], ",", 
           RowBox[{"u", "=", 
            RowBox[{"demotef", "[", "u", "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", "u"}]}], "]"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Look", " ", "for", " ", "alternative", " ", "unum", " ", "string", " ", 
      "that", " ", "favors", " ", "the", " ", 
      RowBox[{"fraction", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"favorf", "[", 
     RowBox[{"unum_", "/;", 
      RowBox[{"unumQ", "[", "unum", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u", "=", 
        RowBox[{"demotee", "[", 
         RowBox[{"padu", "[", "unum", "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"inexQ", "[", "u", "]"}], ",", "u", ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"fsize", "[", "u", "]"}], ">", "1"}], "\[And]", 
            RowBox[{"exQ", "[", 
             RowBox[{"demotef", "[", "u", "]"}], "]"}]}], ",", 
           RowBox[{"u", "=", 
            RowBox[{"demotef", "[", "u", "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", "u"}]}], "]"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Find", " ", "the", " ", "right", " ", "neighbor", " ", "of", " ", "a", 
      " ", 
      RowBox[{"unum", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nborhi", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"unumQ", "[", "u", "]"}]}], ",", "minpower_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "up", ",", "vp", ",", "s", ",", "t", ",", "ulpminu", ",", "ulpmin", 
        ",", 
        RowBox[{"overflow", "=", "False"}], ",", 
        RowBox[{"ut", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"u", "\[Equal]", 
             RowBox[{"BitAnd", "[", 
              RowBox[{
               RowBox[{"utagmask", "+", 
                RowBox[{"signmask", "[", "u", "]"}]}], ",", "u"}], "]"}]}], 
            "\[And]", 
            RowBox[{"exQ", "[", "u", "]"}]}], ",", 
           OverscriptBox["0", "^"], ",", "u"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"s", "=", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], 
         RowBox[{"sign", "[", "ut", "]"}]]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ulpminu", "=", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"minpower", "<", 
           RowBox[{"Log", "[", 
            RowBox[{"2", ",", "smallsubnormal"}], "]"}]}], ",", 
          "smallsubnormalu", ",", "\[IndentingNewLine]", 
          RowBox[{"minpower", ">", 
           RowBox[{"Log", "[", 
            RowBox[{"2", ",", "maxreal"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"overflow", "=", "True"}], ";", 
           OverscriptBox[
            SuperscriptBox["2", 
             RowBox[{"\[LeftFloor]", 
              RowBox[{"Log", "[", 
               RowBox[{"2", ",", "maxreal"}], "]"}], "\[RightFloor]"}]], 
            "^"]}], ",", "\[IndentingNewLine]", "True", ",", 
          OverscriptBox[
           SuperscriptBox["2", "minpower"], "^"]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ulpmin", "=", 
        SubscriptBox[
         RowBox[{"u2g", "[", "ulpminu", "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"u", "\[Equal]", "posinfu"}], "\[Or]", 
          RowBox[{"u", "\[Equal]", "sNaNu"}], "\[Or]", 
          RowBox[{"u", "\[Equal]", "qNaNu"}]}], ",", "qNaNu", ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Values", " ", "without", " ", "nbors", " ", "on", " ", "the", " ", 
           "high", " ", "side"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"u", "\[Equal]", "neginfu"}], ",", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{"overflow", ",", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"utagmask", "\[Equal]", "1"}], ",", 
             RowBox[{
              OverscriptBox[
               RowBox[{"-", "2"}], "^"], "+", "ubitmask"}], ",", 
             RowBox[{"(*", " ", 
              RowBox[{"Warlpiri", " ", "environment"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              OverscriptBox[
               RowBox[{"-", "3"}], "^"], "+", "ubitmask"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"negbigu", "+", "ubitmask"}]}], "]"}], ",", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"If", " ", "-", "\[Infinity]"}], ",", 
           RowBox[{"use", " ", "the", " ", 
            RowBox[{"(", 
             RowBox[{"\[Dash]", "\[Infinity]", ",", "x"}], ")"}], " ", "unum",
             " ", "with", " ", "the", " ", "most", " ", "negative", " ", 
            "x"}], ",", " ", 
           RowBox[{
           "unless", " ", "the", " ", "requested", " ", "minpower", " ", 
            "caused", " ", 
            RowBox[{"overflow", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"inexQ", "[", "u", "]"}], ",", 
         OverscriptBox[
          SubscriptBox[
           RowBox[{"u2g", "[", "u", "]"}], 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "^"], ",", 
         " ", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"If", " ", "inexact"}], ",", " ", 
           RowBox[{
           "always", " ", "use", " ", "the", " ", "exact", " ", "upper", " ", 
            "value"}]}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"overflow", "\[And]", 
          RowBox[{"u", "\[Equal]", 
           OverscriptBox["2", "^"]}], "\[And]", 
          RowBox[{"utagmask", "\[Equal]", "1"}]}], ",", 
         RowBox[{
          OverscriptBox["2", "^"], "+", "ubitmask"}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{"Warlpiri", " ", "\"\<many\>\""}], " ", "*)"}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"overflow", "\[And]", 
          RowBox[{"u", "\[Equal]", 
           OverscriptBox["3", "^"]}], "\[And]", 
          RowBox[{"utagmask", "\[NotEqual]", "1"}]}], ",", 
         RowBox[{
          OverscriptBox["3", "^"], "+", "ubitmask"}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{"Also", " ", "OK", " ", "to", " ", "use", " ", 
           RowBox[{"(", 
            RowBox[{"3", ",", "\[Infinity]"}], ")"}]}], " ", "*)"}], 
         RowBox[{"(*", " ", 
          RowBox[{
          "OK", " ", "to", " ", "overflow", " ", "to", " ", "\[Infinity]", 
           " ", "if", " ", "the", " ", "minpower", " ", "overflowed", " ", 
           "the", " ", 
           RowBox[{"environment", "."}]}], " ", "*)"}], "\[IndentingNewLine]",
          "True", ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Reduce", " ", "ULP", " ", "until", " ", "it", " ", "equals", " ", 
            "ulpmin"}], ",", " ", 
           RowBox[{
           "or", " ", "we", " ", "run", " ", "out", " ", "of", " ", 
            "exponent", " ", "and", " ", "fraction", " ", "bits"}]}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"t", "=", 
           SubscriptBox[
            RowBox[{"u2g", "[", "ut", "]"}], 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ";", 
          RowBox[{"ut", "=", 
           OverscriptBox["t", "^"]}], ";", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"\[Not]", 
             RowBox[{"IntegerQ", "[", 
              RowBox[{"t", "/", "ulpmin"}], "]"}]}], ",", 
            RowBox[{"ulpmin", "/=", "2"}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ulphi", "[", "ut", "]"}], "<", "ulpmin"}], "\[And]", 
             RowBox[{"ut", "\[NotEqual]", 
              RowBox[{"favorf", "[", "ut", "]"}]}]}], ",", 
            RowBox[{"ut", "=", 
             RowBox[{"favorf", "[", "ut", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"esize", "[", "ut", "]"}], "<", "esizemax"}], "\[And]", 
             
             RowBox[{
              RowBox[{"ulphi", "[", 
               RowBox[{"promotee", "[", "ut", "]"}], "]"}], "\[GreaterEqual]",
               "ulpmin"}]}], ",", 
            RowBox[{"ut", "=", 
             RowBox[{"promotee", "[", "ut", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"fsize", "[", "ut", "]"}], "<", "fsizemax"}], "\[And]", 
             
             RowBox[{
              RowBox[{"ulphi", "[", 
               RowBox[{"promotef", "[", "ut", "]"}], "]"}], "\[GreaterEqual]",
               "ulpmin"}]}], ",", 
            RowBox[{"ut", "=", 
             RowBox[{"promotef", "[", "ut", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"ut", "+", 
           RowBox[{"s", " ", "ubitmask"}]}]}]}], "]"}]}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Find", " ", "the", " ", "left", " ", "neighbor", " ", "of", " ", "a", 
      " ", 
      RowBox[{"unum", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"nborlo", "[", 
     RowBox[{
      RowBox[{"u_", "/;", 
       RowBox[{"unumQ", "[", "u", "]"}]}], ",", "minpower_"}], "]"}], ":=", 
    StyleBox[
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "Watch", " ", "out", " ", "for", " ", "negative", " ", "zero"}], ",", 
       " ", 
       RowBox[{"otherwise", " ", "use", " ", "nborhi"}]}], " ", "*)"}],
     FontColor->GrayLevel[0.5]], 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"sameuQ", "[", 
        RowBox[{
         RowBox[{"{", 
          OverscriptBox["u", "^"], "}"}], ",", 
         RowBox[{"{", 
          OverscriptBox["0", "^"], "}"}]}], "]"}], "\[And]", 
       RowBox[{"minpower", "<", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", "smallsubnormal"}], "]"}]}]}], ",", 
      RowBox[{"smallsubnormalu", "+", "signbigu", "-", "ubitmask"}], ",", 
      SubscriptBox[
       RowBox[{"negateu", "[", 
        RowBox[{"{", 
         RowBox[{"nborhi", "[", 
          RowBox[{
           SubscriptBox[
            RowBox[{"negateu", "[", 
             RowBox[{"{", "u", "}"}], "]"}], 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           ",", "minpower"}], "]"}], "}"}], "]"}], 
       RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
     "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Create", " ", "a", " ", "list", " ", "of", " ", "1"}], "-", 
      RowBox[{"dimensional", " ", "uboxes", " ", "from", " ", "a", " ", 
       RowBox[{"ubound", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"uboxlist", "[", 
     RowBox[{
      RowBox[{"ub_", "/;", 
       RowBox[{"uboundQ", "[", "ub", "]"}]}], ",", "minpower_Integer"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"utest", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            SubscriptBox["ub", 
             RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
            "===", "neginfu"}], ",", "neginfu", ",", 
           RowBox[{"nborhi", "[", 
            RowBox[{
             RowBox[{"nborlo", "[", 
              RowBox[{
               SubscriptBox["ub", 
                RowBox[{
                "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], ",", 
               "minpower"}], "]"}], ",", "minpower"}], "]"}]}], "]"}]}], ",", 
        
        RowBox[{"list1", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"list2", "=", 
         RowBox[{"{", "}"}]}], ",", "infinitybits", ",", "nbortemp"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "===",
           "qNaNu"}], "\[Or]", 
         RowBox[{
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "===", "qNaNu"}], 
         "\[Or]", 
         RowBox[{
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "===",
           "sNaNu"}], "\[Or]", 
         RowBox[{
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "===", 
          "sNaNu"}]}], ",", 
        RowBox[{"{", "qNaNu", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"sameuQ", "[", 
         RowBox[{"ub", ",", 
          RowBox[{"{", "neginfu", "}"}]}], "]"}], ",", 
        RowBox[{"{", "neginfu", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"sameuQ", "[", 
         RowBox[{"ub", ",", 
          RowBox[{"{", "posinfu", "}"}]}], "]"}], ",", 
        RowBox[{"{", "posinfu", "}"}], ",", "\[IndentingNewLine]", "True", 
        ",", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Go", " ", "up", " ", "until", " ", "we", " ", "exceed", " ", "the", 
          " ", "ubound", " ", 
          RowBox[{"range", ".", " ", "Possible"}], " ", "to", " ", "exceed", 
          " ", "using", " ", "first", " ", 
          RowBox[{"utest", "!"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"infinitybits", "=", 
          RowBox[{"ubitmask", "+", 
           RowBox[{"expomask", "[", "utest", "]"}], "+", 
           RowBox[{"fracmask", "[", "utest", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"nbortemp", "=", 
          RowBox[{"nborhi", "[", 
           RowBox[{"utest", ",", "minpower"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"BitAnd", "[", 
              RowBox[{"infinitybits", ",", "utest"}], "]"}], "\[Equal]", 
             "infinitybits"}], "\[And]", 
            RowBox[{
             RowBox[{"esize", "[", "utest", "]"}], "<", "esizemax"}], 
            "\[And]", 
            RowBox[{"nequQ", "[", 
             RowBox[{
              RowBox[{"intersectu", "[", 
               RowBox[{"ub", ",", 
                RowBox[{"{", "nbortemp", "}"}]}], "]"}], ",", 
              RowBox[{"{", "nbortemp", "}"}]}], "]"}]}], ",", 
           RowBox[{"utest", "=", 
            RowBox[{
             RowBox[{"promotee", "[", 
              RowBox[{"exact", "[", "utest", "]"}], "]"}], "+", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"inexQ", "[", "utest", "]"}], ",", "ubitmask", ",", 
               "0"}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"sameuQ", "[", 
             RowBox[{
              RowBox[{"intersectu", "[", 
               RowBox[{"ub", ",", 
                RowBox[{"{", "utest", "}"}]}], "]"}], ",", 
              RowBox[{"{", "utest", "}"}]}], "]"}], "\[And]", 
            RowBox[{"(", 
             RowBox[{"utest", "=!=", "posinfu"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"list1", "=", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"list1", ",", "utest"}], "]"}]}], ";", 
            RowBox[{"utest", "=", 
             RowBox[{"nborhi", "[", 
              RowBox[{"utest", ",", "minpower"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"BitAnd", "[", 
                 RowBox[{"infinitybits", ",", "utest"}], "]"}], "\[Equal]", 
                "infinitybits"}], "\[And]", 
               RowBox[{
                RowBox[{"esize", "[", "utest", "]"}], "<", "esizemax"}], 
               "\[And]", 
               RowBox[{"nequQ", "[", 
                RowBox[{
                 RowBox[{"intersectu", "[", 
                  RowBox[{"ub", ",", 
                   RowBox[{"{", "utest", "}"}]}], "]"}], ",", 
                 RowBox[{"{", "utest", "}"}]}], "]"}]}], ",", 
              RowBox[{"utest", "=", 
               RowBox[{
                RowBox[{"promotee", "[", 
                 RowBox[{"exact", "[", "utest", "]"}], "]"}], "+", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"inexQ", "[", "utest", "]"}], ",", "ubitmask", ",", 
                  "0"}], "]"}]}]}]}], "]"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Start", " ", "from", " ", "other", " ", "end", " ", "and", " ", 
           "go", " ", "down", " ", "until", " ", "utest", " ", "equals", " ", 
           "last", " ", "element", " ", "of", " ", 
           RowBox[{"list1", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"utest", "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             SubscriptBox["ub", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "===", 
             "posinfu"}], ",", "posinfu", ",", 
            RowBox[{"nborlo", "[", 
             RowBox[{
              RowBox[{"nborhi", "[", 
               RowBox[{
                SubscriptBox["ub", 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], ",", 
                "minpower"}], "]"}], ",", "minpower"}], "]"}]}], "]"}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"gtuQ", "[", 
             RowBox[{
              RowBox[{"{", "utest", "}"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", "list1", "]"}], "\[Equal]", "0"}], 
                ",", 
                RowBox[{"{", 
                 OverscriptBox[
                  RowBox[{" ", 
                   SubscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u2g", "[", "ub", "]"}], ")"}], 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
                  "^"], "}"}], ",", 
                RowBox[{"{", 
                 SubscriptBox["list1", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "}"}]}], 
               "]"}]}], "]"}], "\[And]", 
            RowBox[{"utest", "\[NotEqual]", "neginfu"}]}], ",", 
           RowBox[{
            RowBox[{"PrependTo", "[", 
             RowBox[{"list2", ",", "utest"}], "]"}], ";", 
            RowBox[{"utest", "=", 
             RowBox[{"nborlo", "[", 
              RowBox[{"utest", ",", "minpower"}], "]"}]}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Join", "[", 
          RowBox[{"list1", ",", "list2"}], "]"}]}]}], "]"}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Create", " ", "a", " ", "1"}], "-", 
      RowBox[{
      "dimensional", " ", "ubox", " ", "list", " ", "that", " ", "leaves", 
       " ", "out", " ", "the", " ", "exact", " ", 
       RowBox[{"unums", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"uboxlistinexact", "[", 
     RowBox[{
      RowBox[{"ub_", "/;", 
       RowBox[{"uboundQ", "[", "ub", "]"}]}], ",", "minpower_Integer"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"set", "=", 
         RowBox[{"uboxlist", "[", 
          RowBox[{"ub", ",", "minpower"}], "]"}]}], ",", 
        RowBox[{"temp", "=", 
         RowBox[{"{", "}"}]}], ",", "i"}], "}"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "set", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"inexQ", "[", 
            SubscriptBox["set", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            "]"}], ",", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"temp", ",", 
             SubscriptBox["set", 
              RowBox[{
              "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], 
            "]"}]}], "]"}]}], "]"}], ";", "temp"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "2"}], "-", 
      RowBox[{
      "dimensional", " ", "ubox", " ", "as", " ", "a", " ", "rounded", " ", 
       RowBox[{"rectangle", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ubox2D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xu_", ",", "yu_"}], "}"}], ",", "r_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xlo", "=", 
         SubscriptBox[
          RowBox[{"u2g", "[", "xu", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"xhi", "=", 
         SubscriptBox[
          RowBox[{"u2g", "[", "xu", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"ylo", "=", 
         SubscriptBox[
          RowBox[{"u2g", "[", "yu", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"yhi", "=", 
         SubscriptBox[
          RowBox[{"u2g", "[", "yu", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EdgeForm", "[", 
         RowBox[{"{", 
          RowBox[{"White", ",", 
           RowBox[{"Thickness", "[", ".0008", "]"}]}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"inexQ", "[", "xu", "]"}], "\[And]", 
           RowBox[{"inexQ", "[", "yu", "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xlo", "+", "r"}], ",", 
              RowBox[{"ylo", "+", "r"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xhi", "-", "r"}], ",", 
              RowBox[{"yhi", "-", "r"}]}], "}"}], ",", 
            RowBox[{"RoundingRadius", "\[Rule]", "r"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"exQ", "[", "xu", "]"}], ")"}], "\[And]", 
           RowBox[{"inexQ", "[", "yu", "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xlo", "-", "r"}], ",", 
              RowBox[{"ylo", "+", "r"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xlo", "+", "r"}], ",", 
              RowBox[{"yhi", "-", "r"}]}], "}"}], ",", 
            RowBox[{"RoundingRadius", "\[Rule]", "r"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"inexQ", "[", "xu", "]"}], "\[And]", 
           RowBox[{"(", 
            RowBox[{"exQ", "[", "yu", "]"}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xlo", "+", "r"}], ",", 
              RowBox[{"ylo", "-", "r"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"xhi", "-", "r"}], ",", 
              RowBox[{"ylo", "+", "r"}]}], "}"}], ",", 
            RowBox[{"RoundingRadius", "\[Rule]", "r"}]}], "]"}], ",", 
          "\[IndentingNewLine]", "True", ",", 
          RowBox[{"Disk", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"xlo", ",", "ylo"}], "}"}], ",", "r"}], "]"}]}], "]"}]}],
        "}"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Split", " ", "a", " ", "ubound", " ", "into", " ", "three", " ", 
       "parts"}], ",", " ", 
      RowBox[{"if", " ", 
       RowBox[{"possible", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"splitub", "[", 
     RowBox[{"ub_", "/;", 
      RowBox[{"uboundQ", "[", "ub", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"b1", ",", "b2", ",", "g1", ",", "g2", ",", "gm"}], "}"}], ",",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"g1", ",", "g2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b1", ",", "b2"}], "}"}]}], "}"}], "=", " ", 
        RowBox[{"u2g", "[", "ub", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"g1", ",", "g2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"b1", ",", "b2"}], "}"}]}], "}"}], "===", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Indeterminate", ",", "Indeterminate"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], "}"}]}], ",", 
         RowBox[{"{", "ub", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Not]", "b1"}], "\[And]", 
          RowBox[{"\[Not]", "b2"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"g1", "\[Equal]", "g2"}], ",", 
           RowBox[{"{", "ub", "}"}], ",", 
           StyleBox[
            RowBox[{"(*", " ", 
             RowBox[{
             "Cannot", " ", "split", " ", "exact", " ", "single", " ", 
              "values"}], " ", "*)"}],
            FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              SubscriptBox["ub", 
               RowBox[{
               "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], "}"}],
              ",", 
             RowBox[{"g2u", "[", GridBox[{
                {"g1", "g2"},
                {"open", "open"}
               }], "]"}], ",", 
             RowBox[{"{", 
              SubscriptBox["ub", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "}"}]}], 
            "}"}]}], "]"}], ",", " ", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
           "else", " ", "cleave", " ", "off", " ", "exact", " ", 
            "endpoints"}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"b1", "\[And]", 
          RowBox[{"\[Not]", "b2"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"g2u", "[", GridBox[{
              {"g1", "g2"},
              {"open", "open"}
             }], "]"}], ",", 
           RowBox[{"{", 
            SubscriptBox["ub", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "}"}]}], "}"}], 
         ",", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
           "cleave", " ", "off", " ", "exact", " ", "right", " ", 
            "endpoint"}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Not]", "b1"}], "\[And]", "b2"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            SubscriptBox["ub", 
             RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
            "}"}], ",", 
           RowBox[{"g2u", "[", GridBox[{
              {"g1", "g2"},
              {"open", "open"}
             }], "]"}]}], "}"}], ",", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
           "cleave", " ", "off", " ", "exact", " ", "left", " ", "endpoint"}],
            " ", "*)"}],
          FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
         RowBox[{"g1", "\[Equal]", 
          RowBox[{"-", "\[Infinity]"}]}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"g2", "\[Equal]", 
            RowBox[{"-", "maxreal"}]}], ",", 
           RowBox[{"{", "ub", "}"}], ",", " ", 
           RowBox[{"(*", " ", 
            RowBox[{
            "Cannot", " ", "split", " ", "the", " ", "negative", " ", 
             "\"\<many\>\"", " ", "region"}], " ", "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"negbigu", "+", "ubitmask"}], "}"}], ",", 
             RowBox[{"{", "negbigu", "}"}], ",", 
             RowBox[{"g2u", "[", GridBox[{
                {
                 RowBox[{"-", "maxreal"}], "g2"},
                {"open", "open"}
               }], "]"}]}], "}"}]}], "]"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{"g2", "\[Equal]", "\[Infinity]"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"g1", "\[Equal]", "maxreal"}], ",", 
           RowBox[{"{", "ub", "}"}], ",", " ", 
           RowBox[{"(*", " ", 
            RowBox[{
            "Cannot", " ", "split", " ", "the", " ", "positive", " ", 
             "\"\<many\>\"", " ", "region"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"g2u", "[", GridBox[{
                {"g1", "maxreal"},
                {"open", "open"}
               }], "]"}], ",", 
             RowBox[{"{", "maxrealu", "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"maxrealu", "+", "ubitmask"}], "}"}]}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
           "See", " ", "if", " ", "open", " ", "interval", " ", "contains", 
            " ", "a", " ", "unum", " ", "different", " ", "from", " ", 
            "either", " ", 
            RowBox[{"endpoint", ":"}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], 
         StyleBox["\[IndentingNewLine]",
          FontColor->GrayLevel[0.5]], 
         RowBox[{
          RowBox[{"gm", "=", 
           RowBox[{"u2g", "[", 
            OverscriptBox[
             RowBox[{
              RowBox[{"(", 
               RowBox[{"g1", "+", "g2"}], ")"}], "/", "2"}], "^"], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{
           SubscriptBox["gm", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ">", 
           "g1"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"g2u", "[", GridBox[{
              {"g1", 
               SubscriptBox["gm", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]},
              {"open", "open"}
             }], "]"}], ",", 
           RowBox[{"{", 
            OverscriptBox[
             SubscriptBox["gm", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "^"], 
            "}"}], ",", 
           RowBox[{"g2u", "[", GridBox[{
              {
               SubscriptBox["gm", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "g2"},
              {"open", "open"}
             }], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          SubscriptBox["gm", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "<", "g2"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"g2u", "[", GridBox[{
              {"g1", 
               SubscriptBox["gm", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]},
              {"open", "open"}
             }], "]"}], ",", 
           RowBox[{"{", 
            OverscriptBox[
             SubscriptBox["gm", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "^"], 
            "}"}], ",", 
           RowBox[{"g2u", "[", GridBox[{
              {
               SubscriptBox["gm", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "g2"},
              {"open", "open"}
             }], "]"}]}], "}"}], ",", "\[IndentingNewLine]", "True", ",", 
         RowBox[{"{", "ub", "}"}]}], "]"}]}]}], "]"}]}], " ", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Cannot", " ", "split"}], ";", " ", 
      RowBox[{"must", " ", "be", " ", "smallest", " ", "ULP", " ", 
       RowBox[{"size", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "3"}], "-", 
      RowBox[{"dimensional", " ", "ubox", " ", "as", " ", "a", " ", 
       RowBox[{"hexahedron", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"ubox3DtoCuboid", "[", "ub_", "]"}], ":=", 
    RowBox[{"Cuboid", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
          "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]], 
          "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
          "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]], 
          "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "}"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "3"}], "-", 
      RowBox[{"dimensional", " ", "ubound", " ", "as", " ", "a", " ", 
       RowBox[{"hexahedron", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"ubound3DtoCuboid", "[", "ub_", "]"}], ":=", 
    RowBox[{"Cuboid", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}]], "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", 
             RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]], "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"2", ",", 
             RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]], "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox[
         RowBox[{"u2g", "[", 
          SubscriptBox["ub", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"3", ",", 
             RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]], "]"}], 
         RowBox[{"\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "}"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "2"}], "-", 
      RowBox[{"dimensional", " ", "range", " ", "as", " ", "a", " ", "gel"}], 
      "-", 
      RowBox[{"style", " ", "3", "D", " ", 
       RowBox[{"object", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"gel2D", "[", 
     RowBox[{
     "xlo_", ",", "xhi_", ",", "ylo_", ",", "yhi_", ",", "r_", ",", "color_", 
      ",", "dropshadow_"}], "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"ylo", "=!=", "NaN"}], "\[And]", 
       RowBox[{"yhi", "=!=", "NaN"}]}], ",", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x1", "=", 
           RowBox[{"xlo", "+", 
            RowBox[{"2", "r", " ", 
             RowBox[{"Boole", "[", 
              RowBox[{"xlo", "<", 
               RowBox[{"xhi", "-", 
                RowBox[{"4", "r"}]}]}], "]"}]}]}]}], ",", 
          RowBox[{"x2", "=", 
           RowBox[{"xhi", "-", 
            RowBox[{"2", "r", " ", 
             RowBox[{"Boole", "[", 
              RowBox[{"xlo", "<", 
               RowBox[{"xhi", "-", 
                RowBox[{"4", "r"}]}]}], "]"}]}]}]}], ",", 
          RowBox[{"y1", "=", 
           RowBox[{"ylo", "+", 
            RowBox[{"2", "r", " ", 
             RowBox[{"Boole", "[", 
              RowBox[{"ylo", "<", 
               RowBox[{"yhi", "-", 
                RowBox[{"4", "r"}]}]}], "]"}]}]}]}], ",", 
          RowBox[{"y2", "=", 
           RowBox[{"yhi", "-", 
            RowBox[{"2", "r", " ", 
             RowBox[{"Boole", "[", 
              RowBox[{"ylo", "<", 
               RowBox[{"yhi", "-", 
                RowBox[{"4", "r"}]}]}], "]"}]}]}]}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{"dropshadow", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Blend", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"White", ",", "Gray"}], "}"}], ",", 
                    RowBox[{"1.3", "t"}]}], "]"}], ",", 
                  RowBox[{"Rectangle", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x1", "-", "r", "+", 
                    RowBox[{"r", " ", "t"}]}], ",", 
                    RowBox[{"y1", "+", 
                    RowBox[{"r", " ", "t"}], "-", "r", "-", 
                    RowBox[{".5", "r"}]}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x2", "+", "r", " ", "-", 
                    RowBox[{"r", " ", "t"}]}], ",", 
                    RowBox[{"y2", "+", "r", "-", 
                    RowBox[{"r", " ", "t"}], "-", 
                    RowBox[{".5", "r"}]}]}], "}"}], ",", 
                    RowBox[{"RoundingRadius", "\[Rule]", 
                    RowBox[{"r", "-", 
                    RowBox[{"r", " ", "t"}]}]}]}], "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"t", ",", "0", ",", ".5", ",", ".03125"}], "}"}]}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Blend", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"color", ",", 
                    RowBox[{"Blend", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"color", ",", "White"}], "}"}], ",", ".5"}], 
                    "]"}]}], "}"}], ",", "t"}], "]"}], ",", 
                RowBox[{"Rectangle", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x1", "-", "r", "+", 
                    RowBox[{"r", " ", "t"}]}], ",", 
                    RowBox[{"y1", "-", "r", " ", "+", 
                    RowBox[{".2", "r", " ", "t"}]}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x2", "+", "r", "-", 
                    RowBox[{"r", " ", "t"}]}], ",", 
                    RowBox[{"y2", "+", "r", " ", "-", 
                    RowBox[{"1.8", "r", " ", "t"}]}]}], "}"}], ",", 
                  RowBox[{"RoundingRadius", "\[Rule]", 
                   RowBox[{"r", " ", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", "t"}], ")"}]}]}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", "1", ",", ".03125"}], "}"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Blend", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Blend", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"color", ",", "White"}], "}"}], ",", ".25"}], 
                    "]"}], ",", "White"}], "}"}], ",", "t"}], "]"}], ",", 
                RowBox[{"Rectangle", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x1", "-", "r", "+", 
                    RowBox[{".55", "r"}], "+", 
                    RowBox[{".45", "r", " ", "t"}]}], ",", 
                    RowBox[{"y2", "+", 
                    RowBox[{".81", "r", " ", "t"}]}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x2", "+", "r", "-", 
                    RowBox[{".55", "r"}], "-", 
                    RowBox[{".45", "r", " ", "t"}]}], ",", 
                    RowBox[{"y2", "+", 
                    RowBox[{".9", "r"}], "-", 
                    RowBox[{".09", "t", " ", "r"}]}]}], "}"}], ",", 
                  RowBox[{"RoundingRadius", "\[Rule]", 
                   RowBox[{".45", "r", " ", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", "t"}], ")"}]}]}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", "1", ",", ".03125"}], "}"}]}], 
             "]"}]}], "}"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Display", " ", "a", " ", "2"}], "-", 
      RowBox[{"dimensional", " ", "ubox", " ", "as", " ", "a", " ", "gel"}], 
      "-", 
      RowBox[{"style", " ", "3", "D", " ", 
       RowBox[{"object", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"showbox2D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xu_", ",", "yu_"}], "}"}], ",", "r_", ",", "color_"}], "]"}], 
    ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x", "=", 
         SubscriptBox[
          RowBox[{"u2g", "[", "xu", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
        ",", 
        RowBox[{"y", "=", 
         SubscriptBox[
          RowBox[{"u2g", "[", "yu", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}]}],
        "}"}], ",", 
      RowBox[{"gel2D", "[", 
       RowBox[{
        SubscriptBox["x", 
         RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox["x", 
         RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox["y", 
         RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], ",", 
        SubscriptBox["y", 
         RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], ",",
         "r", ",", "color", ",", "False"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Display", " ", "a", " ", "2"}], "-", 
       RowBox[{
       "dimensional", " ", "ubox", " ", "as", " ", "a", " ", "simple", " ", 
        "rectangle"}]}], ",", " ", 
      RowBox[{"without", " ", "rounded", " ", 
       RowBox[{"corners", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{
     RowBox[{"showbound2D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xub_", ",", "yub_"}], "}"}], ",", "color_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xlo", ",", "xhi", ",", "ylo", ",", "yhi"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"xlo", ",", "xhi"}], "}"}], "=", " ", 
         SubscriptBox[
          RowBox[{"u2g", "[", "xub", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ylo", ",", "yhi"}], "}"}], "=", " ", 
         SubscriptBox[
          RowBox[{"u2g", "[", "yub", "]"}], 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{"color", ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"xlo", ",", "ylo"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"xhi", ",", "yhi"}], "}"}]}], "]"}]}], "}"}], "]"}]}]}],
       "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Make", " ", "a", " ", "single", " ", "pass", " ", "at", " ", "a", " ", 
       "set", " ", "of", " ", "2"}], "-", 
      RowBox[{
      "dimensional", " ", "uboxes", " ", "to", " ", "coalesce", " ", 
       "subsets", " ", "that", " ", "form", " ", "a", " ", "coarser", " ", 
       "single", " ", "ULP"}], "-", 
      RowBox[{"wide", " ", 
       RowBox[{"unum", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"coalescepass", "[", "set_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "gset", ",", "g", ",", "g1", ",", "g2", ",", "ndim", ",", "udim", ",", 
        "width", ",", "i", ",", "j"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ndim", "=", 
        RowBox[{"Length", "[", 
         SubscriptBox["set", 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"gset", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"u2g", "[", 
           SubscriptBox["set", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]], "]"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "set", "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", "ndim"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"j", "=", "1"}], ",", 
         RowBox[{"j", "\[LessEqual]", "ndim"}], ",", 
         RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "gset", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", 
           RowBox[{
            RowBox[{"g", "=", 
             SubscriptBox["gset", 
              RowBox[{
              "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               SubscriptBox["g", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"j", ",", "2"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               RowBox[{"{", 
                RowBox[{"open", ",", "open"}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"width", "=", 
                RowBox[{
                 SubscriptBox["g", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"j", ",", "1", ",", "2"}], 
                   "\[RightDoubleBracket]"}]], "-", 
                 SubscriptBox["g", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"j", ",", "1", ",", "1"}], 
                   "\[RightDoubleBracket]"}]]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  SubscriptBox["g", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "\[GreaterEqual]", "0"}], ",",
                  "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"EvenQ", "[", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "/", "width"}], "]"}], 
                    "\[And]", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"g2u", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "-", "width"}], ",", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "+", "width"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], "]"}], 
                    "]"}], "\[Equal]", "1"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"g1", "=", 
                    RowBox[{"Insert", "[", 
                    RowBox[{
                    RowBox[{"Delete", "[", 
                    RowBox[{"g", ",", "j"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], ",", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"closed", ",", "closed"}], "}"}]}], "}"}], ",", 
                    "j"}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"g2", "=", 
                    RowBox[{"Insert", "[", 
                    RowBox[{
                    RowBox[{"Delete", "[", 
                    RowBox[{"g", ",", "j"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "+", "width"}], ",", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "+", "width"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", "j"}],
                     "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"gset", ",", "g1"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"gset", ",", "g2"}], "]"}]}], ",", 
                    RowBox[{"gset", "=", 
                    RowBox[{
                    RowBox[{"Complement", "[", 
                    RowBox[{"gset", ",", 
                    RowBox[{"{", 
                    RowBox[{"g", ",", "g1", ",", "g2"}], "}"}]}], "]"}], 
                    "\[Union]", 
                    RowBox[{"{", 
                    RowBox[{"Insert", "[", 
                    RowBox[{
                    RowBox[{"Delete", "[", 
                    RowBox[{"g", ",", "j"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], ",", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "+", "width"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", "j"}],
                     "]"}], "}"}]}]}]}], "]"}]}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"EvenQ", "[", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "/", "width"}], "]"}], 
                    "\[And]", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"g2u", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "-", "width"}], ",", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "+", "width"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], "]"}], 
                    "]"}], "\[Equal]", "1"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"g1", "=", 
                    RowBox[{"Insert", "[", 
                    RowBox[{
                    RowBox[{"Delete", "[", 
                    RowBox[{"g", ",", "j"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], ",", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"closed", ",", "closed"}], "}"}]}], "}"}], ",", 
                    "j"}], "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"g2", "=", 
                    RowBox[{"Insert", "[", 
                    RowBox[{
                    RowBox[{"Delete", "[", 
                    RowBox[{"g", ",", "j"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "-", "width"}], ",", 
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], "-", "width"}]}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", "j"}],
                     "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"gset", ",", "g1"}], "]"}], "&&", 
                    RowBox[{"MemberQ", "[", 
                    RowBox[{"gset", ",", "g2"}], "]"}]}], ",", 
                    RowBox[{"gset", "=", 
                    RowBox[{
                    RowBox[{"Complement", "[", 
                    RowBox[{"gset", ",", 
                    RowBox[{"{", 
                    RowBox[{"g", ",", "g1", ",", "g2"}], "}"}]}], "]"}], 
                    "\[Union]", 
                    RowBox[{"{", 
                    RowBox[{"Insert", "[", 
                    RowBox[{
                    RowBox[{"Delete", "[", 
                    RowBox[{"g", ",", "j"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "1"}], 
                    "\[RightDoubleBracket]"}]], "-", "width"}], ",", 
                    SubscriptBox["g", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"open", ",", "open"}], "}"}]}], "}"}], ",", "j"}],
                     "]"}], "}"}]}]}]}], "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "]"}]}]}], "]"}]}]}], "]"}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         SubscriptBox[
          RowBox[{"g2u", "[", 
           SubscriptBox["gset", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]], "]"}], 
          RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "gset", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", "ndim"}], "}"}]}], "]"}]}]}], "]"}]}], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "Make", " ", "multiple", " ", "passes", " ", "at", " ", "a", " ", 
        "set", " ", "of", " ", "2"}], "-", 
       RowBox[{
       "dimensional", " ", "uboxes", " ", "to", " ", "coalesce", " ", 
        "subsets", " ", "that", " ", "form", " ", "a", " ", "coarser", " ", 
        "single", " ", "ULP"}], "-", 
       RowBox[{"wide", " ", "unum"}]}], ",", " ", 
      RowBox[{
      "until", " ", "all", " ", "possible", " ", "coalescing", " ", "is", " ", 
       RowBox[{"done", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"coalesce", "[", "set_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"newset", "=", "set"}], "}"}], ",", 
      RowBox[{
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"coalescepass", "[", "newset", "]"}], "\[NotEqual]", 
          "newset"}], ",", 
         RowBox[{"newset", "=", 
          RowBox[{"coalescepass", "[", "newset", "]"}]}]}], "]"}], ";", 
       "newset"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "Add", " ", "a", " ", "ubound", " ", "or", " ", "unum", " ", "to", " ",
         "a", " ", "1"}], "-", 
       RowBox[{"dimensional", " ", "set", " ", "of", " ", "ubounds"}]}], ",", 
      " ", 
      RowBox[{"coalescing", " ", "if", " ", 
       RowBox[{"possible", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"coalesce1D", "[", 
     RowBox[{"ubset_List", ",", 
      RowBox[{"ub_", "/;", 
       RowBox[{"uQ", "[", "ub", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"newset", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"ut", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"uboundQ", "[", "ub", "]"}], ",", "ub", ",", 
           RowBox[{"{", "ub", "}"}]}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"ubset", "\[Equal]", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"{", "ub", "}"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "First", " ", "look", " ", "for", " ", "any", " ", "overlapping", 
            " ", "or", " ", "touching", " ", "ubounds"}], ",", " ", 
           RowBox[{"and", " ", "merge", " ", "them", " ", "with", " ", 
            RowBox[{"ut", ".", " ", "If"}], " ", "disjoint"}], ",", " ", 
           RowBox[{"append", " ", "to", " ", 
            RowBox[{"newset", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], 
        StyleBox["\[IndentingNewLine]",
         FontColor->GrayLevel[0.5]], 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "ubset", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               SubscriptBox["ubset", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "\[TildeTilde]", "ut"}], "\[Or]", 
              RowBox[{
               RowBox[{"nborlo", "[", 
                RowBox[{
                 SubscriptBox["ubset", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                 RowBox[{"-", "\[Infinity]"}]}], "]"}], "\[TildeTilde]", 
               "ut"}], "\[Or]", 
              RowBox[{
               RowBox[{"nborhi", "[", 
                RowBox[{
                 SubscriptBox["ubset", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"i", ",", 
                    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]], ",", 
                 RowBox[{"-", "\[Infinity]"}]}], "]"}], "\[TildeTilde]", 
               "ut"}]}], ",", 
             RowBox[{"ut", "=", 
              RowBox[{"{", 
               RowBox[{
                SubscriptBox[
                 RowBox[{"(", 
                  RowBox[{"minub", "[", 
                   RowBox[{
                    SubscriptBox["ubset", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                    ",", "ut"}], "]"}], ")"}], 
                 RowBox[{
                 "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], ",", 
                SubscriptBox[
                 RowBox[{"(", 
                  RowBox[{"maxub", "[", 
                   RowBox[{
                    SubscriptBox["ubset", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                    ",", "ut"}], "]"}], ")"}], 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}], "}"}]}], 
             ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"newset", ",", 
               SubscriptBox["ubset", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], 
              "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"newset", ",", "ut"}], "]"}], ";", "newset"}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Find", " ", "the", " ", "real"}], "-", 
      RowBox[{"valued", " ", "bounds", " ", "of", " ", "a", " ", "2"}], "-", 
      RowBox[{"dimensional", " ", 
       RowBox[{"ubox", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"boxbound2D", "[", 
     RowBox[{
      RowBox[{"xub_", "/;", 
       RowBox[{"uboundQ", "[", "xub", "]"}]}], ",", "minpowerx_", ",", 
      RowBox[{"yub_", "/;", 
       RowBox[{"uboundQ", "[", "yub", "]"}]}], ",", "minpowery_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"list", ",", "left", ",", "right", ",", "bottom", ",", "top"}],
        "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"list", "=", 
        RowBox[{"uboxlist", "[", 
         RowBox[{"yub", ",", "minpowery"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"left", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox["xub", 
             RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
            ",", 
            SubscriptBox["list", 
             RowBox[{
             "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], "}"}],
           ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"right", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox["xub", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], ",", 
            SubscriptBox["list", 
             RowBox[{
             "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], "}"}],
           ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"list", "=", 
        RowBox[{"uboxlist", "[", 
         RowBox[{"xub", ",", "minpowerx"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"bottom", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox["list", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            ",", 
            SubscriptBox["yub", 
             RowBox[{
             "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], "}"}],
           ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"top", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox["list", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            ",", 
            SubscriptBox["yub", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "list", "]"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
       "left", "\[Union]", "right", "\[Union]", "bottom", "\[Union]", 
        "top"}]}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Find", " ", "the", " ", "minimum", " ", "of", " ", "two", " ", 
       "endpoints"}], ",", " ", 
      RowBox[{
       RowBox[{"considering", " ", "open"}], "-", 
       RowBox[{"closed", " ", 
        RowBox[{"state", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"minub", "[", 
     RowBox[{
      RowBox[{"xub_", "/;", 
       RowBox[{"uboundQ", "[", "xub", "]"}]}], ",", 
      RowBox[{"yub_", "/;", 
       RowBox[{"uboundQ", "[", "yub", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xg", "=", 
         RowBox[{"u2g", "[", "xub", "]"}]}], ",", 
        RowBox[{"yg", "=", 
         RowBox[{"u2g", "[", "yub", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["xg", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", 
          SubscriptBox["yg", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SubscriptBox["xg", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
            SubscriptBox["yg", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "\[And]", 
           RowBox[{"\[Not]", 
            SubscriptBox["xg", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], 
          ")"}]}], ",", "xub", ",", "yub"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Find", " ", "the", " ", "maximum", " ", "of", " ", "two", " ", 
       "endpoints"}], ",", " ", 
      RowBox[{
       RowBox[{"considering", " ", "open"}], "-", 
       RowBox[{"closed", " ", 
        RowBox[{"state", "."}]}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"maxub", "[", 
     RowBox[{
      RowBox[{"xub_", "/;", 
       RowBox[{"uboundQ", "[", "xub", "]"}]}], ",", 
      RowBox[{"yub_", "/;", 
       RowBox[{"uboundQ", "[", "yub", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xg", "=", 
         RowBox[{"u2g", "[", "xub", "]"}]}], ",", 
        RowBox[{"yg", "=", 
         RowBox[{"u2g", "[", "yub", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["xg", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ">", 
          SubscriptBox["yg", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SubscriptBox["xg", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
            SubscriptBox["yg", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[And]", 
           RowBox[{"\[Not]", 
            SubscriptBox["xg", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
          ")"}]}], ",", "xub", ",", "yub"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Find", " ", "the", " ", "neighbors"}], ",", " ", 
      RowBox[{"in", " ", "all", " ", "dimensions"}], ",", " ", 
      RowBox[{"of", " ", "a", " ", 
       RowBox[{"unum", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"findnbors", "[", 
     RowBox[{"set_", ",", "minpowers_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "nbors", ",", "s", ",", 
        RowBox[{"tempset", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "set", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"s", "=", 
           SubscriptBox["set", 
            RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"tempset", "=", 
           RowBox[{"Union", "[", 
            RowBox[{"tempset", ",", 
             RowBox[{"Tuples", "[", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"nborlo", "[", 
                   RowBox[{
                    SubscriptBox["s", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    ",", 
                    SubscriptBox["minpowers", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]]}],
                    "]"}], ",", 
                  SubscriptBox["s", 
                   RowBox[{
                   "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                  ",", 
                  RowBox[{"nborhi", "[", 
                   RowBox[{
                    SubscriptBox["s", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    ",", 
                    SubscriptBox["minpowers", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]]}],
                    "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "1", ",", 
                  RowBox[{"Length", "[", "s", "]"}]}], "}"}]}], "]"}], 
              "]"}]}], "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Complement", "[", 
        RowBox[{"tempset", ",", "set"}], "]"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Find", " ", "the", " ", "real", " ", "value", " ", "of", " ", "the", 
      " ", "width", " ", "of", " ", "a", " ", "unum", " ", "or", " ", 
      RowBox[{"ubound", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"width", "[", 
     RowBox[{"u_", "/;", 
      RowBox[{
       RowBox[{"unumQ", "[", "u", "]"}], "\[Or]", 
       RowBox[{"uboundQ", "[", "u", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"glo", ",", "ghi"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"glo", ",", "ghi"}], "}"}], "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"unumQ", "[", "u", "]"}], ",", 
          SubscriptBox[
           RowBox[{"u2g", "[", "u", "]"}], 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          ",", " ", 
          SubscriptBox[
           RowBox[{"u2g", "[", "u", "]"}], 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ghi", "-", "glo"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"Find", " ", "the", " ", "total", " ", "n"}], "-", 
      RowBox[{
      "dimensional", " ", "volume", " ", "of", " ", "a", " ", "ubox", " ", 
       RowBox[{"set", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"volume", "[", "set_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"n", "=", 
         RowBox[{"Length", "[", "set", "]"}]}], ",", 
        RowBox[{"ndim", "=", 
         RowBox[{"Length", "[", 
          SubscriptBox["set", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       UnderoverscriptBox["\[Sum]", 
        RowBox[{"i", "=", "1"}], "n"], 
       RowBox[{
        UnderoverscriptBox["\[Product]", 
         RowBox[{"j", "=", "1"}], "ndim"], 
        RowBox[{"width", "[", 
         SubscriptBox["set", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]], "]"}]}]}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Create", " ", "a", " ", "set", " ", "of", " ", "uboxes", " ", 
      "describing", " ", "the", " ", "rectangular", " ", "bound", " ", 
      "around", " ", "a", " ", "given", " ", 
      RowBox[{"ubox", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"spacestepbounds", "[", 
     RowBox[{"ubox_", ",", "r_"}], "]"}], ":=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        OverscriptBox[
         SubscriptBox[
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"u2g", "[", 
             RowBox[{
              RowBox[{"{", 
               SubscriptBox["ubox", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "}"}], "\[CircleMinus]", 
              RowBox[{"{", 
               OverscriptBox["r", "^"], "}"}]}], "]"}], "+", 
            RowBox[{"smallsubnormal", "/", "2"}]}], ")"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "^"], ",", 
        OverscriptBox[
         SubscriptBox[
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"u2g", "[", 
             RowBox[{
              RowBox[{"{", 
               SubscriptBox["ubox", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "}"}], "\[CirclePlus]", 
              RowBox[{"{", 
               OverscriptBox["r", "^"], "}"}]}], "]"}], "-", 
            RowBox[{"smallsubnormal", "/", "2"}]}], ")"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "^"]}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "ubox", "]"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Create", " ", "the", " ", "set", " ", "of", " ", "all", " ", "uboxes", 
      " ", "inside", " ", "a", " ", 
      RowBox[{"bound", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"spacestep", "[", 
     RowBox[{"ubox_", ",", "r_", ",", "minpower_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"bounds", "=", 
        RowBox[{"spacestepbounds", "[", 
         RowBox[{"ubox", ",", "r"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Tuples", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         SubscriptBox[
          RowBox[{"uboxlist", "[", 
           RowBox[{
            SubscriptBox["bounds", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            ",", "minpower"}], "]"}], 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ";;", 
            RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "bounds", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Check", " ", "a", " ", "ubound", " ", "for", " ", "intersection", " ", 
      "with", " ", "a", " ", 
      StyleBox["set",
       FontSlant->"Italic"], " ", "of", " ", "other", " ", 
      RowBox[{"ubounds", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"setintersectQ", "[", 
     RowBox[{"ub_", ",", "set_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"intQ", "=", "False"}], ",", 
        RowBox[{"ndim", "=", 
         RowBox[{"Length", "[", "ub", "]"}]}], ",", "n"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "set", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{
          RowBox[{"n", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", "ndim"}], ",", 
             RowBox[{"j", "++"}], ",", 
             RowBox[{"n", "+=", 
              RowBox[{"Boole", "[", 
               RowBox[{
                RowBox[{"{", 
                 SubscriptBox["ub", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                 "}"}], "\[TildeTilde]", 
                RowBox[{"{", 
                 SubscriptBox["set", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]], 
                 "}"}]}], "]"}]}]}], "]"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"n", "\[Equal]", "ndim"}], ",", 
             RowBox[{"intQ", "=", "True"}]}], "]"}]}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", "intQ"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Check", " ", "a", " ", "general", " ", "interval", " ", "for", " ", 
      "intersection", " ", "with", " ", "a", " ", 
      StyleBox["set",
       FontSlant->"Italic"], " ", "of", " ", "other", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"gsetintersectQ", "[", 
     RowBox[{"gs_", ",", "gset_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"intQ", "=", "False"}], ",", "n", ",", 
        RowBox[{"ndim", "=", 
         RowBox[{"Length", "[", "gs", "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "gset", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{
          RowBox[{"n", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", "ndim"}], ",", 
            RowBox[{"j", "++"}], ",", 
            RowBox[{"n", "+=", 
             RowBox[{"Boole", "[", 
              RowBox[{"nneqgQ", "[", 
               RowBox[{
                SubscriptBox["gs", 
                 RowBox[{
                 "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], ",", 
                SubscriptBox["gset", 
                 RowBox[{"\[LeftDoubleBracket]", 
                  RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]]}], 
               "]"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"n", "\[Equal]", "ndim"}], ",", 
            RowBox[{"intQ", "=", "True"}]}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", "intQ"}]}], "]"}]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Remove", " ", "interior", " ", "points", " ", "from", " ", "a", " ", 
       "set", " ", "of", " ", "uboxes"}], ",", " ", 
      RowBox[{"leaving", " ", "the", " ", "boundary", " ", 
       RowBox[{"only", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hollowout", "[", "set_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"gnbors", ",", "gset", ",", "i", ",", "j", ",", 
        RowBox[{"n", "=", 
         RowBox[{"Length", "[", "set", "]"}]}], ",", 
        RowBox[{"ndim", "=", 
         RowBox[{"Length", "[", 
          SubscriptBox["set", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          "]"}]}], ",", "nbors", ",", "nnbors", ",", 
        RowBox[{"boundary", "=", 
         RowBox[{"{", "}"}]}], ",", "ub"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"gset", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"u2g", "[", 
           SubscriptBox["set", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]], "]"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "n"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", "ndim"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", "n"}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ub", "=", 
           SubscriptBox["set", 
            RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"nbors", "=", 
           RowBox[{"findnbors", "[", 
            RowBox[{
             RowBox[{"{", "ub", "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", "ndim", "}"}]}], "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"nnbors", "=", 
           RowBox[{"Length", "[", "nbors", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"gnbors", "=", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"u2g", "[", 
              SubscriptBox["nbors", 
               RowBox[{"\[LeftDoubleBracket]", 
                RowBox[{"i", ",", "j"}], "\[RightDoubleBracket]"}]], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "nnbors"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "ndim"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"j", "=", "1"}], ";", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"j", "\[LessEqual]", "nnbors"}], "\[And]", 
             RowBox[{"gsetintersectQ", "[", 
              RowBox[{
               SubscriptBox["gnbors", 
                RowBox[{
                "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], ",", 
               "gset"}], "]"}]}], ",", 
            RowBox[{"j", "++"}]}], "]"}], ";", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"j", "<", "nnbors"}], ",", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"boundary", ",", 
              RowBox[{"{", "ub", "}"}]}], "]"}]}], "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", "boundary"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Check", " ", "if", " ", "an", " ", "argument", " ", "is", " ", "a", " ",
       "list", " ", "of", " ", "general", " ", 
      RowBox[{"intervals", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"glistQ", "[", "g_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"q", "=", "True"}], "}"}], ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Head", "[", "g", "]"}], "\[Equal]", "List"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "g", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"\[Not]", 
              RowBox[{"gQ", "[", 
               SubscriptBox["g", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "]"}]}], ",", 
             RowBox[{"q", "=", "False"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"q", "=", "False"}]}], "]"}], ";", "q"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Check", " ", "if", " ", "a", " ", "list", " ", "of", " ", "general", 
      " ", "intervals", " ", "contains", " ", "a", " ", "NaN", " ", 
      RowBox[{"anywhere", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\n", 
   RowBox[{
    RowBox[{"glistNaNQ", "[", "g_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"q", "=", "False"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"1", 
           RowBox[{"Length", "[", "g", "]"}]}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["g", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"i", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}]], 
             "===", "NaN"}], "\[Or]", 
            RowBox[{
             SubscriptBox["g", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"i", ",", "1", ",", "2"}], "\[RightDoubleBracket]"}]], 
             "===", "NaN"}]}], ",", 
           RowBox[{"q", "=", "True"}]}], "]"}]}], "]"}], ";", "q"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Check", " ", "if", " ", "an", " ", "argument", " ", "is", " ", "a", " ",
       "list", " ", "of", " ", "unums", " ", "or", " ", 
      RowBox[{"ubounds", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ulistQ", "[", "u_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"q", "=", "True"}]}], "}"}], ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Head", "[", "u", "]"}], "\[Equal]", "List"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", "u", "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"\[Not]", 
              RowBox[{"uQ", "[", 
               SubscriptBox["u", 
                RowBox[{
                "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
               "]"}]}], ",", 
             RowBox[{"q", "=", "False"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"q", "=", "False"}]}], "]"}], ";", "q"}]}], "]"}]}], "\n", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Check", " ", "if", " ", "a", " ", "list", " ", "of", " ", "unums", " ",
        "or", " ", "ubounds", " ", "contains", " ", "a", " ", "NaN", " ", 
       RowBox[{"anywhere", ".", " ", "In"}], " ", "the", " ", "prototype"}], 
      ",", " ", 
      RowBox[{
      "signalling", " ", "NaN", " ", "is", " ", "tested", " ", "for"}], ",", 
      " ", 
      RowBox[{
      "but", " ", "in", " ", "a", " ", "real", " ", "environment", " ", 
       "would", " ", "halt", " ", "the", " ", 
       RowBox[{"calculation", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ulistNaNQ", "[", "u_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"q", "=", "False"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"1", 
           RowBox[{"Length", "[", "u", "]"}]}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["u", 
              RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]],
              "\[Equal]", "qNaNu"}], "\[Or]", 
            RowBox[{
             SubscriptBox["u", 
              RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]],
              "\[Equal]", "sNaNu"}]}], ",", 
           RowBox[{"q", "=", "True"}]}], "]"}]}], "]"}], ";", "q"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Polynomial", " ", "helper", " ", "function", " ", "that", " ", "uses", 
       " ", "powers", " ", "of", " ", "x"}], " ", "-", " ", 
      RowBox[{"x0", " ", "instead", " ", "of", " ", 
       RowBox[{"x", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"polyTg", "[", 
     RowBox[{"coeffsg_", ",", "xg_", ",", "x0g_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"bi", ",", "i", ",", "j", ",", 
        RowBox[{"k", "=", 
         RowBox[{"Length", "[", "coeffsg", "]"}]}], ",", 
        RowBox[{"coeffstg", "=", "coeffsg"}], ",", "pg", ",", "xmg"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["x0g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
          RowBox[{"-", "\[Infinity]"}]}], "\[Or]", 
         RowBox[{
          SubscriptBox["x0g", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
          "\[Infinity]"}]}], ",", GridBox[{
          {
           RowBox[{"-", "\[Infinity]"}], "\[Infinity]"},
          {"closed", "closed"}
         }], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "0"}], ",", 
           RowBox[{"j", "\[LessEqual]", 
            RowBox[{"k", "-", "1"}]}], ",", 
           RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"bi", "=", 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"k", "-", "1"}], ",", "j"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"pg", "=", 
             RowBox[{"timesg", "[", 
              RowBox[{
               SubscriptBox["coeffsg", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], " ", ",", 
               GridBox[{
                 {"bi", "bi"},
                 {"closed", "closed"}
                }]}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"i", "=", 
               RowBox[{"k", "-", "2"}]}], ",", 
              RowBox[{"i", "\[GreaterEqual]", "j"}], ",", 
              RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"bi", "=", 
                RowBox[{"Binomial", "[", 
                 RowBox[{"i", ",", "j"}], "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"pg", "=", 
                RowBox[{"plusg", "[", 
                 RowBox[{
                  RowBox[{"timesg", "[", 
                   RowBox[{
                    SubscriptBox["coeffsg", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"i", "+", "1"}], "\[RightDoubleBracket]"}]], ",", 
                    GridBox[{
                    {"bi", "bi"},
                    {"closed", "closed"}
                    }]}], "]"}], ",", 
                  RowBox[{"timesg", "[", 
                   RowBox[{"x0g", ",", "pg"}], "]"}]}], "]"}]}]}]}], "]"}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{
             SubscriptBox["coeffstg", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"j", "+", "1"}], "\[RightDoubleBracket]"}]], "=", 
             "pg"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"xmg", "=", 
          RowBox[{"minusg", "[", 
           RowBox[{"xg", ",", "x0g"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"pg", "=", 
          SubscriptBox["coeffstg", 
           RowBox[{"\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", 
            RowBox[{"k", "-", "1"}]}], ",", 
           RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
           RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
           RowBox[{"pg", "=", 
            RowBox[{"plusg", "[", 
             RowBox[{
              RowBox[{"timesg", "[", 
               RowBox[{"pg", ",", "xmg"}], "]"}], ",", 
              SubscriptBox["coeffstg", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", "pg"}]}], "]"}]}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Polynomial", " ", "helper", " ", "function", " ", "that", " ", 
       "evaluates", " ", "a", " ", "polynomial", " ", "at", " ", "the", " ", 
       "endpoints", " ", "of", " ", "an", " ", "inexact", " ", "unum"}], ",", 
      " ", 
      RowBox[{
      "and", " ", "intersects", " ", "them", " ", "to", " ", "tighten", " ", 
       "the", " ", 
       RowBox[{"result", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"polyinexactg", "[", 
     RowBox[{"coeffsg_", ",", "xg_"}], "]"}], ":=", 
    RowBox[{"intersectg", "[", 
     RowBox[{
      RowBox[{"polyTg", "[", 
       RowBox[{"coeffsg", ",", "xg", ",", GridBox[{
          {
           SubscriptBox["xg", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
           SubscriptBox["xg", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]},
          {"closed", "closed"}
         }]}], "]"}], ",", 
      RowBox[{"polyTg", "[", 
       RowBox[{"coeffsg", ",", "xg", ",", GridBox[{
          {
           SubscriptBox["xg", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
           SubscriptBox["xg", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]},
          {"closed", "closed"}
         }]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Polynomial", " ", "evaluation", " ", "of", " ", "an", " ", "exact", 
       " ", "general", " ", "interval"}], ",", " ", 
      RowBox[{"using", " ", 
       RowBox[{"Horner", "'"}], "s", " ", 
       RowBox[{"rule", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   RowBox[{
    RowBox[{"polyexactg", "[", 
     RowBox[{"coeffsg_", ",", "xg_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"k", "=", 
         RowBox[{"Length", "[", "coeffsg", "]"}]}], ",", 
        RowBox[{"pg", "=", 
         SubscriptBox["coeffsg", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"k", "-", "1"}]}], ",", 
         RowBox[{"i", "\[GreaterEqual]", "1"}], ",", 
         RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
         RowBox[{"pg", "=", 
          RowBox[{"plusg", "[", 
           RowBox[{
            SubscriptBox["coeffsg", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            ",", 
            RowBox[{"timesg", "[", 
             RowBox[{"pg", ",", "xg"}], "]"}]}], "]"}]}]}], "]"}], ";", 
       "pg"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Bisect", " ", "an", " ", "inexact", " ", "general", " ", "interval", 
       " ", "along", " ", "a", " ", "coarsest"}], "-", 
      RowBox[{"possible", " ", "ULP", " ", 
       RowBox[{"boundary", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], 
   StyleBox["\[IndentingNewLine]",
    FontColor->GrayLevel[0.5]], 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "The", " ", "last", " ", "subscript", " ", "on", " ", "the", " ", 
       "last", " ", "line", " ", 
       RowBox[{"was", " ", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}], " ", "and", " ", 
       "should", " ", "have", " ", 
       RowBox[{"been", " ", "\[LeftDoubleBracket]", 
        RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", " ", 
      RowBox[{
      "matching", " ", "the", " ", "code", " ", "shown", " ", "in", " ", 
       "the", " ", 
       RowBox[{"Appendix", ".", " ", "Thanks"}], " ", "to", " ", "Jeff", " ", 
       "Muizelaar", " ", "for", " ", "spotting", " ", "this", " ", "typo"}], 
      ",", " ", 
      RowBox[{"corrected", " ", "in", " ", "this", " ", "version", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"June", " ", "19"}], ",", " ", "2015"}], ")"}], "."}]}]}], 
     " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"bisect", "[", 
     RowBox[{"g_", "/;", 
      RowBox[{"gQ", "[", "g", "]"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"gL", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], ",", "gM", 
        ",", 
        RowBox[{"gR", "=", 
         SubscriptBox["g", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", "m"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"gM", "=", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"gL", "<", "0"}], "\[And]", 
           RowBox[{"gR", ">", "0"}]}], ",", "0", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"gL", "\[Equal]", 
            RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
           RowBox[{"gR", ">", 
            RowBox[{"-", "maxreal"}]}]}], ",", 
          RowBox[{"-", "maxreal"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"gL", "<", "maxreal"}], "\[And]", 
           RowBox[{"gR", "\[Equal]", "\[Infinity]"}]}], ",", "maxreal", ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"m", "=", 
            SuperscriptBox["2", 
             RowBox[{"\[LeftFloor]", 
              RowBox[{"Log", "[", 
               RowBox[{"2", ",", 
                RowBox[{"gR", "-", "gL"}]}], "]"}], "\[RightFloor]"}]]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"IntegerQ", "[", 
            RowBox[{"gL", "/", "m"}], "]"}]}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"gR", "-", "gL"}], "\[Equal]", "m"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"gL", "+", "gR"}], ")"}], "/", "2"}], ",", 
            RowBox[{"m", 
             RowBox[{"\[LeftFloor]", 
              RowBox[{
               RowBox[{"gL", "/", "m"}], "+", "1"}], "\[RightFloor]"}]}]}], 
           "]"}], ",", "\[IndentingNewLine]", "True", ",", 
          RowBox[{"m", 
           RowBox[{"\[LeftCeiling]", 
            RowBox[{"gL", "/", "m"}], "\[RightCeiling]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{GridBox[{
           {"gL", "gM"},
           {
            SubscriptBox["g", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], "open"}
          }], ",", GridBox[{
           {"gM", "gR"},
           {"open", 
            SubscriptBox["g", 
             RowBox[{"\[LeftDoubleBracket]", 
              RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}
          }]}], "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Polynomial", " ", "evaluation", " ", "of", " ", "a", " ", "general", 
       " ", "interval", " ", "without", " ", "u"}], "-", 
      RowBox[{"layer", " ", "information", " ", 
       RowBox[{"loss", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"polyg", "[", 
     RowBox[{
      RowBox[{"coeffsg_", "/;", 
       RowBox[{"glistQ", "[", "coeffsg", "]"}]}], ",", 
      RowBox[{"xg_", "/;", 
       RowBox[{"gQ", "[", "xg", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"gL", ",", "gR", ",", "gM", ",", 
        RowBox[{"k", "=", 
         RowBox[{"Length", "[", "coeffsg", "]"}]}], ",", "min", ",", "minQ", 
        ",", "max", ",", "maxQ", ",", "pg", ",", "trials"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       StyleBox[
        RowBox[{"(*", " ", 
         RowBox[{"Dispense", " ", "with", " ", "NaN", " ", 
          RowBox[{"cases", "."}]}], " ", "*)"}],
        FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["xg", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "===", 
          "NaN"}], "\[Or]", 
         RowBox[{
          SubscriptBox["xg", 
           RowBox[{"\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], "===", 
          "NaN"}], "\[Or]", 
         RowBox[{"glistNaNQ", "[", "coeffsg", "]"}]}], ",", GridBox[{
          {"NaN", "NaN"},
          {"open", "open"}
         }], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{"Constant", " ", 
           RowBox[{"case", ".", " ", "Just"}], " ", "return", " ", "the", " ",
            "first", " ", 
           RowBox[{"(", 
            RowBox[{"and", " ", "only"}], ")"}], " ", 
           RowBox[{"coefficient", "."}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{"k", "\[Equal]", "1"}], ",", 
        SubscriptBox["coeffsg", 
         RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], ",",
         "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{
            "Linear", " ", "case", " ", "is", " ", "a", " ", "fused", " ", 
             "multiply"}], "-", "add"}], ";", " ", 
           RowBox[{"no", " ", "dependency", " ", 
            RowBox[{"problem", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{"k", "\[Equal]", "2"}], ",", 
        RowBox[{"fmag", "[", 
         RowBox[{
          SubscriptBox["coeffsg", 
           RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
          ",", "xg", ",", 
          SubscriptBox["coeffsg", 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Exact", " ", "argument", " ", "is", " ", "also", " ", "easy"}], 
           ",", " ", 
           RowBox[{"since", " ", "no", " ", "dependency", " ", 
            RowBox[{"problem", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         SubscriptBox["xg", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "\[Equal]", 
         SubscriptBox["xg", 
          RowBox[{"\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], ",", 
        RowBox[{"polyexactg", "[", 
         RowBox[{"coeffsg", ",", "xg"}], "]"}], ",", "\[IndentingNewLine]", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "Quadratic", " ", "or", " ", "higher", " ", "requires", " ", 
            RowBox[{"finesse", ".", " ", "Intersect"}], " ", "tbe", " ", 
            "two", " ", "endpoint"}], "-", 
           RowBox[{"based", " ", 
            RowBox[{"evaluations", "."}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", "True", ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"trials", "=", 
          RowBox[{"{", "xg", "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"gL", "=", 
          RowBox[{"polyexactg", "[", 
           RowBox[{"coeffsg", ",", GridBox[{
              {
               SubscriptBox["xg", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               SubscriptBox["xg", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]},
              {"closed", "closed"}
             }]}], "]"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{
           SubscriptBox["xg", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
           RowBox[{
            SubscriptBox["gL", 
             RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
            "=", 
            RowBox[{"{", 
             RowBox[{"open", ",", "open"}], "}"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"gR", "=", 
          RowBox[{"polyexactg", "[", 
           RowBox[{"coeffsg", ",", GridBox[{
              {
               SubscriptBox["xg", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
               SubscriptBox["xg", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]},
              {"closed", "closed"}
             }]}], "]"}]}], ";", 
         RowBox[{"If", "[", 
          RowBox[{
           SubscriptBox["xg", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]], ",", 
           RowBox[{
            SubscriptBox["gR", 
             RowBox[{"\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]], 
            "=", 
            RowBox[{"{", 
             RowBox[{"open", ",", "open"}], "}"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["gL", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", 
             SubscriptBox["gR", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SubscriptBox["gL", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["gR", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]]}], 
              "\[And]", 
              RowBox[{"\[Not]", 
               SubscriptBox["gL", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}]}], 
             ")"}]}], ",", "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", "then", " ", "*)"}],
            FontColor->GrayLevel[0.5]], 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"min", ",", "minQ"}], "}"}], "=", 
            SubscriptBox[
             RowBox[{"Transpose", "[", "gL", "]"}], 
             RowBox[{
             "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], ",", 
           "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", "else", " ", "*)"}],
            FontColor->GrayLevel[0.5]], 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"min", ",", "minQ"}], "}"}], "=", 
            SubscriptBox[
             RowBox[{"Transpose", "[", "gR", "]"}], 
             RowBox[{
             "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}]}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             SubscriptBox["gL", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ">", 
             SubscriptBox["gR", 
              RowBox[{"\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], "\[Or]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SubscriptBox["gL", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
               "\[Equal]", 
               SubscriptBox["gR", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]]}], 
              "\[And]", 
              RowBox[{"\[Not]", 
               SubscriptBox["gL", 
                RowBox[{"\[LeftDoubleBracket]", 
                 RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}], 
             ")"}]}], ",", "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", "then", " ", "*)"}],
            FontColor->GrayLevel[0.5]], 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"max", ",", "maxQ"}], "}"}], "=", 
            SubscriptBox[
             RowBox[{"Transpose", "[", "gL", "]"}], 
             RowBox[{
             "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], ",", 
           "\[IndentingNewLine]", 
           StyleBox[
            RowBox[{"(*", " ", "else", " ", "*)"}],
            FontColor->GrayLevel[0.5]], 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"max", ",", "maxQ"}], "}"}], "=", 
            SubscriptBox[
             RowBox[{"Transpose", "[", "gR", "]"}], 
             RowBox[{
             "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}]}], 
          "]"}], ";", 
         StyleBox["\[IndentingNewLine]",
          FontWeight->"Plain"], 
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "trials", "]"}], "\[GreaterEqual]", "1"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"pg", "=", 
             RowBox[{"polyinexactg", "[", 
              RowBox[{"coeffsg", ",", 
               SubscriptBox["trials", 
                RowBox[{
                "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
              "]"}]}], ";", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"intersectg", "[", 
                RowBox[{
                 RowBox[{"u2g", "[", 
                  RowBox[{"g2u", "[", "pg", "]"}], "]"}], ",", 
                 RowBox[{"u2g", "[", 
                  RowBox[{"g2u", "[", GridBox[{
                    {"min", "max"},
                    {"minQ", "maxQ"}
                    }], "]"}], "]"}]}], "]"}], "===", 
               RowBox[{"u2g", "[", 
                RowBox[{"g2u", "[", "pg", "]"}], "]"}]}], ",", 
              RowBox[{"trials", "=", 
               RowBox[{"Rest", "[", "trials", "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"trials", "=", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"bisect", "[", 
                   SubscriptBox["trials", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                   "]"}], ",", 
                  RowBox[{"Rest", "[", "trials", "]"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"gM", "=", 
                RowBox[{"polyexactg", "[", 
                 RowBox[{"coeffsg", ",", GridBox[{
                    {
                    SubscriptBox["trials", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]], 
                    SubscriptBox["trials", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1", ",", "2"}], 
                    "\[RightDoubleBracket]"}]]},
                    {"closed", "closed"}
                   }]}], "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SubscriptBox["gM", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], "<", 
                   "min"}], "\[Or]", 
                  RowBox[{
                   RowBox[{
                    SubscriptBox["gM", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", "min"}], "\[And]", 
                   RowBox[{"\[Not]", 
                    SubscriptBox["gM", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "1"}], "\[RightDoubleBracket]"}]]}]}]}],
                  ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"min", ",", "minQ"}], "}"}], "=", 
                  SubscriptBox[
                   RowBox[{"Transpose", "[", "gM", "]"}], 
                   RowBox[{
                   "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}]]}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   SubscriptBox["gM", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], ">", 
                   "max"}], "\[Or]", 
                  RowBox[{
                   RowBox[{
                    SubscriptBox["gM", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]], 
                    "\[Equal]", "max"}], "\[And]", 
                   RowBox[{"\[Not]", 
                    SubscriptBox["gM", 
                    RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]]}]}]}],
                  ",", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"max", ",", "maxQ"}], "}"}], "=", 
                  SubscriptBox[
                   RowBox[{"Transpose", "[", "gM", "]"}], 
                   RowBox[{
                   "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]]}]}], "]"}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{GridBox[{
                  {"min", "max"},
                  {"minQ", "maxQ"}
                 }], "=", 
                RowBox[{"u2g", "[", 
                 RowBox[{"g2u", "[", GridBox[{
                    {"min", "max"},
                    {"minQ", "maxQ"}
                   }], "]"}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
          "]"}], ";", GridBox[{
           {"min", "max"},
           {"minQ", "maxQ"}
          }]}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Polynomial", " ", "evaluation", " ", "of", " ", "a", " ", "unum", " ", 
       "or", " ", "ubound", " ", "without", " ", "u"}], "-", 
      RowBox[{"layer", " ", "information", " ", 
       RowBox[{"loss", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"polyu", "[", 
     RowBox[{
      RowBox[{"coeffsu_", "/;", 
       RowBox[{"ulistQ", "[", "coeffsu", "]"}]}], ",", 
      RowBox[{"u_", "/;", 
       RowBox[{"uQ", "[", "u", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"coeffsg", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"u2g", "[", 
           SubscriptBox["coeffsu", 
            RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "coeffsu", "]"}]}], "}"}]}], "]"}]}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"g2u", "[", 
       RowBox[{"polyg", "[", 
        RowBox[{"coeffsg", ",", 
         RowBox[{"u2g", "[", "u", "]"}]}], "]"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "The", " ", "ubinsert", " ", "insertion", " ", "routine", " ", 
       "assumes", " ", "ubset", " ", "is", " ", "a", " ", "sorted", " ", 
       "set", " ", "of", " ", "disjoint", " ", "ubounds"}], ",", " ", 
      RowBox[{"and", " ", "has", " ", "no", " ", "NaN", " ", 
       RowBox[{"ubounds", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ubinsert", "[", 
     RowBox[{"ubset_", ",", 
      RowBox[{"ub_", "/;", 
       RowBox[{"uboundQ", "[", "ub", "]"}]}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "j", ",", 
        RowBox[{"k", "=", 
         RowBox[{"Length", "[", "ubset", "]"}]}], ",", 
        RowBox[{"lefttouch", "=", "False"}], ",", 
        RowBox[{"righttouch", "=", "False"}], ",", 
        RowBox[{"newset", "=", "ubset"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"k", "\[Equal]", "0"}], ",", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<   First element. \>\"", ",", 
            RowBox[{"{", " ", 
             RowBox[{"view", "[", "ub", "]"}], "}"}]}], "]"}], ";"}], "*)"}], 
        
        RowBox[{"{", "ub", "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"j", "=", "k"}], ";", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"j", ">", "0"}], "\[And]", 
             RowBox[{"gtuQ", "[", 
              RowBox[{
               SubscriptBox["newset", 
                RowBox[{
                "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], ",", 
               "ub"}], "]"}]}], ",", 
            RowBox[{"j", "--"}]}], "]"}], ";"}], 
         RowBox[{"(*", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<insertion point = \>\"", ",", "j"}], "]"}], "*)"}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"j", ">", "0"}], ",", 
           RowBox[{"lefttouch", "=", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"nborhi", "[", 
                RowBox[{
                 SubscriptBox["newset", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{"j", ",", 
                    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]], ",", 
                 RowBox[{"-", "\[Infinity]"}]}], "]"}], "}"}], 
              "\[TildeTilde]", "ub"}], ")"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"j", "<", "k"}], ",", 
           RowBox[{"righttouch", "=", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"nborlo", "[", 
                RowBox[{
                 SubscriptBox["newset", 
                  RowBox[{"\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{"j", "+", "1"}], ",", "1"}], 
                   "\[RightDoubleBracket]"}]], ",", 
                 RowBox[{"-", "\[Infinity]"}]}], "]"}], "}"}], 
              "\[TildeTilde]", "ub"}], ")"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"lefttouch", "\[And]", "righttouch"}], ",", 
           RowBox[{
            RowBox[{"newset", "=", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "k"}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  SubscriptBox["newset", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                  
                  SubscriptBox["newset", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"j", "+", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]]}], "}"}],
                 "}"}], ",", 
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   RowBox[{"j", "+", "1"}]}], "}"}]}], "]"}]}], "]"}]}], 
            ";"}], 
           RowBox[{"(*", 
            RowBox[{"Print", "[", "\"\<   Joined on both sides. \>\"", "]"}], 
            "*)"}], ",", "\[IndentingNewLine]", 
           RowBox[{"lefttouch", "\[And]", 
            RowBox[{"\[Not]", "righttouch"}]}], ",", 
           RowBox[{
            RowBox[{"newset", "=", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "k"}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  SubscriptBox["newset", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"j", ",", "1"}], "\[RightDoubleBracket]"}]], ",", 
                  
                  SubscriptBox["ub", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]]}], "}"}], 
                "}"}], ",", 
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "j"}], "}"}]}], "]"}]}], "]"}]}], ";"}], 
           RowBox[{"(*", 
            RowBox[{"Print", "[", "\"\<   Joined on left side. \>\"", "]"}], 
            "*)"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\[Not]", "lefttouch"}], "\[And]", "righttouch"}], ",", 
           RowBox[{
            RowBox[{"newset", "=", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"j", "+", "1"}], ",", "k"}], "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  SubscriptBox["ub", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], ",", 
                  SubscriptBox["newset", 
                   RowBox[{"\[LeftDoubleBracket]", 
                    RowBox[{
                    RowBox[{"j", "+", "1"}], ",", 
                    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]]}], "}"}],
                 "}"}], ",", 
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   RowBox[{"j", "+", "1"}]}], "}"}]}], "]"}]}], "]"}]}], 
            ";"}], 
           RowBox[{"(*", 
            RowBox[{"Print", "[", "\"\<   Joined on right side. \>\"", "]"}], 
            "*)"}], ",", "\[IndentingNewLine]", "True", ",", 
           RowBox[{
            RowBox[{"newset", "=", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"j", "+", "1"}], ">", "k"}], ",", "newset", ",", 
                 RowBox[{"Drop", "[", 
                  RowBox[{"newset", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"j", "+", "1"}], ",", "k"}], "}"}]}], "]"}]}], 
                "]"}], ",", 
               RowBox[{"{", "ub", "}"}], ",", 
               RowBox[{"Drop", "[", 
                RowBox[{"newset", ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "j"}], "}"}]}], "]"}]}], "]"}]}], ";"}]}], 
          RowBox[{"(*", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<   Inserted new ubound, not touching. \>\"", ",", "newset"}],
             "]"}], "*)"}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", "newset"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{"The", " ", "try"}], "-", 
      RowBox[{"everything", " ", 
       RowBox[{"solver", ".", " ", "Has"}], " ", "commented"}], "-", 
      RowBox[{
      "out", " ", "Print", " ", "statements", " ", "that", " ", "can", " ", 
       "be", " ", "uncommented", " ", "to", " ", "see", " ", "why", " ", 
       "long"}], "-", 
      RowBox[{
      "running", " ", "solvers", " ", "are", " ", "taking", " ", "too", " ", 
       RowBox[{"long", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"solveforub", "[", "domain_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "new", ",", 
        RowBox[{"sols", "=", 
         RowBox[{"{", "}"}]}], ",", "temp", ",", 
        RowBox[{"trials", "=", "domain"}], ",", "ub"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "trials", "]"}], ">", "0"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"new", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", "trials", "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", 
            RowBox[{
             RowBox[{"ub", "=", 
              SubscriptBox["trials", 
               RowBox[{
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"conditionQ", "[", "ub", "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"temp", "=", 
                  RowBox[{"splitub", "[", "ub", "]"}]}], ";"}], 
                "\[IndentingNewLine]", 
                StyleBox[
                 RowBox[{"(*", 
                  RowBox[{"Print", "[", 
                   RowBox[{"\"\<Splitting \>\"", ",", " ", 
                    RowBox[{"view", "[", "ub", "]"}], ",", "\"\< into \>\"", 
                    ",", 
                    RowBox[{"Table", "[", " ", 
                    RowBox[{
                    RowBox[{"view", "[", 
                    SubscriptBox["temp", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "temp", "]"}]}], "}"}]}], "]"}]}], 
                   "]"}], "*)"}],
                 FontColor->GrayLevel[0.5]], ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "temp", "]"}], "\[Equal]", "1"}], 
                  ",", " ", 
                  StyleBox[
                   RowBox[{"(*", " ", 
                    RowBox[{
                    RowBox[{"unsplittable", ".", " ", "Join"}], " ", "to", 
                    " ", "existing", " ", "region", " ", "or", " ", "start", 
                    " ", "new", " ", 
                    RowBox[{"one", "."}]}], " ", "*)"}],
                   FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
                  RowBox[{"sols", "=", 
                   RowBox[{"ubinsert", "[", 
                    RowBox[{"sols", ",", 
                    SubscriptBox["temp", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}],
                     "]"}]}], 
                  RowBox[{"(*", 
                   RowBox[{";", "\[IndentingNewLine]", 
                    RowBox[{"Print", "[", 
                    RowBox[{"\"\<Joined \>\"", ",", " ", 
                    RowBox[{"view", "[", "ub", "]"}], ",", 
                    "\"\< to sols: \>\"", ",", 
                    RowBox[{"Table", "[", " ", 
                    RowBox[{
                    RowBox[{"view", "[", 
                    SubscriptBox["sols", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "sols", "]"}]}], "}"}]}], "]"}]}], 
                    "]"}]}], "*)"}], ",", "\[IndentingNewLine]", 
                  StyleBox[
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Print", "[", 
                    RowBox[{"\"\<New split to examine: \>\"", ",", 
                    RowBox[{"Table", "[", " ", 
                    RowBox[{
                    RowBox[{"view", "[", 
                    SubscriptBox["temp", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "temp", "]"}]}], "}"}]}], "]"}]}], 
                    "]"}], ";"}], "*)"}],
                   FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"new", "=", 
                    RowBox[{"Join", "[", 
                    RowBox[{"temp", ",", "new"}], "]"}]}], ";"}], 
                   "\[IndentingNewLine]", 
                   StyleBox[
                    RowBox[{"(*", 
                    RowBox[{"Print", "[", 
                    RowBox[{"\"\<The 'new' list: \>\"", ",", 
                    RowBox[{"Table", "[", " ", 
                    RowBox[{
                    RowBox[{"view", "[", 
                    SubscriptBox["new", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "new", "]"}]}], "}"}]}], "]"}]}], 
                    "]"}], "*)"}],
                    FontColor->GrayLevel[0.5]], ";"}]}], 
                 "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
              "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"trials", "=", "new"}]}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", "sols"}]}], "]"}]}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
     "Acceleration", " ", "bound", " ", "that", " ", "avoids", " ", "the", 
      " ", "dependency", " ", "problem", " ", "between", " ", "numerator", 
      " ", "and", " ", 
      RowBox[{"denominator", "."}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"accub", "[", 
     RowBox[{"{", 
      RowBox[{"xub_", ",", "yub_"}], "}"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "i", ",", "j", ",", "x", ",", "y", ",", "a", ",", "b", ",", "s", ",", 
        RowBox[{"amin", "=", "\[Infinity]"}], ",", 
        RowBox[{"amax", "=", 
         RowBox[{"-", "\[Infinity]"}]}], ",", 
        RowBox[{"bmin", "=", "\[Infinity]"}], ",", 
        RowBox[{"bmax", "=", 
         RowBox[{"-", "\[Infinity]"}]}], ",", 
        RowBox[{"tests", "=", 
         RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           RowBox[{"u2g", "[", "xub", "]"}], 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
          ",", 
          SubscriptBox[
           RowBox[{"u2g", "[", "yub", "]"}], 
           RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
         "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tests", "=", 
        RowBox[{"Tuples", "[", 
         RowBox[{"{", 
          RowBox[{"x", ",", "y"}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", "2"}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "1"}], ",", 
           RowBox[{"j", "\[LessEqual]", "2"}], ",", 
           RowBox[{"j", "++"}], ",", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"s", "=", "1"}], ",", 
             RowBox[{"s", "\[GreaterEqual]", 
              RowBox[{"-", "1"}]}], ",", 
             RowBox[{"s", "-=", "2"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["x", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                 "<", 
                 RowBox[{"s", " ", 
                  RowBox[{
                   SubscriptBox["y", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                   "/", 
                   SqrtBox["2"]}]}], "<", 
                 SubscriptBox["x", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
                ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"tests", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"s", " ", 
                    RowBox[{
                    SubscriptBox["y", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    "/", 
                    SqrtBox["2"]}]}], ",", 
                    SubscriptBox["y", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]]}],
                    "}"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["y", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                 "<", 
                 RowBox[{"s", " ", 
                  RowBox[{
                   SubscriptBox["x", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                   "/", 
                   SqrtBox["2"]}]}], "<", 
                 SubscriptBox["y", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
                ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"tests", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    SubscriptBox["x", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                    ",", 
                    RowBox[{"s", " ", 
                    RowBox[{
                    SubscriptBox["x", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                    "/", 
                    SqrtBox["2"]}]}]}], "}"}]}], "]"}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["x", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                 "<", 
                 RowBox[{"s", " ", 
                  SubscriptBox["y", 
                   RowBox[{
                   "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                  SqrtBox["2"]}], "<", 
                 SubscriptBox["x", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
                ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"tests", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"s", " ", 
                    SubscriptBox["y", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], 
                    SqrtBox["2"]}], ",", 
                    SubscriptBox["y", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]]}],
                    "}"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["y", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
                 "<", 
                 RowBox[{"s", " ", 
                  SubscriptBox["x", 
                   RowBox[{
                   "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                  SqrtBox["2"]}], "<", 
                 SubscriptBox["y", 
                  RowBox[{
                  "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]]}], 
                ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"tests", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    SubscriptBox["x", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                    ",", 
                    RowBox[{"s", " ", 
                    SubscriptBox["x", 
                    RowBox[{
                    "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
                    SqrtBox["2"]}]}], "}"}]}], "]"}]}], "]"}]}]}], 
            "\[IndentingNewLine]", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "tests", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b"}], "}"}], "=", 
           RowBox[{"acc", "[", 
            SubscriptBox["tests", 
             RowBox[{"\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"amin", ",", "amax"}], "}"}], "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Min", "[", 
              RowBox[{"a", ",", "amin"}], "]"}], ",", 
             RowBox[{"Max", "[", 
              RowBox[{"a", ",", "amax"}], "]"}]}], "}"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"bmin", ",", "bmax"}], "}"}], "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Min", "[", 
              RowBox[{"b", ",", "bmin"}], "]"}], ",", 
             RowBox[{"Max", "[", 
              RowBox[{"b", ",", "bmax"}], "]"}]}], "}"}]}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"amin", "\[Equal]", "0"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["xub", 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "]"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["xub", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "]"}]}], ",", 
         RowBox[{"amin", "+=", 
          RowBox[{"smallsubnormal", "/", "2"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"bmin", "\[Equal]", "0"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["yub", 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "]"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["yub", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "]"}]}], ",", 
         RowBox[{"bmin", "+=", 
          RowBox[{"smallsubnormal", "/", "2"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"amax", "\[Equal]", "0"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["xub", 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "]"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["xub", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "]"}]}], ",", 
         RowBox[{"amax", "-=", 
          RowBox[{"smallsubnormal", "/", "2"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"bmax", "\[Equal]", "0"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["yub", 
            RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]], 
           "]"}], "\[And]", 
          RowBox[{"inexQ", "[", 
           SubscriptBox["yub", 
            RowBox[{"\[LeftDoubleBracket]", 
             RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]], "]"}]}], ",", 
         RowBox[{"bmax", "-=", 
          RowBox[{"smallsubnormal", "/", "2"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           OverscriptBox["amin", "^"], ",", 
           OverscriptBox["amax", "^"]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           OverscriptBox["bmin", "^"], ",", 
           OverscriptBox["bmax", "^"]}], "}"}]}], "}"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   StyleBox[
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
      "Turn", " ", "a", " ", "unum", " ", "into", " ", "a", " ", "guess"}], 
      ",", " ", 
      RowBox[{"for", " ", "imitation", " ", "of", " ", "float", " ", 
       RowBox[{"behavior", "."}]}]}], " ", "*)"}],
    FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"guessu", "[", 
     RowBox[{"x_", "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"uQ", "[", "x", "]"}], "\[Or]", 
        RowBox[{"gQ", "[", "x", "]"}]}], ")"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "g", ",", "gu"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "If", " ", "not", " ", "already", " ", "a", " ", "general", " ", 
          "interval", " ", "with", " ", "exact", " ", "endpoints"}], ",", " ", 
         RowBox[{"make", " ", "it", " ", 
          RowBox[{"one", "."}]}]}], " ", "*)"}],
       FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"g", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"uQ", "[", "x", "]"}], ",", 
          RowBox[{"u2g", "[", "x", "]"}], ",", 
          RowBox[{"u2g", "[", 
           RowBox[{"g2u", "[", "x", "]"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}], "=", 
        SubscriptBox["g", 
         RowBox[{"\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", " ", 
        StyleBox[
         RowBox[{"(*", " ", 
          RowBox[{"Take", " ", "care", " ", "of", " ", "trivial", " ", 
           RowBox[{"cases", ":", " ", 
            RowBox[{"NaN", " ", "or", " ", "an", " ", "exact", " ", 
             RowBox[{"interval", "."}]}]}]}], " ", "*)"}],
         FontColor->GrayLevel[0.5]], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"a", "===", "NaN"}], "\[Or]", 
          RowBox[{"b", "===", "NaN"}]}], ",", "qNaNu", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"a", "\[Equal]", "b"}], ",", 
         OverscriptBox["a", "^"], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"a", "\[Equal]", 
           RowBox[{"-", "\[Infinity]"}]}], "\[And]", 
          RowBox[{"b", "\[Equal]", "\[Infinity]"}]}], ",", 
         OverscriptBox["0", "^"], ",", "\[IndentingNewLine]", "True", ",", 
         StyleBox[
          RowBox[{"(*", " ", 
           RowBox[{
           "Average", " ", "the", " ", "endpoint", " ", "values", " ", "and", 
            " ", "convert", " ", "to", " ", "a", " ", 
            RowBox[{"unum", "."}]}], " ", "*)"}],
          FontColor->GrayLevel[0.5]], 
         StyleBox["\[IndentingNewLine]",
          FontColor->GrayLevel[0.5]], 
         RowBox[{
          RowBox[{"gu", "=", 
           OverscriptBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{"a", "+", "b"}], ")"}], "/", "2"}], "^"]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"exQ", "[", "gu", "]"}], ",", "gu", ",", 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"If", " ", "exact"}], ",", " ", 
               RowBox[{
                RowBox[{"we", "'"}], "re", " ", 
                RowBox[{"done", ".", " ", 
                 RowBox[{"That", "'"}]}], "s", " ", "the", " ", 
                RowBox[{"guess", "."}]}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], 
            StyleBox["\[IndentingNewLine]",
             FontColor->GrayLevel[0.5]], 
            StyleBox[
             RowBox[{"(*", " ", 
              RowBox[{"else", " ", "round", " ", "to", " ", "nearest", " ", 
               RowBox[{"even", "."}]}], " ", "*)"}],
             FontColor->GrayLevel[0.5]], 
            StyleBox["\[IndentingNewLine]",
             FontColor->GrayLevel[0.5]], 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"BitAnd", "[", 
                 RowBox[{"ulpu", ",", "gu"}], "]"}], "\[Equal]", "0"}], ",", 
               RowBox[{"gu", "=", 
                RowBox[{"gu", "-", "ubitmask"}]}], ",", 
               RowBox[{"gu", "=", 
                RowBox[{"gu", "+", "ubitmask"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             StyleBox[
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{
                "Compress", " ", "away", " ", "the", " ", "last", " ", "zero",
                  " ", "in", " ", "the", " ", "fraction"}], ",", " ", 
                RowBox[{"since", " ", "it", " ", "is", " ", 
                 RowBox[{"even", "."}]}]}], " ", "*)"}],
              FontColor->GrayLevel[0.5]], 
             StyleBox["\[IndentingNewLine]",
              FontColor->GrayLevel[0.5]], 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"fsize", "[", "gu", "]"}], "\[Equal]", "1"}], ",", 
               "gu", ",", 
               RowBox[{
                RowBox[{"BitShiftRight", "[", 
                 RowBox[{
                  RowBox[{"BitAnd", "[", 
                   RowBox[{
                    RowBox[{"floatmask", "[", "gu", "]"}], ",", "gu"}], "]"}],
                   ",", "1"}], "]"}], "+", 
                RowBox[{"BitAnd", "[", 
                 RowBox[{"efsizemask", ",", "gu"}], "]"}], "-", "1"}]}], 
              "]"}]}]}], "]"}]}]}], "]"}]}]}], "]"}]}]}]}]], "Input",
 CellMargins->{{49, Inherited}, {1, 1}},
 InitializationCell->True,
 CellChangeTimes->{{3.5976958099373293`*^9, 3.597695955767931*^9}, {
   3.597696833449402*^9, 3.5976968446299887`*^9}, {3.597697069473584*^9, 
   3.5976971589154243`*^9}, {3.597697224909829*^9, 3.597697279629113*^9}, {
   3.5976973103543777`*^9, 3.597697323625346*^9}, {3.597697362240232*^9, 
   3.597697398436123*^9}, {3.597697438265224*^9, 3.597697488774225*^9}, {
   3.597697603273212*^9, 3.597697605937132*^9}, {3.5976977025696487`*^9, 
   3.597697706026922*^9}, {3.59769792075701*^9, 3.597697937038663*^9}, {
   3.5977762627276278`*^9, 3.597776285928898*^9}, 3.597776359396861*^9, {
   3.597776417570751*^9, 3.597776432836018*^9}, {3.597776746640239*^9, 
   3.5977767507268476`*^9}, {3.598014571650226*^9, 3.598014590315401*^9}, {
   3.5994811967188473`*^9, 3.599481197132647*^9}, 3.5998517516562023`*^9, {
   3.600179277942041*^9, 3.600179482976729*^9}, 3.603320462101651*^9, {
   3.603411184855798*^9, 3.603411229406357*^9}, {3.603411399626895*^9, 
   3.603411407597744*^9}, {3.60341550464825*^9, 3.603415528838421*^9}, 
   3.604056276862027*^9, {3.6043261886335382`*^9, 3.6043261898426733`*^9}, 
   3.604336685212072*^9, {3.6044185866271553`*^9, 3.604418587988509*^9}, {
   3.604503482451619*^9, 3.604503483544044*^9}, {3.60450357326105*^9, 
   3.604503586958527*^9}, {3.604520655736071*^9, 3.604520656975197*^9}, {
   3.604591569842341*^9, 3.6045915755497017`*^9}, {3.6045918208542337`*^9, 
   3.60459184261489*^9}, {3.604666879674808*^9, 3.6046668805933533`*^9}, {
   3.6046855761451807`*^9, 3.604685645010165*^9}, {3.6046856867967157`*^9, 
   3.604685707328291*^9}, {3.60468585786488*^9, 3.604685861492653*^9}, {
   3.604686330385666*^9, 3.604686444263685*^9}, {3.6046865206445627`*^9, 
   3.604686532509901*^9}, {3.604686857206109*^9, 3.604686860054008*^9}, {
   3.604686896093343*^9, 3.604686907475502*^9}, {3.604686958887898*^9, 
   3.604686963612947*^9}, {3.604687131247023*^9, 3.604687135306019*^9}, {
   3.604751925750133*^9, 3.604751927178096*^9}, {3.6050108058279*^9, 
   3.605010808785841*^9}, {3.605045457342491*^9, 3.605045465224684*^9}, {
   3.605094590708828*^9, 3.605094592377616*^9}, {3.605095415223381*^9, 
   3.6050954160445147`*^9}, {3.605124324246029*^9, 3.605124325961299*^9}, {
   3.605124480488859*^9, 3.605124480874053*^9}, {3.605125457978444*^9, 
   3.605125460353622*^9}, {3.605187625146166*^9, 3.605187660252552*^9}, {
   3.605187842932446*^9, 3.605187895674843*^9}, {3.605368365454031*^9, 
   3.6053683726232767`*^9}, {3.6056541865264177`*^9, 3.60565418923637*^9}, 
   3.6056543397926407`*^9, {3.605654430433793*^9, 3.605654578755246*^9}, {
   3.605654752048513*^9, 3.605654816577523*^9}, {3.605654856087483*^9, 
   3.6056548613155622`*^9}, {3.605654894188671*^9, 3.605654909486768*^9}, {
   3.605654963911779*^9, 3.605654967899617*^9}, {3.605655228464868*^9, 
   3.605655232285729*^9}, {3.6057153768860693`*^9, 3.605715379049172*^9}, 
   3.605717009478923*^9, {3.605721150709525*^9, 3.6057211521362457`*^9}, {
   3.606503779489015*^9, 3.606503798173559*^9}, {3.6065038988928833`*^9, 
   3.606503932461443*^9}, {3.606566514571494*^9, 3.606566516686824*^9}, {
   3.606674593907366*^9, 3.6066745974230347`*^9}, {3.607189768766015*^9, 
   3.607189769910845*^9}, {3.6072680737946463`*^9, 3.607268075048189*^9}, {
   3.6073472993706913`*^9, 3.607347316542824*^9}, {3.607347350630279*^9, 
   3.60734736444543*^9}, {3.607380750298209*^9, 3.60738075224014*^9}, {
   3.607433169447605*^9, 3.607433183419607*^9}, {3.60745750152977*^9, 
   3.607457503047138*^9}, 3.607719534817171*^9, {3.607774916864558*^9, 
   3.607774935064733*^9}, {3.608125934118959*^9, 3.608125935482555*^9}, {
   3.608151636120832*^9, 3.608151636981532*^9}, {3.6081521402231007`*^9, 
   3.608152141533711*^9}, {3.608493497117399*^9, 3.608493574229596*^9}, {
   3.608493629029714*^9, 3.608493698303852*^9}, {3.608555113461837*^9, 
   3.60855511386449*^9}, {3.60865247097536*^9, 3.608652555591466*^9}, {
   3.608652639244137*^9, 3.6086527254145193`*^9}, {3.608652771505556*^9, 
   3.608652796190501*^9}, {3.608653064174271*^9, 3.608653066931101*^9}, 
   3.6086538136639357`*^9, {3.608654045320537*^9, 3.608654074424069*^9}, {
   3.609182880338707*^9, 3.6091829422978277`*^9}, {3.609246181900494*^9, 
   3.609246207659978*^9}, {3.60924629315694*^9, 3.609246294235076*^9}, 
   3.6092464507131357`*^9, {3.609246495277104*^9, 3.609246593162719*^9}, {
   3.609246847122067*^9, 3.609246871841473*^9}, {3.60924696828493*^9, 
   3.609246969277253*^9}, {3.609276034237473*^9, 3.6092760369285316`*^9}, {
   3.6092765718056803`*^9, 3.609276578373947*^9}, {3.6092766480419407`*^9, 
   3.6092766491481657`*^9}, 3.609282179778225*^9, {3.609506128249673*^9, 
   3.609506129416985*^9}, {3.609511364681108*^9, 3.609511371935772*^9}, 
   3.609511412456106*^9, {3.6095244159169416`*^9, 3.609524417253327*^9}, {
   3.609587297330311*^9, 3.609587320045684*^9}, {3.6095875165579023`*^9, 
   3.609587519216799*^9}, {3.6096351914808292`*^9, 3.609635192844522*^9}, {
   3.6096700764440928`*^9, 3.609670077746284*^9}, {3.609678628382758*^9, 
   3.609678630252602*^9}, {3.609705608201195*^9, 3.609705609113388*^9}, {
   3.6097643763663197`*^9, 3.60976438066451*^9}, {3.609889349756092*^9, 
   3.609889350210252*^9}, {3.609895018069322*^9, 3.6098950185471163`*^9}, {
   3.610017244917841*^9, 3.610017288645793*^9}, {3.61001761750414*^9, 
   3.610017618414611*^9}, {3.610019564015362*^9, 3.610019564956553*^9}, {
   3.614808352639247*^9, 3.614808353061212*^9}, 3.6148198990290747`*^9, {
   3.614875673740773*^9, 3.614875676530698*^9}, {3.6148757181333723`*^9, 
   3.614875722969026*^9}, 3.614878985119224*^9, {3.6148790547448997`*^9, 
   3.614879055455572*^9}, 3.61488273970864*^9, {3.614882859569977*^9, 
   3.614882860886859*^9}, 3.614882894664467*^9, 3.614882950852641*^9, {
   3.614883026654097*^9, 3.6148830351842937`*^9}, {3.614887740797943*^9, 
   3.614887743514019*^9}, {3.6149389188475323`*^9, 3.6149389527419252`*^9}, {
   3.615533966049438*^9, 3.615533967133569*^9}, {3.6162742866537733`*^9, 
   3.616274287236598*^9}, {3.616362991377479*^9, 3.616362992532712*^9}, {
   3.61645419410081*^9, 3.616454200534967*^9}, 3.6165115176597958`*^9, {
   3.616627091141384*^9, 3.616627091598083*^9}, {3.6166280552930613`*^9, 
   3.6166280620510178`*^9}, 3.616935753742484*^9, {3.61697654453377*^9, 
   3.616976545873095*^9}, {3.616976590966572*^9, 3.6169766164934597`*^9}, 
   3.616976702470334*^9, {3.6169767387057953`*^9, 3.616976871955429*^9}, {
   3.616976978693242*^9, 3.6169771214870863`*^9}, {3.616977196076816*^9, 
   3.616977204770501*^9}, {3.6169772778250504`*^9, 3.61697741228821*^9}, {
   3.616977504503986*^9, 3.6169776877132998`*^9}, {3.616977768461803*^9, 
   3.616977835594149*^9}, {3.616979276767221*^9, 3.616979769224681*^9}, {
   3.617006796146542*^9, 3.617006849339313*^9}, {3.6170068817497253`*^9, 
   3.6170069086834383`*^9}, {3.617006946138649*^9, 3.617007101824719*^9}, {
   3.6170640241565332`*^9, 3.617064025232169*^9}, {3.617120043044022*^9, 
   3.617120045552047*^9}, {3.617120115047872*^9, 3.617120194580267*^9}, {
   3.643709477472494*^9, 3.643709488624995*^9}, {3.6437095753252296`*^9, 
   3.643709708609337*^9}}]
},
ScreenStyleEnvironment->"Printout",
WindowSize->{1028, 1147},
WindowMargins->{{Automatic, 93}, {Automatic, 0}},
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{45, 46},
PageHeaders->{{None, 
   Cell[
    TextData[{
      StyleBox[
       CounterBox["Page"], "PageNumber"], 
      StyleBox["   ", "Header"], 
      StyleBox["|", "Header"], 
      StyleBox[" ", "Header"], 
      StyleBox[
       RowBox[{"The", " ", "End", " ", "of", " ", "Error"}], "Header"]}], 
    "Header"], None}, {None, 
   Cell[
    TextData[
     StyleBox[
      RowBox[{
        StyleBox["A", "Header"], 
        StyleBox[" ", "Header"], 
        StyleBox["New", "Header"], 
        StyleBox[" ", "Header"], "Number", " ", "Format", ":", " ", "The", 
        " ", "Unum", "  ", "|", "   ", 
        StyleBox[
         CounterBox["Page"], "PageNumber"]}], "Header"]], "Header"], None}},
PageFooters->{{None, None, None}, {None, None, None}},
PageHeaderLines->{False, False},
PageFooterLines->{False, False},
PrintingOptions->{"FacingPages"->True,
"FirstPageFace"->Right,
"FirstPageFooter"->True,
"FirstPageHeader"->False,
"PageFooterMargins"->{18, 18},
"PageHeaderMargins"->{30, 30},
"PageSize"->{504, 720},
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->True,
"PrintingMargins"->{{30, 30}, {55, 54}}},
ShowSelection->True,
Hyphenation->True,
HyphenationOptions->{"HyphenationMinLengths"->{5, 5}},
Magnification:>2. Inherited,
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 4, \
2014)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"], 
    CellMargins -> {{24, Inherited}, {Inherited, Inherited}}], 
   Cell[
    StyleData["Title"], CellMargins -> {{37, Inherited}, {10, 30}}, 
    FontFamily -> "Palatino", FontColor -> RGBColor[0.666667, 0, 0]], 
   Cell[
    StyleData["Subtitle"], CellMargins -> {{37, Inherited}, {20, 2}}, 
    FontFamily -> "Palatino"], 
   Cell[
    StyleData["Section"], CellMargins -> {{41, Inherited}, {8, 34}}, 
    TextJustification -> 0., FontFamily -> "Palatino", FontSize -> 24, 
    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
    RGBColor[0.666667, 0, 0]], 
   Cell[
    StyleData["Text"], CellMargins -> {{49, Inherited}, {7, 7}}], 
   Cell[
    StyleData["Subsection"], TextJustification -> 0., FontFamily -> 
    "Palatino", FontColor -> RGBColor[0.666667, 0, 0]], 
   Cell[
    StyleData["Subsubsection"], CellMargins -> {{49, Inherited}, {2, 10}}, 
    TextJustification -> 0., FontFamily -> "Palatino", FontSize -> 18, 
    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
    RGBColor[0.666667, 0, 0]], 
   Cell[
    StyleData["Program"], Evaluatable -> True, TextJustification -> 0., 
    FontWeight -> "Bold", Background -> RGBColor[0.88, 1, 0.88]]}, Visible -> 
  False, FrontEndVersion -> 
  "10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 4, 2014)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 407021, 10135, 37419, "Input",
 InitializationCell->True],
Cell[407581, 10157, 191625, 4736, 16991, "Input",
 InitializationCell->True]
}
]
*)

(* End of internal cache information *)
